#!/usr/bin/python3
# coding: utf-8

"""
HCE project, Python bindings, Distributed Tasks Manager application.
Verify of social data checker main functional.

@package: tools
@file cgi_etag.py
@author Maksym Masalov <maximmasalov888@gmail.com>
@link: http://hierarchical-cluster-engine.com/
@copyright: Copyright &copy; 2013-2017 IOIX Ukraine
@license: http://hierarchical-cluster-engine.com/license/
@since: 0.1
"""

import os
import io
import sys
import cgitb

cgitb.enable(display=1)
argv = sys.argv[1]


def html_page():

    if argv is '1':
        print('Content-Type: text/html')
        print('ETag: hash-123-noquotes')
        found_etag = 0
        for headername, headervalue in os.environ.items():
            if headername.startswith('HTTP_'):
                if str(headername) == 'HTTP_IF_NONE_MATCH' and str(headervalue) == 'hash-123-noquotes' and found_etag == 0:
                    found_etag += 1
                    print('Status: 304')
                    print('ETag: {}'.format(headervalue))
                    print('')
        if found_etag == 0:
            print('Status: 200')
            print('')
            print('<html>')
            print('<body>')
            print('<h1>ETag: hash-123-noquotes</h1>')
            print('</body>')
            print('</html>')

    if argv is '2':
        print('Content-Type: text/html')
        print('ETag: "hash-123"')
        found_etag = 0
        for headername, headervalue in os.environ.items():
            if headername.startswith('HTTP_'):
                if str(headername) == 'HTTP_IF_NONE_MATCH' and str(headervalue) == '"hash-123"' and found_etag == 0:
                    found_etag += 1
                    print('Status: 304')
                    print('ETag: {}'.format(headervalue))
                    print('')
        if found_etag == 0:
            print('Status: 200')
            print('')
            print('<html>')
            print('<body>')
            print('<h1>ETag: hash-123</h1>')
            print('</body>')
            print('</html>')

    if argv is '3':
        print('Content-Type: text/html')
        print('ETag: "hash-123-gzip"')
        found_etag = 0
        for headername, headervalue in os.environ.items():
            if headername.startswith('HTTP_'):
                if str(headername) == 'HTTP_IF_NONE_MATCH' and str(headervalue) == '"hash-123"' and found_etag == 0:
                    found_etag += 1
                    print('Status: 304')
                    print('ETag: {}'.format(headervalue))
                    print('')
        if found_etag == 0:
            print('Status: 200')
            print('')
            print('<html>')
            print('<body>')
            print('<h1>ETag: "hash-123-gzip"</h1>')
            print('</body>')
            print('</html>')

    if argv is '4':
        print('Content-Type: text/html')
        print('ETag: W/hash-123-noquotes')
        found_etag = 0
        for headername, headervalue in os.environ.items():
            if headername.startswith('HTTP_'):
                if str(headername) == 'HTTP_IF_NONE_MATCH' and str(headervalue) == 'W/hash-123-noquotes' and found_etag == 0:
                    found_etag += 1
                    print('Status: 304')
                    print('ETag: {}'.format(headervalue))
                    print('')
        if found_etag == 0:
            print('Status: 200')
            print('')
            print('<html>')
            print('<body>')
            print('<h1>ETag: W/hash-123-noquotes</h1>')
            print('</body>')
            print('</html>')

    if argv is '5':
        print('Content-Type: text/html')
        print('ETag: W/"hash-123 algo"')
        found_etag = 0
        for headername, headervalue in os.environ.items():
            if headername.startswith('HTTP_'):
                if str(headername) == 'HTTP_IF_NONE_MATCH' and str(headervalue) == 'W/"hash-123 algo"' and found_etag == 0:
                    found_etag += 1
                    print('Status: 304')
                    print('ETag: {}'.format(headervalue))
                    print('')
        if found_etag == 0:
            print('Status: 200')
            print('')
            print('<html>')
            print('<body>')
            print('<h1>ETag: W/"hash-123 algo"</h1>')
            print('</body>')
            print('</html>')

    if argv is '6':
        print('Content-Type: text/html')
        print('ETag: W/"hash-123 algo-gzip"')
        found_etag = 0
        for headername, headervalue in os.environ.items():
            if headername.startswith('HTTP_'):
                if str(headername) == 'HTTP_IF_NONE_MATCH' and str(headervalue) == 'W/"hash-123 algo"' and found_etag == 0:
                    found_etag += 1
                    print('Status: 304')
                    print('ETag: {}'.format(headervalue))
                    print('')
        if found_etag == 0:
            print('Status: 200')
            print('')
            print('<html>')
            print('<body>')
            print('<h1>ETag: W/"hash-123 algo-gzip"</h1>')
            print('</body>')
            print('</html>')


def main():
    sys.stdout = io.TextIOWrapper(sys.stdout.buffer, encoding="UTF-8")
    html_page()


if __name__ == '__main__':
    main()
