/**
 * Social js script
 * Get social data (posts, reposts, likes) from social networks: TW, FB, GPLUS
 *
 * @author samokspv samokspv1@gmail.com
 * @version 2.2.5
 */
window.MACRO_INFO = {
    version: '2.2.5'
};

/*
Profiles archives path (needs copy to /tmp):
    bundle_tools/chrome_profiles/named_noimg
Profiles logins/passwords path:
    bundle_tools/trunk/api/python/hce/ftests/ftest_dc_fetchers_facebook.txt
Google chrome old versions: 
    https://www.slimjet.com/chrome/google-chrome-old-version.php
    $sudo dpkg -i chrome64_51.0.2704.84.deb
Log:
    ~/hce-node-bundle/api/python/log/social_task_rt.log

Info:
    https://peter.sh/experiments/chromium-command-line-switches/#input
*/

// =====================================
/*
datetimeStart = new Date();
datetimeEnd = new Date();
datetimeEnd.setSeconds(datetimeStart.getSeconds() + 400);

var iframeScrollTop = -1;
var incrementScroll = function incrementScroll(datetimeEnd) {
           
                var iframeBody = document.body;
                window.scrollBy(0, 600);
                //var isEndOfPage = (iframeScrollTop == iframeBody.scrollTop);
                
                iframeScrollTop = iframeBody.scrollTop;
                var isTimerEnd = (Date.parse(new Date()) >= Date.parse(datetimeEnd));
                //(Date.parse(new Date() + ':' + Date.parse(datetimeEnd)) = isTimerEnd);
                if (isTimerEnd) {
                    console.customLog('END...');
                    clearInterval(scrollLoopId);
              
                }
};
scrollLoopId = setInterval(incrementScroll.bind(null, datetimeEnd), 500);
 */
// =====================================
/*RUN chrome for testing:
google-chrome --disable-web-security --allow-running-insecure-content --user-data-dir=/tmp
*/
// =====================================
//delete console.log;
console.customLog = function(data) {
    var result = window.console.dir(data);
    return result;
}
console.customLog('social.js: script added!');
// =====================================
var localhost = {
    params: {},
    init: function(params) {
        this.params = params || {};
        return this;
    },
    // getData
    get: function() {
        var itemsData = [];
        var container = document.querySelector('#' + this.params.iframeId).contentWindow.document;
        var itemsList = container.querySelectorAll('.tweet');
        [].forEach.call(itemsList, function(item) {
            var username = item.querySelector('.username');
            if (username) {
                username = username.innerText;
            }
            if (!username || (username == '')) {
             return;
            }
            var timestamp = item.querySelector('.js-short-timestamp');
            if (timestamp) {
                timestamp = timestamp.getAttribute('data-time') + '000';
            } else {
                timestamp = '';
            }
            var title = item.querySelector('.js-tweet-text');
            if (title) {
                title = title.innerText;
            } else {
                title = '';
            }
            var like = item.querySelector('.ProfileTweet-action--favorite .ProfileTweet-actionCountForPresentation');
            if (like) {
                like = like.innerText;
            } else {
                like = 0;
            }
            var repost = item.querySelector('.ProfileTweet-action--retweet .ProfileTweet-actionCountForPresentation');
            if (repost) {
                repost = repost.innerText;
            } else {
                repost = 0;
            }
            var itemData = {
              author: username.trim(),
              date: timestamp,
              title: title.trim(),
              repost: repost,
              like: like
            };
            itemsData.push(itemData);
        });

        /*var key = this.params.iframeLink;
        var result = {};
        result[key] = itemsData;
        return result;*/
        return itemsData;
    }
}

//https://twitter.com/search?f=tweets&vertical=default&q=https://www.washingtonpost.com/politics/trump-says-cruzs-canadian-birth-could-be-very-precarious-for-gop/2016/01/05/5ce69764-b3f8-11e5-9388-466021d971de_story.html?hpid=hp_hp-top-table-main_trump0106-610pm%3Ahomepage%2Fstory
var TW = {
    name: 'tw',
    profile: '',
    params: {},
    init: function(params) {
        this.params = params || {};

        if (this.params.hasOwnProperty('returnObjOnly')) {
            return this;
        }

        if (this.params.hasOwnProperty('iframeId')) {
            this.params.container = document.querySelector('#' + this.params.iframeId).contentWindow.document;
        } else {
            this.params.container = document;
        }

        // no needs profile
        errorMaskObj.removeBitByName(errorMaskObj.errorsBits.PROFILE_EMPTY.name);
        // no needs search string
        errorMaskObj.removeBitByName(errorMaskObj.errorsBits.NO_SEARCH_INPUT.name);
        console.customLog('social.js (' + this.name + '): init(): profile user name: ' + this.profile);
        

        return this;
    },
    get: function() {
        var self = this;
        var itemsData = [];
        var itemsList = self.params.container.querySelectorAll('.tweet');
        var itemsListCount = itemsList.length;
        if (itemsListCount > 0) {
            console.customLog('social.js: ' + self.name + '.get(): itemsList.length: ' + itemsListCount);
            errorMaskObj.removeBitByName(errorMaskObj.errorsBits.SOCIAL_MODULE_CANT_FIND_DATA.name);
        } else {
            console.customLog('social.js: ' + self.name + '.get(): itemsList.length is empty');
        }

        var errorInfoContainer = self.params.container.querySelector('.SearchEmptyTimeline-empty');
        if (errorInfoContainer) {
            console.customLog('social.js: ' + self.name + '.get(): document.querySelector(".SearchEmptyTimeline-empty").innerText: ' + errorInfoContainer.innerText);
        }

        [].forEach.call(itemsList, function(item) {
            var username = item.querySelector('.username');
            if (username) {
                username = username.innerText;
            }
            var fullname = item.querySelector('.fullname');
            if (fullname) {
                fullname = fullname.innerText;
            }
            if (!username || (username == '')) {
                console.customLog('social.js: ' + self.name + '.get(): username is empty: item skipped');
                return;
            }
            username = fullname + ' ' + username;
            console.customLog('social.js: ' + self.name + '.get(): querySelector(".fullname"): ' + username);
            var timestamp = item.querySelector('.js-short-timestamp');
            if (timestamp) {
                timestamp = timestamp.getAttribute('data-time') + '000';
            } else {
                timestamp = '';
            }
            console.customLog('social.js: ' + self.name + '.get(): querySelector(".js-short-timestamp").getAttribute("data-time") + "000": ' + timestamp);
            
            /*var title = item.querySelector('.js-tweet-text');
            if (title) {
                title = title.innerText;
            } else {
                title = '';
            }*/
            var linkInTitle = item.querySelector('.js-tweet-text a');
            if (linkInTitle) {
                if (linkInTitle.getAttribute('data-expanded-url')) {
                    linkInTitleText = ' ' + linkInTitle.getAttribute('data-expanded-url');
                } else {
                    linkInTitleText = '';
                }
                linkInTitle.remove();
            } else {
                linkInTitleText = '';
            }
            var title = item.querySelector('.js-tweet-text');
            if (title) {
                title = title.innerText + linkInTitleText;
            } else {
                title = '';
            }
            console.customLog('social.js: ' + self.name + '.get(): querySelector(".js-tweet-text"): ' + title);
            
            var like = item.querySelector('.ProfileTweet-action--favorite .ProfileTweet-actionCountForPresentation');
            if (like) {
                like = like.innerText;
            } else {
                like = 0;
            }
            console.customLog('social.js: ' + self.name + '.get(): querySelector(".ProfileTweet-action--favorite .ProfileTweet-actionCountForPresentation"): ' + like);
            var repost = item.querySelector('.ProfileTweet-action--retweet .ProfileTweet-actionCountForPresentation');
            if (repost) {
                repost = repost.innerText;
            } else {
                repost = 0;
            }
            console.customLog('social.js: ' + self.name + '.get(): querySelector(".ProfileTweet-action--retweet .ProfileTweet-actionCountForPresentation"): ' + repost);
            var itemData = {
              author: username.trim(),
              date: timestamp,
              title: title.trim(),
              repost: repost,
              like: like
            };
            itemsData.push(itemData);
        });

        /*var key = this.params.iframeLink;
        var result = {};
        result[key] = itemsData;
        return result;*/
        return itemsData;
    },
    createIframe: function(id, link) {
        return createIframe(id, link);
    }
}

/*
htmltps://plus.google.com/collections/featured

var iframe = document.createElement('iframe');
        iframe.id = 'testID';
iframe.src = 'https://google.com/plus';
iframe.top = '0px';
iframe.left = '0px';
iframe.style="border:1px solid red";
document.body.innerHTML = 'TEST GPLUS';
document.body.appendChild(iframe);
 */

//https://plus.google.com/s/%22'Fantastic%20Beasts'%3A%20Can%20a%20Harry%20Potter%20hater%20enjoy%20the%20new%20movie%3F%22/top
var GPLUS = {
    name: 'gplus',
    params: {},
    init: function(params) {
        this.params = params || {};

        if (this.params.hasOwnProperty('iframeId')) {
            this.params.container = document.querySelector('#' + this.params.iframeId).contentWindow.document;
        } else {
            this.params.container = document;
        }

        // no needs profile
        errorMaskObj.removeBitByName(errorMaskObj.errorsBits.PROFILE_EMPTY.name);
        // no needs search string
        errorMaskObj.removeBitByName(errorMaskObj.errorsBits.NO_SEARCH_INPUT.name);

        console.customLog('social.js (' + this.name + '): init(): profile user name: ' + this.profile);
        

        return this;
    },
    get: function() {
        var self = this;
        var itemsData = [];
        var itemsList = self.params.container.querySelectorAll('.Ihwked');
        
        var itemsListCount = itemsList.length;
        if (itemsListCount > 0) {
            console.customLog('social.js: ' + self.name + '.get(): itemsList.length: ' + itemsListCount);
            errorMaskObj.removeBitByName(errorMaskObj.errorsBits.SOCIAL_MODULE_CANT_FIND_DATA.name);
        } else {
            console.customLog('social.js: ' + self.name + '.get(): itemsList.length is empty');
        }

        var errorInfoContainer = self.params.container.querySelector('.t1KkGe.dUB6ge');
        if (errorInfoContainer) {
            console.customLog('social.js: ' + self.name + '.get(): document.querySelector(".SearchEmptyTimeline-empty").innerText: ' + errorInfoContainer.innerText);
        }

        [].forEach.call(itemsList, function(item) {
            var username = item.querySelector('.xHn24c');
            if (username) {
                username = username.innerText;
            }
            if (!username || (username == '')) {
             return;
            }

            var dateString = item.querySelector('.qXj2He span');
            if (dateString) {

                dateStringLabel = dateString.getAttribute('aria-label').trim();
                dateString = dateString.innerText.trim();

                if (dateStringLabel.indexOf('min') !== -1) {
                    var dateStringForParse = dateString + 'in';
                } else if (dateStringLabel.indexOf('hour') !== -1) {
                    var dateStringForParse = dateString + 'our';
                } else if (dateStringLabel.indexOf('day') !== -1) {
                    var dateStringForParse = dateString + 'ay';
                } else if (dateStringLabel.indexOf('week') !== -1) {
                    var dateStringForParse = dateString + 'eek';
                }
                if (dateStringForParse) {
                    var dateString = Date.parse('t - ' + dateStringForParse);   
                }

            } else {
                var dateString = item.querySelector('.qXj2He');
                dateString = dateString.innerText.trim();
            }
            var today = new Date(dateString);
            var timestamp = today.getTime();

            var title = item.querySelector('.wftCae');
            if (title) {
                title = title.innerText;
            } else {
                title = '';
            }
            var numbers = item.querySelectorAll('.KwDIr .YxJESd');
            if (numbers[0]) {
                like = numbers[0].innerText;
            } else {
                like = 0;
            }
            var numberLast = numbers[numbers.length - 1];
            if (numberLast) {
                repost = numberLast.innerText;
            } else {
                repost = 0;
            }
            var itemData = {
              author: username.trim(),
              date: timestamp,
              title: title.trim(),
              repost: repost,
              like: like
            };
            itemsData.push(itemData);
        });

        /*var key = this.params.iframeLink;
        var result = {};
        result[key] = itemsData;
        return result;*/
        return itemsData;
    }
}

//https:\/\/www.facebook.com\/search\/top\/?q=%25QUERY_STRING%25
//https://www.facebook.com/search/top/?q=%27Fantastic%20Beasts%27%3A%20Can%20a%20Harry%20Potter%20hater%20enjoy%20the%20new%20movie%3F
//need this plugin for adding iframe: https://chrome.google.com/webstore/detail/ignore-x-frame-headers/gleekbfjekiniecknbkamfmkohkpodhe/reviews
//https://sites.google.com/a/chromium.org/chromedriver/extensions
//http://askubuntu.com/questions/26782/where-are-chromium-extensions-located
// path to extensions: chrome://version/ , chrome://extensions/
/*
For FB needs:
- add headers to api/python/ini/crawler-task_headers.txt
    --user-data-dir-zip:/tmp/custom_profile_fb_noimg50b.zip,/tmp/custom_profile_fb_noimg50c.zip,/tmp/custom_profile_fb_noimg50d.zip,/tmp/custom_profile_fb_noimg50e.zip,/tmp/custom_profile_fb_noimg50f.zip,/tmp/custom_profile_fb_noimg50g.zip,/tmp/custom_profile_fb_noimg50h.zip,/tmp/custom_profile_fb_noimg50i.zip,/tmp/custom_profile_fb_noimg50j.zip,/tmp/custom_profile_fb_noimg50k.zip,/tmp/custom_profile_fb_noimg50l.zip,/tmp/custom_profile_fb_noimg50m.zip
*/
var FB = {
    name: 'fb',
    profile: '',
    params: {},
    init: function(params) {
        this.params = params || {};
        
        //"native", "media_page" и "google_search"
        if (!this.params.hasOwnProperty('method')) {
            this.params.method = 'media_page';
        }
        
        if (this.params.hasOwnProperty('returnObjOnly')) {
            return this;
        }

        if (this.params.hasOwnProperty('iframeId')) {
            this.params.container = document.querySelector('#' + this.params.iframeId).contentWindow.document;
        } else {
            this.params.container = document;
        }

        switch (this.params.method) {
            case 'native':
            var profileUserContainer = this.params.container.querySelector('div[data-click="profile_icon"] span');
            if (profileUserContainer) {
                this.profile = profileUserContainer.innerText.trim();
                errorMaskObj.removeBitByName(errorMaskObj.errorsBits.PROFILE_EMPTY.name);
            } else {
                return this;
            }
            console.customLog('social.js (' + this.name + '): init(): profile user name: ' + this.profile);
        
            var profileFacebookSearch = document.querySelector('div[role="search"] form div div div div input[name="q"]');
            if (profileFacebookSearch) {
                errorMaskObj.removeBitByName(errorMaskObj.errorsBits.NO_SEARCH_INPUT.name);
                console.customLog('social.js Facebook search input avaliable on page');
            } else {
                return this;
            }
            break;

            case 'media_page':
            console.customLog('social.js (' + this.name + '): init(): use search without authorization');
            
            // no needs profile
            errorMaskObj.removeBitByName(errorMaskObj.errorsBits.PROFILE_EMPTY.name);
            // no needs search string
            errorMaskObj.removeBitByName(errorMaskObj.errorsBits.NO_SEARCH_INPUT.name);
            // no needs create iframe
            errorMaskObj.removeBitByName(errorMaskObj.errorsBits.IFRAME_NOT_CREATED.name);
            break;
        }

        return this;
    },
    get: function() {
        var  self = this;
        var itemsData = [];

        console.customLog('social.js: ' + self.name + '.method: ' + self.params.method);

        switch (self.params.method) {
            case 'native':
            // container (v1)
            var itemsList = self.params.container.querySelectorAll('.userContentWrapper');
            if (!itemsList.length) {
                // container (v2)
                var itemsList = self.params.container.querySelectorAll('.fbUserContent');
                var itemsListContainerStyle = 2;
            }
            if (!itemsList.length) {
                // container (v3)
                //var itemsList = self.params.container.querySelectorAll('._401d');
                var itemsList = self.params.container.querySelectorAll('._1yt [data-bt*="PUBLIC_POSTS"] ._401d');
                var itemsListContainerStyle = 3;
            }
            if (!itemsList.length) {
                // container (v4)
                var itemsList = self.params.container.querySelectorAll('._1yt [data-gt*="PUBLIC_POSTS"] ._401d');
                var itemsListContainerStyle = 4;
            }
            if (!itemsList.length) {
                // container (v5)
                var itemsList = self.params.container.querySelectorAll('#initial_browse_result ._401d');
                var itemsListContainerStyle = 5;
            }

            var itemsListCount = itemsList.length;
            if (itemsListCount > 0) {
                console.customLog('social.js: ' + self.name + '.get(): itemsList.length: ' + itemsListCount);
                errorMaskObj.removeBitByName(errorMaskObj.errorsBits.SOCIAL_MODULE_CANT_FIND_DATA.name);
            } else {
                console.customLog('social.js: ' + self.name + '.get(): itemsList.length is empty');
                //console.customLog('social.js: ' + self.name + '.get(): document.querySelector("body").innerHTML: ' + self.params.container.querySelector("body").innerHTML);
            }

            var errorInfoContainer = self.params.container.querySelector('._50f4._5kx5');
            if (errorInfoContainer) {
                // We couldn't find anything for ...
                console.customLog('social.js: ' + self.name + '.get(): (banned!) document.querySelector("._50f4._5kx5").innerText: ' + errorInfoContainer.innerText);
                return exit();

                /*if (window.MACRO_COLLECT.options.fb.hasOwnProperty('profileBannedCountCurrent') &&
                    window.MACRO_COLLECT.options.fb.hasOwnProperty('profileBannedCountMax') &&
                    (window.MACRO_COLLECT.options.fb.profileBannedCountCurrent >= window.MACRO_COLLECT.options.fb.profileBannedCountMax)
                        ) {
                    console.customLog('social.js: (fb) profileBannedCountMax is reached');
                    return exit();
                } else {
                    FB_SETTINGS.profileBannedCountCurrent++;
                }*/

            }

            [].forEach.call(itemsList, function(item) {
                var username = item.querySelector('.fwb a');
                if (!username) {
                    var username = item.querySelector('._lic ._vwp');
                }
                if (username) {
                    username = username.innerText;
                } else if (!username || (username == '')) {
                    console.customLog('social.js: ' + self.name + '.get(): username is empty: item skipped');
                    return;
                }
                console.customLog('social.js: ' + self.name + '.get(): querySelector(".fwb a").innerText: ' + username);
                var timestamp = item.querySelector('abbr[data-utime]');
                if (timestamp) {
                    timestamp = timestamp.getAttribute('data-utime') + '000';
                } else {
                    timestamp = '';
                }
                console.customLog('social.js: ' + self.name + '.get(): querySelector("abbr[data-utime]").getAttribute("data-utime") + "000": ' + timestamp);
                var title = item.querySelector('.userContent');
                if (!title) {
                    var title = item.querySelector('._5-jo');     
                }
                if (title) {
                    title = title.innerText;
                } else {
                    title = '';
                }
                console.customLog('social.js: ' + self.name + '.get(): querySelector(".userContent").innerText: ' + title);
                
                // like (v1)
                var like = item.querySelector('._ipp a span span');
                if (like) {
                    like = like.innerText;
                } else {
                    like = 0;
                }
                console.customLog('social.js: ' + self.name + '.get(): querySelector("._ipp a span span").innerText: ' + like);
                
                //if (itemsListContainerStyle && (itemsListContainerStyle == 3)) {
                    /*var repost = item.querySelector('._ipo ._ipm._2x0m');
                    if (repost) {
                        repost = repost.innerText.split(' ')[0];
                    } else {
                        repost = 0;
                    }*/
                    // respost (v1)
                    var repost = item.querySelector('._ipo ._ipm._2x0m');
                    if (repost) {
                        repost = repost.innerText.split(' ')[0];
                    } else {
                        var repost = 0;
                    }
                /*} else {
                    var repost = item.querySelector('._ipo ._ipm');
                    if (repost) {
                        repost = repost.innerText;
                    } else {
                        repost = 0;
                    }
                }**/
                console.customLog('social.js: ' + self.name + '.get(): querySelector("._ipo ._ipm._2x0m").innerText: ' + repost);
                
                var subLikesMixed = [];
                var subLikesBox = item.querySelectorAll('._ipp span a');
                [].forEach.call(subLikesBox, function(subLikesMixedBoxItem) {
                    subLikesMixed.push(subLikesMixedBoxItem.getAttribute('aria-label'));
                });
                subLikesGroup = {
                    'like': '',
                    'love': '',
                    'haha': '',
                    'wow': '',
                    'sad': '',
                    'angry': ''
                };
                if (subLikesMixed.length) {
                    [].forEach.call(subLikesMixed, function(subLikesMixedItem) {
                        var subLikesMixedItemSplit = subLikesMixedItem.split(' ');
                        subLikesGroup[subLikesMixedItemSplit[1].toLowerCase()] = subLikesMixedItemSplit[0];
                    });
                }

                var itemData = {
                  author: username/*.trim()*/,
                  date: timestamp,
                  title: title.trim(),
                  repost: repost,
                  like: like,
                  subLikes: subLikesGroup
                };
                itemsData.push(itemData);
            });
            break;
            
            case 'media_page':
            var popupDialog = self.params.container.querySelector('#content_container ._3-8y');
            if (popupDialog) {
                popupDialog.remove();
            }

            /*var notDataWhatWeNeedFlag = 'notDataWhatWeNeed';
            self.params.container.querySelectorAll('.userContentWrapper').className += ' ' + notDataWhatWeNeedFlag;
            console.info('!!!!!' + self.params.query);
            document.querySelector('._58al').value = self.params.query;
            document.querySelector('._3fbq').click();*/

            //var intervalId = setInterval(function() {

                // container (v1)
                var itemsList = 
                    self.params.container
                        .querySelector('._442n')
                        .querySelectorAll('.userContentWrapper');
                /*if (itemsList.length && !(itemsList[0].className.indexOf(notDataWhatWeNeedFlag) !== -1)) {
                    clearInterval(intervalId);
                }*/

                var itemsListCount = itemsList.length;
                if (itemsListCount > 0) {
                    console.customLog('social.js: ' + self.name + '.get(): itemsList.length: ' + itemsListCount);
                    errorMaskObj.removeBitByName(errorMaskObj.errorsBits.SOCIAL_MODULE_CANT_FIND_DATA.name);
                } else {
                    console.customLog('social.js: ' + self.name + '.get(): itemsList.length is empty');
                    //console.customLog('social.js: ' + self.name + '.get(): document.querySelector("body").innerHTML: ' + self.params.container.querySelector("body").innerHTML);
                }

                var errorInfoContainer = self.params.container.querySelector('._26l');
                if (errorInfoContainer) {
                    // Sorry, we couldn't find any results for this search.
                    console.customLog('social.js: ' + self.name + '.get(): (banned!) document.querySelector("._26l").innerText: ' + errorInfoContainer.innerText);
                    return exit();

                    /*if (window.MACRO_COLLECT.options.fb.hasOwnProperty('profileBannedCountCurrent') &&
                        window.MACRO_COLLECT.options.fb.hasOwnProperty('profileBannedCountMax') &&
                        (window.MACRO_COLLECT.options.fb.profileBannedCountCurrent >= window.MACRO_COLLECT.options.fb.profileBannedCountMax)
                            ) {
                        console.customLog('social.js: (fb) profileBannedCountMax is reached');
                        return exit();
                    } else {
                        FB_SETTINGS.profileBannedCountCurrent++;
                    }*/

                }

                //var item = itemsList[0];
                [].forEach.call(itemsList, function(item) {
                    var username = item.querySelector('.fwb a');
                    if (!username) {
                        var username = item.querySelector('._lic ._vwp');
                    }
                    if (username) {
                        username = username.innerText;
                    } else if (!username || (username == '')) {
                        console.customLog('social.js: ' + self.name + '.get(): username is empty: item skipped');
                        return;
                    }
                    console.customLog('social.js: ' + self.name + '.get(): querySelector(".fwb a").innerText: ' + username);
                    var timestamp = item.querySelector('abbr[data-utime]');
                    if (timestamp) {
                        timestamp = timestamp.getAttribute('data-utime') + '000';
                    } else {
                        timestamp = '';
                    }
                    console.customLog('social.js: ' + self.name + '.get(): querySelector("abbr[data-utime]").getAttribute("data-utime") + "000": ' + timestamp);
                    var title = item.querySelector('.userContent');
                    if (!title) {
                        var title = item.querySelector('._5-jo');     
                    }
                    if (title) {
                        title = title.innerText;
                    } else {
                        title = '';
                    }
                    console.customLog('social.js: ' + self.name + '.get(): querySelector(".userContent").innerText: ' + title);
                    
                    // like (v2)
                    if (!like) {
                        var like = item.querySelector('.UFIContainer .UFILikeSentenceText span');
                        /*if (like) {
                            like = like.innerText.match(/\d+/);
                            if (like) {
                                like = like[0];
                            } else {
                                like = 0;  
                            }
                        } else {
                            like = 0;
                        }*/
                        if (like) {
                            like = like.innerText;
                            //var like = 'Pornchai Puttikulsathit, Derek Sebastien, Nick Huish and 6,234 others like this.';
                            //var like = 'Tim Grundmann and Ахмар Влад like this.'
                            //var like = "Teng Teck Poh likes this."; 
                            if (like.indexOf(' others like this.') !== -1) { // many people likes this
                                var likeSplitAnd = like.split(' and ');
                                var like1 = likeSplitAnd[0].split(',').length;
                                console.info(like1);
                                var like2 = likeSplitAnd[1].replace(' others like this.', '').replace(',', '.');
                                var like = parseInt(like1) + parseFloat(like2);
                            } else if (like.indexOf(' like this.') !== -1) { // 2 people likes this
                                like = 2;
                            } else if (like.indexOf(' likes this.') !== -1) { // 1 people likes this
                                like = 1;
                            } else {
                                like = 0;
                            }
                        } else {
                            like = 0;
                        }
                    }
                    console.customLog('social.js: ' + self.name + '.get(): querySelector(".UFIContainer .UFILikeSentenceText span").innerText: ' + like);
                    
                    // respost (v2)
                    if (!repost) {
                        var repost = item.querySelector('.UFIContainer .UFIShareRow a');
                        if (repost) {
                            repost = repost.innerText.split(' ')[0];
                        } else {
                            var repost = 0;
                        }                    
                    }
                    console.customLog('social.js: ' + self.name + '.get(): querySelector(".UFIContainer .UFIShareRow a").innerText: ' + repost);
                    
                    var subLikesMixed = [];
                    var subLikesBox = item.querySelectorAll('._ipp span a');
                    [].forEach.call(subLikesBox, function(subLikesMixedBoxItem) {
                        subLikesMixed.push(subLikesMixedBoxItem.getAttribute('aria-label'));
                    });
                    subLikesGroup = {
                        'like': '',
                        'love': '',
                        'haha': '',
                        'wow': '',
                        'sad': '',
                        'angry': ''
                    };
                    if (subLikesMixed.length) {
                        [].forEach.call(subLikesMixed, function(subLikesMixedItem) {
                            var subLikesMixedItemSplit = subLikesMixedItem.split(' ');
                            subLikesGroup[subLikesMixedItemSplit[1].toLowerCase()] = subLikesMixedItemSplit[0];
                        });
                    }
                    // comments
                    if (document.querySelector('.UFIPagerLink')) {
                        document.querySelector('.UFIPagerLink').click();
                    }


                    var itemData = {
                      author: username/*.trim()*/,
                      date: timestamp,
                      title: title.trim(),
                      repost: repost,
                      like: like,
                      subLikes: subLikesGroup
                    };
                    itemsData.push(itemData);
                });

            //}, 500);
            break;
            // ...
        }
        
        /*var key = self.params.iframeLink;
        var result = {};
        result[key] = itemsData;
        return result;*/
        return itemsData;
    },
    getDataFromLinksList: function() {
        //check prifile icon is still avaliable while searching and not blocked
        var profileUserBit = window.errorMaskObj.checkBitByName('PROFILE_EMPTY');
        if (profileUserBit) {
            console.customLog('social.js: profile user name: ' + this.profile + ' GONE! ->' + window.errorMaskObj.maskList);
            return this.get();
        }
        //check search string is still avaliable while searching and not blocked
        var profileFacebookSearchBit = window.errorMaskObj.checkBitByName('NO_SEARCH_INPUT');
        if (profileFacebookSearchBit) {
            console.customLog('social.js Facebook search string is NOT avaliable while search, GONE!');
            return this.get();
        }

        var linksList = this.getLinksList();
        console.customLog('social.js: linksList: ' + JSON.stringify(linksList));
        var linksListCount = Object.keys(linksList).length;
        if (linksListCount > 0) {
            if (linksList.hasOwnProperty('storiesPublic')) {
                var fbFrameCall = createIframe(this.params.id, linksList['storiesPublic']);
                return true; // continue next iteration
            }
            // needs to merge: storiesPublic and storiesOpinion
            /*
            if (linksList.hasOwnProperty('storiesOpinion')) {
                createIframe(this.params.id, linksList['storiesOpinion']);
            }
            return true;
            */
        } else {
            return this.get();
        }
        //exit();
        /*for (var linksListKey in linksList) {
            var link = linksList[linksListKey];
            createIframe(linksListKey, link);
        }*/
    },
    getLinksList: function() {
        var linksList = {};
        // Public Posts (see all)
        var storiesPublic = this.params.container.querySelectorAll('._401d a[href*="stories-public"]');
        if (storiesPublic.length) {
            linksList.storiesPublic = storiesPublic[0].href;
        }
        /*// People Are Saying (see all)
        var storiesOpinion = this.params.container.querySelectorAll('._401d a[href*="stories-opinion"]');
        if (storiesOpinion.length) {
            linksList.storiesOpinion = storiesOpinion[0].href;
        }*/
        return linksList;
    },
    createIframe: function(id, link) {
        switch (this.params.method) {
            case 'media_page':
            return getDataFromCurrentPage(id, link);
            break;
            case 'native':
            default:
            return createIframeFromLinksList(id, link);
            break;
        }
    }
}
//======================================
var errorMask = {
    params: {},
    maskList: 0,
    errorsBits: {
        KEYWORDS_DATA_EMPTY: {
            name: 'KEYWORDS_DATA_EMPTY',
            bitNumber: 0
        },
        PROFILE_EMPTY: {
            name: 'PROFILE_EMPTY',
            bitNumber: 1
        },
        IFRAME_NOT_CREATED: {
            name: 'IFRAME_NOT_CREATED',
            bitNumber: 2
        },
        SOCIAL_MODULE_RESULT_EMPTY: {
            name: 'SOCIAL_MODULE_RESULT_EMPTY',
            bitNumber: 3
        },
        SOCIAL_MODULE_CANT_FIND_DATA: {
            name: 'SOCIAL_MODULE_CANT_FIND_DATA',
            bitNumber: 4
        },
        NO_SEARCH_INPUT: {
            name: 'NO_SEARCH_INPUT',
            bitNumber: 5
        },
    },
    init: function(params) {
        this.params = params || {};
        console.customLog('social.js: errorMask.init()');
        if (this.params.hasOwnProperty('maskList')) {
            this.maskList = this.params.maskList;
        } else {
            for (var i in this.errorsBits) {
                this.addBitByName(this.errorsBits[i].name);
            }
        }
        console.customLog('social.js: errorMask.errorsBits: ' + JSON.stringify(this.errorsBits));
        return this;
    },
    addBitByName: function(bitName) {
        // Add bit to errorMask
        if (!this.errorsBits.hasOwnProperty(bitName)) {
            return false;
        }
        var bit = Math.pow(2, this.errorsBits[bitName].bitNumber);
        this.maskList |= bit;
        console.customLog('social.js: errorMask.addBitByName(' + bitName + ')');
        return true;
    },
    removeBitByName: function(bitName) {
        // Remove bit from errorMask
        if (!this.errorsBits.hasOwnProperty(bitName)) {
            return 'error';
        }
        var bitNumber = this.errorsBits[bitName].bitNumber;
        bit = Math.pow(2, bitNumber);
        this.maskList &= ~bit;

        if (this.params.hasOwnProperty('id')) {
            window.MACRO_COLLECT.data[this.params.id].errorMask &= ~bit;
        }

        console.customLog('social.js: errorMask.removeBitByName(' + bitName + ')');
        return true;
    },
    checkBitByName: function(bitName) {
        // Checks bit in errorMask
        if (!this.errorsBits.hasOwnProperty(bitName)) {
            return false;
        }
        var bitNumber = this.errorsBits[bitName].bitNumber;
        return this.maskList & Math.pow(2, bitNumber);
    },
    getErrorsBitsFromMask: function(mask) {
        var errorsBitsFromMask = {};
        if (!mask) {
            return errorsBitsFromMask;
        }
        for (var i in this.errorsBits) {
            var bit = Math.pow(2, this.errorsBits[i].bitNumber);
            var isBitInMaskList = (this.maskList & bit);
            if (isBitInMaskList > 0) {
                var name = this.errorsBits[i].name;
                errorsBitsFromMask[name] = this.errorsBits[name];
            }
        }
        return errorsBitsFromMask;
    },
}
function getURLObj(url) {
    return (new URL(url));
}
function fixSourceURL(url) {
    /*var domain = getURLObj(url);
    domain = domain.hostname;
    switch (domain) {
        case 'www.washingtonpost.com':
            if (url.indexOf('?')) {
                url = url.split('?')[0];
            }
        break;
    }*/
    if (url && url.indexOf('?') && (url.indexOf('.html') || url.indexOf('.htm'))) {
        url = url.split('?')[0];
    }
    return url;
}
function exit() {
    window.IFRAME_DATA_READY = true;
    console.customLog('social.js: maskList=' + JSON.stringify(errorMaskObj.maskList));
    return true;
}
//errorMaskObj = errorMask.init();

/*window.MACRO_COLLECT = [];*/
/*window.MACRO_COLLECT = {
    data: {
        "b5777a445645146e13ca1f06eb719754": {
          source_url: "http://www.valuewalk.com/2018/01/ibm-q4-2017-earnings-results-tank-shares",
          title: 'IBM Q4 2017 Earnings Results Tank Shares',
          errorMask: 63,
          data: [],
          info: {}
        }
    },
    options: {
        totalMaxTime: 300, //window.IFRAME_MAX_TIME
        scrollCount:  10,   //window.IFRAME_CSCROLL_COUNT
        scrollDelay:  1000,//window.IFRAME_CSCROLL_DELAY
        scrollStep:   300, //window.IFRAME_CSCROLL_STEP
        searchField:  'source_url', //window.IFRAME_SFIELD
        queryUrl: 'https://www.facebook.com/pg/bbc/posts/?ref=page_internal',
        //queryUrl:     'https://twitter.com/search?f=tweets&vertical=default&q=%25QUERY_STRING%25&src=typd', // window.IFRAME_QUERY_URL
        profileBannedCountMax: {
          fb: 5, 
          tw: 0
        },
        dataCount: 1,
        method: 'media_page',
        currentDataMd5: 'b5777a445645146e13ca1f06eb719754',
        autostart: ''
    },
    info: {
        currentDataIndex: 0,
        profileBannedCountCurrent: {
          fb: 0, 
          tw: 0
        }
    }
};*/

window.socialModule = getSocialModule();
var documentLocation = document.location;

/*var xmlhttp = new XMLHttpRequest();
xmlhttp.open('GET', window.MACRO_COLLECT.options.geoIPInfoURL, true);
xmlhttp.onreadystatechange = function() {
  if ((xmlhttp.readyState == 4) && (xmlhttp.status == 200)) {
    console.customLog('social.js: Geo IP info (ok): ' + xmlhttp.responseText);
  } else {
    console.customLog('social.js: Geo IP info (check...): ' + xmlhttp.responseText);
  }
};
xmlhttp.send(null);*/

//iframe onerror listener
function iframeErrored() {
    window.errorMaskObj.addBitByName(window.errorMaskObj.errorsBits.IFRAME_NOT_CREATED.name);
    console.customLog('social.js: createIframeFromLinksList: iframe.onerror: need exit');
    exit();
}
/*function startIframe(id, link) {
    createIframe(searchDataKey, iframeLink);
}*/

function createIframeFromLinksList(id, link) {
    progressCounter();

    if (!id || !link) {
        console.customLog('social.js: createIframeFromLinksList (error): id: ' + id + '; link: ' + link);
        return false;
    }

    console.customLog('social.js: createIframeFromLinksList (ok): id: ' + id + '; link: ' + link);

    var profileFacebookSearch = document.querySelector('div[role="search"] form div div div div input[name="q"]');
    if (profileFacebookSearch) {
        errorMaskObj.removeBitByName(errorMaskObj.errorsBits.NO_SEARCH_INPUT.name);
    } else {
        console.customLog('social.js createIframeFromLinksList (error): Facebook search input not avaliable on page');
        return false;
    }
    console.customLog('social.js createIframeFromLinksList (ok): Facebook search input avaliable on page');


    iframeId = 'social_iframe_links_' + id;
    var iframe = document.querySelector('#' + iframeId);
    var createNewIframe = false;
    if (!iframe) {
        createNewIframe = true;
        var iframe = document.createElement('iframe');
        iframe.id = iframeId;
        //console.customLog('createNewIframe: ' + iframeId);
    } else {
        //console.customLog('useOldIframe: ' + iframeId);
    }

    iframe.onload = function() {
        console.customLog('social.js createIframeFromLinksList: iframe.onload: starting... ');
        window.errorMaskObj.removeBitByName(window.errorMaskObj.errorsBits.IFRAME_NOT_CREATED.name);

        return function() {
            //alert('iframe-onload');
            datetimeStart = new Date();
            datetimeEnd = new Date();
            datetimeEnd.setSeconds(datetimeStart.getSeconds() + window.MACRO_COLLECT.options.totalMaxTime);

            var iframeScrollTop = -1;
            var scrollCountCheck = 1;
            var incrementScroll = function incrementScroll(iframe, datetimeEnd) {
                console.customLog('social.js: createIframeFromLinksList: iframe.onload: scrolling... : ' + scrollCountCheck);
                progressCounter();

                //alert(iframe.id);
                //var iframe = document.querySelector('#' + iframeId);
                var iframeBody = iframe.contentWindow.document.body;
                iframe.contentWindow.scrollBy(0, window.MACRO_COLLECT.options.scrollStep);
                
                // setTimeout
                setTimeout(function() {
                
                var isEndOfPage = (iframeScrollTop == iframeBody.scrollTop);
                iframeScrollTop = iframeBody.scrollTop;
                /*var isTimerEnd = (Date.parse(new Date()) >= Date.parse(datetimeEnd));
                if (isTimerEnd) {
                    isEndOfPage = true;
                } else {
                    isEndOfPage = false;
                }*/
                
                if ((window.MACRO_COLLECT.options.scrollCount != 0) && (scrollCountCheck >= window.MACRO_COLLECT.options.scrollCount)) {
                    isEndOfPage = true;
                }/* else {
                    isEndOfPage = false;
                }*/
                
                /*if (!isEndOfPage) {
                    //console.customLog('SOCIAL-JS: Scroll step: ' + scrollCountCheck);
                } else {*/
                if (isEndOfPage) {
                    clearInterval(scrollLoopId);
                    //console.customLog('SOCIAL-JS: Iframe #' + iframeId + ': BEGIN');
                    
                    /*var tempData = {};
                    tempData[id] = {url: '', data: []};
                    tempData[id].url = link;*/
                    
                    var socialModuleResult = socialModule
                            .init({
                                id: id,
                                iframeId: iframe.id,
                                method: window.MACRO_COLLECT.options.method
                                /*,iframeLink: link*/
                            })
                            .getDataFromLinksList();
                    
                    /*if (!socialModuleResult) {
                        var socialModuleResult = socialModule
                            .init({
                                iframeId: iframe.id
                            })
                            .get();
                    }*/

                    console.customLog('social.js: createIframeFromLinksList: iframe.onload: isEndOfPage: socialModuleResult: ' + JSON.stringify(socialModuleResult));
                    
                    /*if (socialModuleResult) {
                        return true;
                    }*/

                    if (Array.isArray(socialModuleResult)) {
                        if (socialModuleResult.length) {
                            errorMaskObj.removeBitByName(errorMaskObj.errorsBits.SOCIAL_MODULE_RESULT_EMPTY.name);
                        }
                        
                        /*var tempData = {};
                        tempData[id] = {url: '', data: []};
                        tempData[id].url = link;
                        tempData[id].data = socialModuleResult;
                        tempData[id].profile = socialModule.profile;
                        tempData[id].errorMask = errorMaskObj.maskList;
                        window.MACRO_COLLECT.push(tempData);*/
                        
                        window.MACRO_COLLECT.data[id].source_url = link;
                        window.MACRO_COLLECT.data[id].data = socialModuleResult;
                        window.MACRO_COLLECT.data[id].profile = socialModule.profile;
                        window.MACRO_COLLECT.data[id].errorMask = errorMaskObj.maskList;
                        window.MACRO_COLLECT.info.currentDataIndex++;

                        //if (window.MACRO_COLLECT.options.dataCount == window.MACRO_COLLECT.length) {
                        if (window.MACRO_COLLECT.options.dataCount == window.MACRO_COLLECT.info.currentDataIndex) {
                            console.customLog('social.js: createIframeFromLinksList: iframe.onload: MACRO_COLLECT: (exit)' + JSON.stringify(window.MACRO_COLLECT));
                            console.customLog('social.js: createIframeFromLinksList: iframe.onload: IFRAME_DATA_READY: true');
                            return exit();
                        }

                    } else {
                        return true;
                    }
                }
                
                scrollCountCheck++;
                }, 500);// setTimeout
            }
            var scrollLoopId;
            var startScrollLoop = function(iframe) {
                //alert(iframe.id);
                scrollLoopId = setInterval(incrementScroll.bind(null, iframe, datetimeEnd), window.MACRO_COLLECT.options.scrollDelay);
            }
            var iframe = this;
            startScrollLoop(iframe);
        }
    }();

    iframe.addEventListener("error", iframeErrored, true);


    iframe.src = link;

    iframe.style.position = 'absolute';
    iframe.style.top = '0px';
    iframe.style.zIndex = '10001';
    //iframe.style.height = '800px';
    //iframe.style.width = '600px';
    iframe.style.height = '1080px';
    iframe.style.width = '1920px';
    
    //console.customLog('SOCIAL-JS. Iframe Id: ' + iframeId);
    //console.customLog('SOCIAL-JS. Iframe link: ' + link);

    //var html = '<body>Foo</body>';
    //iframe.src = 'data:text/html;charset=utf-8,' + encodeURI(html);
    if (createNewIframe) {
        document.body.appendChild(iframe);
    }

    //check the element iframe exists in DOM
    var iframeBit = document.querySelector('#' + iframeId);
    if (iframeBit) {
        try {
            iframeBit.contentWindow.document.body;
            errorMaskObj.removeBitByName(errorMaskObj.errorsBits.IFRAME_NOT_CREATED.name);
        } catch(e) {
            errorMaskObj.addBitByName(errorMaskObj.errorsBits.IFRAME_NOT_CREATED.name);
            exit();
            return false;
        }

    } else {
        console.customLog('social.js createIframeFromLinksList (error): iframeBit failed');
        exit();
        return false;
    }
    ////alert(3);
}

function createIframe(id, link) {
    console.customLog('social.js: createIframe');

    progressCounter();

    if (!id || !link) {
        console.customLog('social.js: createIframe (error): id: ' + id + '; link: ' + link);
        return false;
    }
    
    console.customLog('social.js: createIframe (ok): id: ' + id + '; link: ' + link);
    
    errorMaskObj.removeBitByName(errorMaskObj.errorsBits.IFRAME_NOT_CREATED.name);

    iframeId = 'social_iframe_' + id;
    var iframe = document.querySelector('#' + iframeId);
    var createNewIframe = false;
    if (!iframe) {
        createNewIframe = true;
        var iframe = document.createElement('iframe');
        iframe.id = iframeId;
        //console.customLog('createNewIframe: ' + iframeId);
    } else {
        //console.customLog('useOldIframe: ' + iframeId);
    }

    iframe.onload = function() {
        return function() {
            //alert('iframe-onload');
            datetimeStart = new Date();
            datetimeEnd = new Date();
            datetimeEnd.setSeconds(datetimeStart.getSeconds() + window.MACRO_COLLECT.options.totalMaxTime);

            var iframeScrollTop = -1;
            var scrollCountCheck = 1;
            var incrementScroll = function incrementScroll(iframe, datetimeEnd) {
                console.customLog('social.js: createIframe: iframe.onload: scrolling... : ' + scrollCountCheck);
                progressCounter();

                //alert(iframe.id);
                //var iframe = document.querySelector('#' + iframeId);
                var iframeBody = iframe.contentWindow.document.body;
                iframe.contentWindow.scrollBy(0, window.MACRO_COLLECT.options.scrollStep);
                
                // setTimeout
                setTimeout(function() {
                
                var isEndOfPage = (iframeScrollTop == iframeBody.scrollTop);
                iframeScrollTop = iframeBody.scrollTop;
                /*var isTimerEnd = (Date.parse(new Date()) >= Date.parse(datetimeEnd));
                if (isTimerEnd) {
                    isEndOfPage = true;
                } else {
                    isEndOfPage = false;
                }*/
                
                if ((window.MACRO_COLLECT.options.scrollCount != 0) && (scrollCountCheck >= window.MACRO_COLLECT.options.scrollCount)) {
                    isEndOfPage = true;
                }/* else {
                    isEndOfPage = false;
                }*/
                
                /*if (!isEndOfPage) {
                    //console.customLog('SOCIAL-JS: Scroll step: ' + scrollCountCheck);
                } else {*/
                if (isEndOfPage) {
                    clearInterval(scrollLoopId);
                    //console.customLog('SOCIAL-JS: Iframe #' + iframeId + ': BEGIN');
                    var socialModuleResult = socialModule
                            .init({
                                iframeId: iframe.id,
                                method: window.MACRO_COLLECT.options.method
                                /*,iframeLink: link*/
                            })
                            .get();
                    /*Example: socialModuleResult = [
                      {
                        "a353d41c75a72de2376500ad052c0e63": {
                          "url": "https://www.facebook.com/search/top/?q='Fantastic Beasts': Can a Harry Potter hater enjoy the new movie?",
                          "data": [
                            {
                              "date": "1479636907000",
                              "title": "Find out what a Potter superfan and a confused muggle made of the new film set in J.K. Rowling's wizarding world.",
                              "repost": 0,
                              "like": "108",
                              "author": "CNET"
                            }
                          ]
                        }
                      }
                    ];*/
                    console.customLog('social.js: createIframe: iframe.onload: isEndOfPage: socialModuleResult: ' + JSON.stringify(socialModuleResult));

                    if (Array.isArray(socialModuleResult)) {
                        if (socialModuleResult.length) {
                            errorMaskObj.removeBitByName(errorMaskObj.errorsBits.SOCIAL_MODULE_RESULT_EMPTY.name);
                        }

                        window.MACRO_COLLECT.data[id].source_url = link;
                        window.MACRO_COLLECT.data[id].data = socialModuleResult;
                        window.MACRO_COLLECT.data[id].profile = socialModule.profile;
                        window.MACRO_COLLECT.data[id].errorMask = errorMaskObj.maskList;
                        window.MACRO_COLLECT.info.currentDataIndex++;
                        if (window.MACRO_COLLECT.options.dataCount == window.MACRO_COLLECT.info.currentDataIndex) {
                            console.customLog('social.js: createIframe: iframe.onload: MACRO_COLLECT: (exit)' + JSON.stringify(window.MACRO_COLLECT));
                            console.customLog('social.js: createIframe: iframe.onload: IFRAME_DATA_READY: true');
                            return exit();
                        }

                    }
                    //console.customLog('SOCIAL-JS: Iframe #' + iframeId + ': MACRO_COLLECT length: ' + window.MACRO_COLLECT.length);
                    //console.customLog('SOCIAL-JS: Iframe #' + iframeId + ': END');
                }
                
                scrollCountCheck++;
                }, 500);// setTimeout
            }
            var scrollLoopId;
            var startScrollLoop = function(iframe) {
                //alert(iframe.id);
                scrollLoopId = setInterval(incrementScroll.bind(null, iframe, datetimeEnd), window.MACRO_COLLECT.options.scrollDelay);
            }
            var iframe = this;
            startScrollLoop(iframe);
            /*var testData = {
                    "a353d41c75a72de2376500ad052c0e63": {
                    "url": "https://twitter.com/search?f=tweets&vertical=default&q=http://www.theguardian.com/us-news/2016/jan/05/obama-gun-control-executive-action-background-checks-licenses-gun-shows-mental-health-funding&src=typd",
                    "data" :
                    [
                        {
                            "author":"@RapidSW",
                            "title":"'Fantastic Beasts': Can a Harry Potter hater enjoy the new movie?",
                            "like": 4,
                            "repost": 3,
                            "date": "1479766513000"
                        },
                        {
                            "author":"@samokspv",
                            "title":"'Fantastic Beasts': Can a Harry Potter hater enjoy the new movie?",
                            "like": 10,
                            "repost": 2,
                            "date": "1479766513000"
                        }
                    ]
                }
            };
            window.MACRO_COLLECT.push(testData);*/
            //alert('PUSH');
        }
    }();

    iframe.src = link;

    iframe.style.position = 'absolute';
    iframe.style.top = '0px';
    iframe.style.zIndex = '10001';
    //iframe.style.height = '800px';
    //iframe.style.width = '600px';
    iframe.style.height = '1080px';
    iframe.style.width = '1920px';
    
    //console.customLog('SOCIAL-JS. Iframe Id: ' + iframeId);
    //console.customLog('SOCIAL-JS. Iframe link: ' + link);

    //var html = '<body>Foo</body>';
    //iframe.src = 'data:text/html;charset=utf-8,' + encodeURI(html);
    if (createNewIframe) {
        document.body.appendChild(iframe);
    }
    ////alert(3);
}

function getDataFromCurrentPage(id, link) {
    console.customLog('social.js: getDataFromCurrentPage');

    progressCounter();

    if (!id/* || !link*/) {
        console.customLog('social.js: getDataFromCurrentPage (error): id: ' + id/* + '; link: ' + link*/);
        return false;
    }
    
    console.customLog('social.js: getDataFromCurrentPage (ok): id: ' + id/* + '; link: ' + link*/);
    
    //errorMaskObj.removeBitByName(errorMaskObj.errorsBits.IFRAME_NOT_CREATED.name);

    /*iframeId = 'social_iframe_' + id;
    var iframe = document.querySelector('#' + iframeId);
    var createNewIframe = false;
    if (!iframe) {
        createNewIframe = true;
        var iframe = document.createElement('iframe');
        iframe.id = iframeId;
        //console.customLog('createNewIframe: ' + iframeId);
    } else {
        //console.customLog('useOldIframe: ' + iframeId);
    }*/

    //iframe.onload = function() {
        //return function() {
            //alert('iframe-onload');
            datetimeStart = new Date();
            datetimeEnd = new Date();
            datetimeEnd.setSeconds(datetimeStart.getSeconds() + window.MACRO_COLLECT.options.totalMaxTime);

            var windowScrollTop = -1;
            var scrollCountCheck = 1;
            var incrementScroll = function incrementScroll(iframe, datetimeEnd) {
                console.customLog('social.js: getDataFromCurrentPage: window.onload: scrolling... : ' + scrollCountCheck);
                progressCounter();

                //alert(iframe.id);
                //var iframe = document.querySelector('#' + iframeId);
                var documentBody = document.body;
                window.scrollBy(0, window.MACRO_COLLECT.options.scrollStep);
                
                // setTimeout
                setTimeout(function() {
                
                var isEndOfPage = (windowScrollTop == documentBody.scrollTop);
                windowScrollTop = documentBody.scrollTop;
                /*var isTimerEnd = (Date.parse(new Date()) >= Date.parse(datetimeEnd));
                if (isTimerEnd) {
                    isEndOfPage = true;
                } else {
                    isEndOfPage = false;
                }*/
                
                if ((window.MACRO_COLLECT.options.scrollCount != 0) && (scrollCountCheck >= window.MACRO_COLLECT.options.scrollCount)) {
                    isEndOfPage = true;
                }/* else {
                    isEndOfPage = false;
                }*/
                
                /*if (!isEndOfPage) {
                    //console.customLog('SOCIAL-JS: Scroll step: ' + scrollCountCheck);
                } else {*/
                if (isEndOfPage) {
                    clearInterval(scrollLoopId);
                    //console.customLog('SOCIAL-JS: Iframe #' + iframeId + ': BEGIN');
                    var socialModuleResult = socialModule
                            .init({
                                //iframeId: iframe.id,
                                method: window.MACRO_COLLECT.options.method
                                /*,iframeLink: link*/
                            })
                            .get();
                    /*Example: socialModuleResult = [
                      {
                        "a353d41c75a72de2376500ad052c0e63": {
                          "url": "https://www.facebook.com/search/top/?q='Fantastic Beasts': Can a Harry Potter hater enjoy the new movie?",
                          "data": [
                            {
                              "date": "1479636907000",
                              "title": "Find out what a Potter superfan and a confused muggle made of the new film set in J.K. Rowling's wizarding world.",
                              "repost": 0,
                              "like": "108",
                              "author": "CNET"
                            }
                          ]
                        }
                      }
                    ];*/
                    console.customLog('social.js: getDataFromCurrentPage: iframe.onload: isEndOfPage: socialModuleResult: ' + JSON.stringify(socialModuleResult));

                    if (Array.isArray(socialModuleResult)) {
                        if (socialModuleResult.length) {
                            errorMaskObj.removeBitByName(errorMaskObj.errorsBits.SOCIAL_MODULE_RESULT_EMPTY.name);
                        }

                        window.MACRO_COLLECT.data[id].source_url = link;
                        window.MACRO_COLLECT.data[id].data = socialModuleResult;
                        window.MACRO_COLLECT.data[id].profile = socialModule.profile;
                        window.MACRO_COLLECT.data[id].errorMask = errorMaskObj.maskList;
                        window.MACRO_COLLECT.info.currentDataIndex++;
                        if (window.MACRO_COLLECT.options.dataCount == window.MACRO_COLLECT.info.currentDataIndex) {
                            console.customLog('social.js: getDataFromCurrentPage: iframe.onload: MACRO_COLLECT: (exit)' + JSON.stringify(window.MACRO_COLLECT));
                            console.customLog('social.js: getDataFromCurrentPage: iframe.onload: IFRAME_DATA_READY: true');
                            return exit();
                        }

                    }
                    //console.customLog('SOCIAL-JS: Iframe #' + iframeId + ': MACRO_COLLECT length: ' + window.MACRO_COLLECT.length);
                    //console.customLog('SOCIAL-JS: Iframe #' + iframeId + ': END');
                }
                
                scrollCountCheck++;
                }, 500);// setTimeout
            }
            var scrollLoopId;
            var startScrollLoop = function(iframe) {
                scrollLoopId = setInterval(incrementScroll.bind(null, iframe, datetimeEnd), window.MACRO_COLLECT.options.scrollDelay);
            }
            var iframe = window;
            startScrollLoop(iframe);
            /*var testData = {
                    "a353d41c75a72de2376500ad052c0e63": {
                    "url": "https://twitter.com/search?f=tweets&vertical=default&q=http://www.theguardian.com/us-news/2016/jan/05/obama-gun-control-executive-action-background-checks-licenses-gun-shows-mental-health-funding&src=typd",
                    "data" :
                    [
                        {
                            "author":"@RapidSW",
                            "title":"'Fantastic Beasts': Can a Harry Potter hater enjoy the new movie?",
                            "like": 4,
                            "repost": 3,
                            "date": "1479766513000"
                        },
                        {
                            "author":"@samokspv",
                            "title":"'Fantastic Beasts': Can a Harry Potter hater enjoy the new movie?",
                            "like": 10,
                            "repost": 2,
                            "date": "1479766513000"
                        }
                    ]
                }
            };
            window.MACRO_COLLECT.push(testData);*/
            //alert('PUSH');
        //}
    //}();

    /*iframe.src = link;

    iframe.style.position = 'absolute';
    iframe.style.top = '0px';
    iframe.style.zIndex = '10001';
    //iframe.style.height = '800px';
    //iframe.style.width = '600px';
    iframe.style.height = '1080px';
    iframe.style.width = '1920px';*/
    
    //console.customLog('SOCIAL-JS. Iframe Id: ' + iframeId);
    //console.customLog('SOCIAL-JS. Iframe link: ' + link);

    //var html = '<body>Foo</body>';
    //iframe.src = 'data:text/html;charset=utf-8,' + encodeURI(html);
    /*if (createNewIframe) {
        document.body.appendChild(iframe);
    }*/
    ////alert(3);
}

function getSocialModule() {
    var hostname = document.location.hostname.replace('www.', '');
    console.customLog('social.js: getSocialModule: hostname: ' + hostname);
    switch(hostname) {
        case 'twitter.com':
            return TW;
            break;
        case 'facebook.com':
            return FB;
            break;
        case 'plus.google.com':
            return GPLUS;
            break;
        default:
            console.customLog('social.js: getSocialModule: hostname is wrong: ' + hostname);
            return localhost;
            break;
    }
}

function progressCounter() {
    if (typeof window.IFRAME_PROGRESS_COUNTER == "undefined") {
        window.IFRAME_PROGRESS_COUNTER = 0;        
    } else {
        window.IFRAME_PROGRESS_COUNTER++;
    }
    console.customLog('social.js: window.IFRAME_PROGRESS_COUNTER: ' + window.IFRAME_PROGRESS_COUNTER);
}

function MACRO_GO() {
    window.SCRAPER_STARTED = true;
    progressCounter();

    if (!window.MACRO_COLLECT) {
        console.customLog('social.js: MACRO_GO(): window.MACRO_COLLECT is undefined');
        return exit();
    }
    if (!Object.keys(window.MACRO_COLLECT.data).length) {
        console.customLog('social.js: MACRO_GO(): window.MACRO_COLLECT.data is empty');
        return exit();
    }

    if (/*(window.MACRO_COLLECT.options.method == 'media_page') && */
        window.MACRO_COLLECT.options.hasOwnProperty('currentDataMd5') &&
        (window.MACRO_COLLECT.options.currentDataMd5 != '')) {
        var searchData = {};
        searchData[window.MACRO_COLLECT.options.currentDataMd5] = window.MACRO_COLLECT.data[window.MACRO_COLLECT.options.currentDataMd5];
    } else {
        var searchData = window.MACRO_COLLECT.data;
    }

    //var intervalId = setInterval(function() {
        ////console.customLog('Search info: try get from: ' + window.MACRO_COLLECT.options.searchLink);
        //if (Object.keys(searchData).length) {
        //    //console.customLog('Search info: OK!');

        //    clearInterval(intervalId);
            // Go to specific social site and 
            // get social data for each title/link
            for (var searchDataKey in searchData) {
            //console.customLog(searchDataKey);
            //[].forEach.call(searchData, function(item) {
                progressCounter();
                
                var item = searchData[searchDataKey];
                if (item.hasOwnProperty(window.MACRO_COLLECT.options.searchField)) {
                    var searchField = item[window.MACRO_COLLECT.options.searchField];
                    
                    errorMaskObj = errorMask.init({
                        id: searchDataKey, 
                        maskList: item.errorMask
                    });

                    errorMaskObj.removeBitByName(errorMaskObj.errorsBits.KEYWORDS_DATA_EMPTY.name);

                    if (window.MACRO_COLLECT.options.searchField == 'source_url') {
                        searchField = fixSourceURL(searchField);
                    }

                    var queryString = '%25QUERY_STRING%25';
                    if (documentLocation && documentLocation.href.indexOf(queryString) !== -1) {
                        var iframeLink = documentLocation.href;
                    } else if (window.MACRO_COLLECT.options.queryUrl && window.MACRO_COLLECT.options.queryUrl.indexOf(queryString) !== -1) {
                        var iframeLink = window.MACRO_COLLECT.options.queryUrl;
                    } else {
                        var iframeLink = '';
                    }

                    /*//01 - Temp code
                    if (iframeLink.indexOf('facebook') !== -1) {
                        queryString = encodeURIComponent(queryString).replace(/%20/g, "+");
                        iframeLink = 'https://www.facebook.com/search/str/' + queryString + '/stories-keyword/stories-opinion';
                    }
                    //01*/

                    if (iframeLink != '') {
                        iframeLink = iframeLink.replace(queryString, searchField);
                    }

                    var createResult = socialModule
                            .init({
                                returnObjOnly: true,
                                method: window.MACRO_COLLECT.options.method
                            })
                            .createIframe(searchDataKey, iframeLink);
                            //.createIframe('call_createIframe_'+(+new Date()), iframeLink);
                    if (createResult == false) {
                        console.customLog('social.js socialModule.createIframe FALSE');
                        return exit();
                    }
                    //errorMaskObj = errorMask.init();
                    //createIframeFromLinksList(searchDataKey, iframeLink);
                    //createIframe(searchDataKey, iframeLink);
                }
            //});
            }
        //}
    //}, 3000);
}

if (window.MACRO_COLLECT.options.hasOwnProperty('autostart') && 
    (window.MACRO_COLLECT.options.autostart != '') &&
    window.hasOwnProperty(window.MACRO_COLLECT.options.autostart)) {
    window[window.MACRO_COLLECT.options.autostart]();
} else {
    MACRO_GO();
}

//=================================
/**
 * Version: 1.0 Alpha-1 
 * Build Date: 13-Nov-2007
 * Copyright (c) 2006-2007, Coolite Inc. (http://www.coolite.com/). All rights reserved.
 * License: Licensed under The MIT License. See license.txt and http://www.datejs.com/license/. 
 * Website: http://www.datejs.com/ or http://www.coolite.com/datejs/
 */
Date.CultureInfo={name:"en-US",englishName:"English (United States)",nativeName:"English (United States)",dayNames:["Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"],abbreviatedDayNames:["Sun","Mon","Tue","Wed","Thu","Fri","Sat"],shortestDayNames:["Su","Mo","Tu","We","Th","Fr","Sa"],firstLetterDayNames:["S","M","T","W","T","F","S"],monthNames:["January","February","March","April","May","June","July","August","September","October","November","December"],abbreviatedMonthNames:["Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"],amDesignator:"AM",pmDesignator:"PM",firstDayOfWeek:0,twoDigitYearMax:2029,dateElementOrder:"mdy",formatPatterns:{shortDate:"M/d/yyyy",longDate:"dddd, MMMM dd, yyyy",shortTime:"h:mm tt",longTime:"h:mm:ss tt",fullDateTime:"dddd, MMMM dd, yyyy h:mm:ss tt",sortableDateTime:"yyyy-MM-ddTHH:mm:ss",universalSortableDateTime:"yyyy-MM-dd HH:mm:ssZ",rfc1123:"ddd, dd MMM yyyy HH:mm:ss GMT",monthDay:"MMMM dd",yearMonth:"MMMM, yyyy"},regexPatterns:{jan:/^jan(uary)?/i,feb:/^feb(ruary)?/i,mar:/^mar(ch)?/i,apr:/^apr(il)?/i,may:/^may/i,jun:/^jun(e)?/i,jul:/^jul(y)?/i,aug:/^aug(ust)?/i,sep:/^sep(t(ember)?)?/i,oct:/^oct(ober)?/i,nov:/^nov(ember)?/i,dec:/^dec(ember)?/i,sun:/^su(n(day)?)?/i,mon:/^mo(n(day)?)?/i,tue:/^tu(e(s(day)?)?)?/i,wed:/^we(d(nesday)?)?/i,thu:/^th(u(r(s(day)?)?)?)?/i,fri:/^fr(i(day)?)?/i,sat:/^sa(t(urday)?)?/i,future:/^next/i,past:/^last|past|prev(ious)?/i,add:/^(\+|after|from)/i,subtract:/^(\-|before|ago)/i,yesterday:/^yesterday/i,today:/^t(oday)?/i,tomorrow:/^tomorrow/i,now:/^n(ow)?/i,millisecond:/^ms|milli(second)?s?/i,second:/^sec(ond)?s?/i,minute:/^min(ute)?s?/i,hour:/^h(ou)?rs?/i,week:/^w(ee)?k/i,month:/^m(o(nth)?s?)?/i,day:/^d(ays?)?/i,year:/^y((ea)?rs?)?/i,shortMeridian:/^(a|p)/i,longMeridian:/^(a\.?m?\.?|p\.?m?\.?)/i,timezone:/^((e(s|d)t|c(s|d)t|m(s|d)t|p(s|d)t)|((gmt)?\s*(\+|\-)\s*\d\d\d\d?)|gmt)/i,ordinalSuffix:/^\s*(st|nd|rd|th)/i,timeContext:/^\s*(\:|a|p)/i},abbreviatedTimeZoneStandard:{GMT:"-000",EST:"-0400",CST:"-0500",MST:"-0600",PST:"-0700"},abbreviatedTimeZoneDST:{GMT:"-000",EDT:"-0500",CDT:"-0600",MDT:"-0700",PDT:"-0800"}};
Date.getMonthNumberFromName=function(name){var n=Date.CultureInfo.monthNames,m=Date.CultureInfo.abbreviatedMonthNames,s=name.toLowerCase();for(var i=0;i<n.length;i++){if(n[i].toLowerCase()==s||m[i].toLowerCase()==s){return i;}}
return-1;};Date.getDayNumberFromName=function(name){var n=Date.CultureInfo.dayNames,m=Date.CultureInfo.abbreviatedDayNames,o=Date.CultureInfo.shortestDayNames,s=name.toLowerCase();for(var i=0;i<n.length;i++){if(n[i].toLowerCase()==s||m[i].toLowerCase()==s){return i;}}
return-1;};Date.isLeapYear=function(year){return(((year%4===0)&&(year%100!==0))||(year%400===0));};Date.getDaysInMonth=function(year,month){return[31,(Date.isLeapYear(year)?29:28),31,30,31,30,31,31,30,31,30,31][month];};Date.getTimezoneOffset=function(s,dst){return(dst||false)?Date.CultureInfo.abbreviatedTimeZoneDST[s.toUpperCase()]:Date.CultureInfo.abbreviatedTimeZoneStandard[s.toUpperCase()];};Date.getTimezoneAbbreviation=function(offset,dst){var n=(dst||false)?Date.CultureInfo.abbreviatedTimeZoneDST:Date.CultureInfo.abbreviatedTimeZoneStandard,p;for(p in n){if(n[p]===offset){return p;}}
return null;};Date.prototype.clone=function(){return new Date(this.getTime());};Date.prototype.compareTo=function(date){if(isNaN(this)){throw new Error(this);}
if(date instanceof Date&&!isNaN(date)){return(this>date)?1:(this<date)?-1:0;}else{throw new TypeError(date);}};Date.prototype.equals=function(date){return(this.compareTo(date)===0);};Date.prototype.between=function(start,end){var t=this.getTime();return t>=start.getTime()&&t<=end.getTime();};Date.prototype.addMilliseconds=function(value){this.setMilliseconds(this.getMilliseconds()+value);return this;};Date.prototype.addSeconds=function(value){return this.addMilliseconds(value*1000);};Date.prototype.addMinutes=function(value){return this.addMilliseconds(value*60000);};Date.prototype.addHours=function(value){return this.addMilliseconds(value*3600000);};Date.prototype.addDays=function(value){return this.addMilliseconds(value*86400000);};Date.prototype.addWeeks=function(value){return this.addMilliseconds(value*604800000);};Date.prototype.addMonths=function(value){var n=this.getDate();this.setDate(1);this.setMonth(this.getMonth()+value);this.setDate(Math.min(n,this.getDaysInMonth()));return this;};Date.prototype.addYears=function(value){return this.addMonths(value*12);};Date.prototype.add=function(config){if(typeof config=="number"){this._orient=config;return this;}
var x=config;if(x.millisecond||x.milliseconds){this.addMilliseconds(x.millisecond||x.milliseconds);}
if(x.second||x.seconds){this.addSeconds(x.second||x.seconds);}
if(x.minute||x.minutes){this.addMinutes(x.minute||x.minutes);}
if(x.hour||x.hours){this.addHours(x.hour||x.hours);}
if(x.month||x.months){this.addMonths(x.month||x.months);}
if(x.year||x.years){this.addYears(x.year||x.years);}
if(x.day||x.days){this.addDays(x.day||x.days);}
return this;};Date._validate=function(value,min,max,name){if(typeof value!="number"){throw new TypeError(value+" is not a Number.");}else if(value<min||value>max){throw new RangeError(value+" is not a valid value for "+name+".");}
return true;};Date.validateMillisecond=function(n){return Date._validate(n,0,999,"milliseconds");};Date.validateSecond=function(n){return Date._validate(n,0,59,"seconds");};Date.validateMinute=function(n){return Date._validate(n,0,59,"minutes");};Date.validateHour=function(n){return Date._validate(n,0,23,"hours");};Date.validateDay=function(n,year,month){return Date._validate(n,1,Date.getDaysInMonth(year,month),"days");};Date.validateMonth=function(n){return Date._validate(n,0,11,"months");};Date.validateYear=function(n){return Date._validate(n,1,9999,"seconds");};Date.prototype.set=function(config){var x=config;if(!x.millisecond&&x.millisecond!==0){x.millisecond=-1;}
if(!x.second&&x.second!==0){x.second=-1;}
if(!x.minute&&x.minute!==0){x.minute=-1;}
if(!x.hour&&x.hour!==0){x.hour=-1;}
if(!x.day&&x.day!==0){x.day=-1;}
if(!x.month&&x.month!==0){x.month=-1;}
if(!x.year&&x.year!==0){x.year=-1;}
if(x.millisecond!=-1&&Date.validateMillisecond(x.millisecond)){this.addMilliseconds(x.millisecond-this.getMilliseconds());}
if(x.second!=-1&&Date.validateSecond(x.second)){this.addSeconds(x.second-this.getSeconds());}
if(x.minute!=-1&&Date.validateMinute(x.minute)){this.addMinutes(x.minute-this.getMinutes());}
if(x.hour!=-1&&Date.validateHour(x.hour)){this.addHours(x.hour-this.getHours());}
if(x.month!==-1&&Date.validateMonth(x.month)){this.addMonths(x.month-this.getMonth());}
if(x.year!=-1&&Date.validateYear(x.year)){this.addYears(x.year-this.getFullYear());}
if(x.day!=-1&&Date.validateDay(x.day,this.getFullYear(),this.getMonth())){this.addDays(x.day-this.getDate());}
if(x.timezone){this.setTimezone(x.timezone);}
if(x.timezoneOffset){this.setTimezoneOffset(x.timezoneOffset);}
return this;};Date.prototype.clearTime=function(){this.setHours(0);this.setMinutes(0);this.setSeconds(0);this.setMilliseconds(0);return this;};Date.prototype.isLeapYear=function(){var y=this.getFullYear();return(((y%4===0)&&(y%100!==0))||(y%400===0));};Date.prototype.isWeekday=function(){return!(this.is().sat()||this.is().sun());};Date.prototype.getDaysInMonth=function(){return Date.getDaysInMonth(this.getFullYear(),this.getMonth());};Date.prototype.moveToFirstDayOfMonth=function(){return this.set({day:1});};Date.prototype.moveToLastDayOfMonth=function(){return this.set({day:this.getDaysInMonth()});};Date.prototype.moveToDayOfWeek=function(day,orient){var diff=(day-this.getDay()+7*(orient||+1))%7;return this.addDays((diff===0)?diff+=7*(orient||+1):diff);};Date.prototype.moveToMonth=function(month,orient){var diff=(month-this.getMonth()+12*(orient||+1))%12;return this.addMonths((diff===0)?diff+=12*(orient||+1):diff);};Date.prototype.getDayOfYear=function(){return Math.floor((this-new Date(this.getFullYear(),0,1))/86400000);};Date.prototype.getWeekOfYear=function(firstDayOfWeek){var y=this.getFullYear(),m=this.getMonth(),d=this.getDate();var dow=firstDayOfWeek||Date.CultureInfo.firstDayOfWeek;var offset=7+1-new Date(y,0,1).getDay();if(offset==8){offset=1;}
var daynum=((Date.UTC(y,m,d,0,0,0)-Date.UTC(y,0,1,0,0,0))/86400000)+1;var w=Math.floor((daynum-offset+7)/7);if(w===dow){y--;var prevOffset=7+1-new Date(y,0,1).getDay();if(prevOffset==2||prevOffset==8){w=53;}else{w=52;}}
return w;};Date.prototype.isDST=function(){/*console.customLog('isDST');*/return this.toString().match(/(E|C|M|P)(S|D)T/)[2]=="D";};Date.prototype.getTimezone=function(){return Date.getTimezoneAbbreviation(this.getUTCOffset,this.isDST());};Date.prototype.setTimezoneOffset=function(s){var here=this.getTimezoneOffset(),there=Number(s)*-6/10;this.addMinutes(there-here);return this;};Date.prototype.setTimezone=function(s){return this.setTimezoneOffset(Date.getTimezoneOffset(s));};Date.prototype.getUTCOffset=function(){var n=this.getTimezoneOffset()*-10/6,r;if(n<0){r=(n-10000).toString();return r[0]+r.substr(2);}else{r=(n+10000).toString();return"+"+r.substr(1);}};Date.prototype.getDayName=function(abbrev){return abbrev?Date.CultureInfo.abbreviatedDayNames[this.getDay()]:Date.CultureInfo.dayNames[this.getDay()];};Date.prototype.getMonthName=function(abbrev){return abbrev?Date.CultureInfo.abbreviatedMonthNames[this.getMonth()]:Date.CultureInfo.monthNames[this.getMonth()];};Date.prototype._toString=Date.prototype.toString;Date.prototype.toString=function(format){var self=this;var p=function p(s){return(s.toString().length==1)?"0"+s:s;};return format?format.replace(/dd?d?d?|MM?M?M?|yy?y?y?|hh?|HH?|mm?|ss?|tt?|zz?z?/g,function(format){switch(format){case"hh":return p(self.getHours()<13?self.getHours():(self.getHours()-12));case"h":return self.getHours()<13?self.getHours():(self.getHours()-12);case"HH":return p(self.getHours());case"H":return self.getHours();case"mm":return p(self.getMinutes());case"m":return self.getMinutes();case"ss":return p(self.getSeconds());case"s":return self.getSeconds();case"yyyy":return self.getFullYear();case"yy":return self.getFullYear().toString().substring(2,4);case"dddd":return self.getDayName();case"ddd":return self.getDayName(true);case"dd":return p(self.getDate());case"d":return self.getDate().toString();case"MMMM":return self.getMonthName();case"MMM":return self.getMonthName(true);case"MM":return p((self.getMonth()+1));case"M":return self.getMonth()+1;case"t":return self.getHours()<12?Date.CultureInfo.amDesignator.substring(0,1):Date.CultureInfo.pmDesignator.substring(0,1);case"tt":return self.getHours()<12?Date.CultureInfo.amDesignator:Date.CultureInfo.pmDesignator;case"zzz":case"zz":case"z":return"";}}):this._toString();};
Date.now=function(){return new Date();};Date.today=function(){return Date.now().clearTime();};Date.prototype._orient=+1;Date.prototype.next=function(){this._orient=+1;return this;};Date.prototype.last=Date.prototype.prev=Date.prototype.previous=function(){this._orient=-1;return this;};Date.prototype._is=false;Date.prototype.is=function(){this._is=true;return this;};Number.prototype._dateElement="day";Number.prototype.fromNow=function(){var c={};c[this._dateElement]=this;return Date.now().add(c);};Number.prototype.ago=function(){var c={};c[this._dateElement]=this*-1;return Date.now().add(c);};(function(){var $D=Date.prototype,$N=Number.prototype;var dx=("sunday monday tuesday wednesday thursday friday saturday").split(/\s/),mx=("january february march april may june july august september october november december").split(/\s/),px=("Millisecond Second Minute Hour Day Week Month Year").split(/\s/),de;var df=function(n){return function(){if(this._is){this._is=false;return this.getDay()==n;}
return this.moveToDayOfWeek(n,this._orient);};};for(var i=0;i<dx.length;i++){$D[dx[i]]=$D[dx[i].substring(0,3)]=df(i);}
var mf=function(n){return function(){if(this._is){this._is=false;return this.getMonth()===n;}
return this.moveToMonth(n,this._orient);};};for(var j=0;j<mx.length;j++){$D[mx[j]]=$D[mx[j].substring(0,3)]=mf(j);}
var ef=function(j){return function(){if(j.substring(j.length-1)!="s"){j+="s";}
return this["add"+j](this._orient);};};var nf=function(n){return function(){this._dateElement=n;return this;};};for(var k=0;k<px.length;k++){de=px[k].toLowerCase();$D[de]=$D[de+"s"]=ef(px[k]);$N[de]=$N[de+"s"]=nf(de);}}());Date.prototype.toJSONString=function(){return this.toString("yyyy-MM-ddThh:mm:ssZ");};Date.prototype.toShortDateString=function(){return this.toString(Date.CultureInfo.formatPatterns.shortDatePattern);};Date.prototype.toLongDateString=function(){return this.toString(Date.CultureInfo.formatPatterns.longDatePattern);};Date.prototype.toShortTimeString=function(){return this.toString(Date.CultureInfo.formatPatterns.shortTimePattern);};Date.prototype.toLongTimeString=function(){return this.toString(Date.CultureInfo.formatPatterns.longTimePattern);};Date.prototype.getOrdinal=function(){switch(this.getDate()){case 1:case 21:case 31:return"st";case 2:case 22:return"nd";case 3:case 23:return"rd";default:return"th";}};
(function(){Date.Parsing={Exception:function(s){this.message="Parse error at '"+s.substring(0,10)+" ...'";}};var $P=Date.Parsing;var _=$P.Operators={rtoken:function(r){return function(s){var mx=s.match(r);if(mx){return([mx[0],s.substring(mx[0].length)]);}else{throw new $P.Exception(s);}};},token:function(s){return function(s){return _.rtoken(new RegExp("^\s*"+s+"\s*"))(s);};},stoken:function(s){return _.rtoken(new RegExp("^"+s));},until:function(p){return function(s){var qx=[],rx=null;while(s.length){try{rx=p.call(this,s);}catch(e){qx.push(rx[0]);s=rx[1];continue;}
break;}
return[qx,s];};},many:function(p){return function(s){var rx=[],r=null;while(s.length){try{r=p.call(this,s);}catch(e){return[rx,s];}
rx.push(r[0]);s=r[1];}
return[rx,s];};},optional:function(p){return function(s){var r=null;try{r=p.call(this,s);}catch(e){return[null,s];}
return[r[0],r[1]];};},not:function(p){return function(s){try{p.call(this,s);}catch(e){return[null,s];}
throw new $P.Exception(s);};},ignore:function(p){return p?function(s){var r=null;r=p.call(this,s);return[null,r[1]];}:null;},product:function(){var px=arguments[0],qx=Array.prototype.slice.call(arguments,1),rx=[];for(var i=0;i<px.length;i++){rx.push(_.each(px[i],qx));}
return rx;},cache:function(rule){var cache={},r=null;return function(s){try{r=cache[s]=(cache[s]||rule.call(this,s));}catch(e){r=cache[s]=e;}
if(r instanceof $P.Exception){throw r;}else{return r;}};},any:function(){var px=arguments;return function(s){var r=null;for(var i=0;i<px.length;i++){if(px[i]==null){continue;}
try{r=(px[i].call(this,s));}catch(e){r=null;}
if(r){return r;}}
throw new $P.Exception(s);};},each:function(){var px=arguments;return function(s){var rx=[],r=null;for(var i=0;i<px.length;i++){if(px[i]==null){continue;}
try{r=(px[i].call(this,s));}catch(e){throw new $P.Exception(s);}
rx.push(r[0]);s=r[1];}
return[rx,s];};},all:function(){var px=arguments,_=_;return _.each(_.optional(px));},sequence:function(px,d,c){d=d||_.rtoken(/^\s*/);c=c||null;if(px.length==1){return px[0];}
return function(s){var r=null,q=null;var rx=[];for(var i=0;i<px.length;i++){try{r=px[i].call(this,s);}catch(e){break;}
rx.push(r[0]);try{q=d.call(this,r[1]);}catch(ex){q=null;break;}
s=q[1];}
if(!r){throw new $P.Exception(s);}
if(q){throw new $P.Exception(q[1]);}
if(c){try{r=c.call(this,r[1]);}catch(ey){throw new $P.Exception(r[1]);}}
return[rx,(r?r[1]:s)];};},between:function(d1,p,d2){d2=d2||d1;var _fn=_.each(_.ignore(d1),p,_.ignore(d2));return function(s){var rx=_fn.call(this,s);return[[rx[0][0],r[0][2]],rx[1]];};},list:function(p,d,c){d=d||_.rtoken(/^\s*/);c=c||null;return(p instanceof Array?_.each(_.product(p.slice(0,-1),_.ignore(d)),p.slice(-1),_.ignore(c)):_.each(_.many(_.each(p,_.ignore(d))),px,_.ignore(c)));},set:function(px,d,c){d=d||_.rtoken(/^\s*/);c=c||null;return function(s){var r=null,p=null,q=null,rx=null,best=[[],s],last=false;for(var i=0;i<px.length;i++){q=null;p=null;r=null;last=(px.length==1);try{r=px[i].call(this,s);}catch(e){continue;}
rx=[[r[0]],r[1]];if(r[1].length>0&&!last){try{q=d.call(this,r[1]);}catch(ex){last=true;}}else{last=true;}
if(!last&&q[1].length===0){last=true;}
if(!last){var qx=[];for(var j=0;j<px.length;j++){if(i!=j){qx.push(px[j]);}}
p=_.set(qx,d).call(this,q[1]);if(p[0].length>0){rx[0]=rx[0].concat(p[0]);rx[1]=p[1];}}
if(rx[1].length<best[1].length){best=rx;}
if(best[1].length===0){break;}}
if(best[0].length===0){return best;}
if(c){try{q=c.call(this,best[1]);}catch(ey){throw new $P.Exception(best[1]);}
best[1]=q[1];}
return best;};},forward:function(gr,fname){return function(s){return gr[fname].call(this,s);};},replace:function(rule,repl){return function(s){var r=rule.call(this,s);return[repl,r[1]];};},process:function(rule,fn){return function(s){var r=rule.call(this,s);return[fn.call(this,r[0]),r[1]];};},min:function(min,rule){return function(s){var rx=rule.call(this,s);if(rx[0].length<min){throw new $P.Exception(s);}
return rx;};}};var _generator=function(op){return function(){var args=null,rx=[];if(arguments.length>1){args=Array.prototype.slice.call(arguments);}else if(arguments[0]instanceof Array){args=arguments[0];}
if(args){for(var i=0,px=args.shift();i<px.length;i++){args.unshift(px[i]);rx.push(op.apply(null,args));args.shift();return rx;}}else{return op.apply(null,arguments);}};};var gx="optional not ignore cache".split(/\s/);for(var i=0;i<gx.length;i++){_[gx[i]]=_generator(_[gx[i]]);}
var _vector=function(op){return function(){if(arguments[0]instanceof Array){return op.apply(null,arguments[0]);}else{return op.apply(null,arguments);}};};var vx="each any all".split(/\s/);for(var j=0;j<vx.length;j++){_[vx[j]]=_vector(_[vx[j]]);}}());(function(){var flattenAndCompact=function(ax){var rx=[];for(var i=0;i<ax.length;i++){if(ax[i]instanceof Array){rx=rx.concat(flattenAndCompact(ax[i]));}else{if(ax[i]){rx.push(ax[i]);}}}
return rx;};Date.Grammar={};Date.Translator={hour:function(s){return function(){this.hour=Number(s);};},minute:function(s){return function(){this.minute=Number(s);};},second:function(s){return function(){this.second=Number(s);};},meridian:function(s){return function(){this.meridian=s.slice(0,1).toLowerCase();};},timezone:function(s){return function(){var n=s.replace(/[^\d\+\-]/g,"");if(n.length){this.timezoneOffset=Number(n);}else{this.timezone=s.toLowerCase();}};},day:function(x){var s=x[0];return function(){this.day=Number(s.match(/\d+/)[0]);};},month:function(s){return function(){this.month=((s.length==3)?Date.getMonthNumberFromName(s):(Number(s)-1));};},year:function(s){return function(){var n=Number(s);this.year=((s.length>2)?n:(n+(((n+2000)<Date.CultureInfo.twoDigitYearMax)?2000:1900)));};},rday:function(s){return function(){switch(s){case"yesterday":this.days=-1;break;case"tomorrow":this.days=1;break;case"today":this.days=0;break;case"now":this.days=0;this.now=true;break;}};},finishExact:function(x){x=(x instanceof Array)?x:[x];var now=new Date();this.year=now.getFullYear();this.month=now.getMonth();this.day=1;this.hour=0;this.minute=0;this.second=0;for(var i=0;i<x.length;i++){if(x[i]){x[i].call(this);}}
this.hour=(this.meridian=="p"&&this.hour<13)?this.hour+12:this.hour;if(this.day>Date.getDaysInMonth(this.year,this.month)){throw new RangeError(this.day+" is not a valid value for days.");}
var r=new Date(this.year,this.month,this.day,this.hour,this.minute,this.second);if(this.timezone){r.set({timezone:this.timezone});}else if(this.timezoneOffset){r.set({timezoneOffset:this.timezoneOffset});}
return r;},finish:function(x){x=(x instanceof Array)?flattenAndCompact(x):[x];if(x.length===0){return null;}
for(var i=0;i<x.length;i++){if(typeof x[i]=="function"){x[i].call(this);}}
if(this.now){return new Date();}
var today=Date.today();var method=null;var expression=!!(this.days!=null||this.orient||this.operator);if(expression){var gap,mod,orient;orient=((this.orient=="past"||this.operator=="subtract")?-1:1);if(this.weekday){this.unit="day";gap=(Date.getDayNumberFromName(this.weekday)-today.getDay());mod=7;this.days=gap?((gap+(orient*mod))%mod):(orient*mod);}
if(this.month){this.unit="month";gap=(this.month-today.getMonth());mod=12;this.months=gap?((gap+(orient*mod))%mod):(orient*mod);this.month=null;}
if(!this.unit){this.unit="day";}
if(this[this.unit+"s"]==null||this.operator!=null){if(!this.value){this.value=1;}
if(this.unit=="week"){this.unit="day";this.value=this.value*7;}
this[this.unit+"s"]=this.value*orient;}
return today.add(this);}else{if(this.meridian&&this.hour){this.hour=(this.hour<13&&this.meridian=="p")?this.hour+12:this.hour;}
if(this.weekday&&!this.day){this.day=(today.addDays((Date.getDayNumberFromName(this.weekday)-today.getDay()))).getDate();}
if(this.month&&!this.day){this.day=1;}
return today.set(this);}}};var _=Date.Parsing.Operators,g=Date.Grammar,t=Date.Translator,_fn;g.datePartDelimiter=_.rtoken(/^([\s\-\.\,\/\x27]+)/);g.timePartDelimiter=_.stoken(":");g.whiteSpace=_.rtoken(/^\s*/);g.generalDelimiter=_.rtoken(/^(([\s\,]|at|on)+)/);var _C={};g.ctoken=function(keys){var fn=_C[keys];if(!fn){var c=Date.CultureInfo.regexPatterns;var kx=keys.split(/\s+/),px=[];for(var i=0;i<kx.length;i++){px.push(_.replace(_.rtoken(c[kx[i]]),kx[i]));}
fn=_C[keys]=_.any.apply(null,px);}
return fn;};g.ctoken2=function(key){return _.rtoken(Date.CultureInfo.regexPatterns[key]);};g.h=_.cache(_.process(_.rtoken(/^(0[0-9]|1[0-2]|[1-9])/),t.hour));g.hh=_.cache(_.process(_.rtoken(/^(0[0-9]|1[0-2])/),t.hour));g.H=_.cache(_.process(_.rtoken(/^([0-1][0-9]|2[0-3]|[0-9])/),t.hour));g.HH=_.cache(_.process(_.rtoken(/^([0-1][0-9]|2[0-3])/),t.hour));g.m=_.cache(_.process(_.rtoken(/^([0-5][0-9]|[0-9])/),t.minute));g.mm=_.cache(_.process(_.rtoken(/^[0-5][0-9]/),t.minute));g.s=_.cache(_.process(_.rtoken(/^([0-5][0-9]|[0-9])/),t.second));g.ss=_.cache(_.process(_.rtoken(/^[0-5][0-9]/),t.second));g.hms=_.cache(_.sequence([g.H,g.mm,g.ss],g.timePartDelimiter));g.t=_.cache(_.process(g.ctoken2("shortMeridian"),t.meridian));g.tt=_.cache(_.process(g.ctoken2("longMeridian"),t.meridian));g.z=_.cache(_.process(_.rtoken(/^(\+|\-)?\s*\d\d\d\d?/),t.timezone));g.zz=_.cache(_.process(_.rtoken(/^(\+|\-)\s*\d\d\d\d/),t.timezone));g.zzz=_.cache(_.process(g.ctoken2("timezone"),t.timezone));g.timeSuffix=_.each(_.ignore(g.whiteSpace),_.set([g.tt,g.zzz]));g.time=_.each(_.optional(_.ignore(_.stoken("T"))),g.hms,g.timeSuffix);g.d=_.cache(_.process(_.each(_.rtoken(/^([0-2]\d|3[0-1]|\d)/),_.optional(g.ctoken2("ordinalSuffix"))),t.day));g.dd=_.cache(_.process(_.each(_.rtoken(/^([0-2]\d|3[0-1])/),_.optional(g.ctoken2("ordinalSuffix"))),t.day));g.ddd=g.dddd=_.cache(_.process(g.ctoken("sun mon tue wed thu fri sat"),function(s){return function(){this.weekday=s;};}));g.M=_.cache(_.process(_.rtoken(/^(1[0-2]|0\d|\d)/),t.month));g.MM=_.cache(_.process(_.rtoken(/^(1[0-2]|0\d)/),t.month));g.MMM=g.MMMM=_.cache(_.process(g.ctoken("jan feb mar apr may jun jul aug sep oct nov dec"),t.month));g.y=_.cache(_.process(_.rtoken(/^(\d\d?)/),t.year));g.yy=_.cache(_.process(_.rtoken(/^(\d\d)/),t.year));g.yyy=_.cache(_.process(_.rtoken(/^(\d\d?\d?\d?)/),t.year));g.yyyy=_.cache(_.process(_.rtoken(/^(\d\d\d\d)/),t.year));_fn=function(){return _.each(_.any.apply(null,arguments),_.not(g.ctoken2("timeContext")));};g.day=_fn(g.d,g.dd);g.month=_fn(g.M,g.MMM);g.year=_fn(g.yyyy,g.yy);g.orientation=_.process(g.ctoken("past future"),function(s){return function(){this.orient=s;};});g.operator=_.process(g.ctoken("add subtract"),function(s){return function(){this.operator=s;};});g.rday=_.process(g.ctoken("yesterday tomorrow today now"),t.rday);g.unit=_.process(g.ctoken("minute hour day week month year"),function(s){return function(){this.unit=s;};});g.value=_.process(_.rtoken(/^\d\d?(st|nd|rd|th)?/),function(s){return function(){this.value=s.replace(/\D/g,"");};});g.expression=_.set([g.rday,g.operator,g.value,g.unit,g.orientation,g.ddd,g.MMM]);_fn=function(){return _.set(arguments,g.datePartDelimiter);};g.mdy=_fn(g.ddd,g.month,g.day,g.year);g.ymd=_fn(g.ddd,g.year,g.month,g.day);g.dmy=_fn(g.ddd,g.day,g.month,g.year);g.date=function(s){return((g[Date.CultureInfo.dateElementOrder]||g.mdy).call(this,s));};g.format=_.process(_.many(_.any(_.process(_.rtoken(/^(dd?d?d?|MM?M?M?|yy?y?y?|hh?|HH?|mm?|ss?|tt?|zz?z?)/),function(fmt){if(g[fmt]){return g[fmt];}else{throw Date.Parsing.Exception(fmt);}}),_.process(_.rtoken(/^[^dMyhHmstz]+/),function(s){return _.ignore(_.stoken(s));}))),function(rules){return _.process(_.each.apply(null,rules),t.finishExact);});var _F={};var _get=function(f){return _F[f]=(_F[f]||g.format(f)[0]);};g.formats=function(fx){if(fx instanceof Array){var rx=[];for(var i=0;i<fx.length;i++){rx.push(_get(fx[i]));}
return _.any.apply(null,rx);}else{return _get(fx);}};g._formats=g.formats(["yyyy-MM-ddTHH:mm:ss","ddd, MMM dd, yyyy H:mm:ss tt","ddd MMM d yyyy HH:mm:ss zzz","d"]);g._start=_.process(_.set([g.date,g.time,g.expression],g.generalDelimiter,g.whiteSpace),t.finish);g.start=function(s){try{var r=g._formats.call({},s);if(r[1].length===0){return r;}}catch(e){}
return g._start.call({},s);};}());Date._parse=Date.parse;Date.parse=function(s){var r=null;if(!s){return null;}
try{r=Date.Grammar.start.call({},s);}catch(e){return null;}
return((r[1].length===0)?r[0]:null);};Date.getParseFunction=function(fx){var fn=Date.Grammar.formats(fx);return function(s){var r=null;try{r=fn.call({},s);}catch(e){return null;}
return((r[1].length===0)?r[0]:null);};};Date.parseExact=function(s,fx){return Date.getParseFunction(fx)(s);};

function getChromeVersion() {
  var match = navigator.appVersion.match(/.*Chrome\/([0-9\.]+)/);
  return match ? match[1] : null;
}