#!/bin/bash
#
#
#
# Configuring /etc/hosts
#
#
#
hosts=$(cat /etc/hosts)
hosts_original=$(cat /etc/hosts)
hosts_mod=0
echo "$hosts"
if [[ "$hosts" == *"127.0.0.2     user_proxy"* && "$hosts" == *"127.0.0.1     resolver"* ]]; then
    echo 'File /etc/hosts is already configured to the required state'
    hosts=$(cat /etc/hosts)
elif [[ "$hosts" != *"127.0.0.2     user_proxy"* && "$hosts" != *"127.0.0.1     resolver"* ]];then
    echo 'File /etc/hosts is not configured to the required state. Configuring (Initiall statre will be restored once test is finished)'
    echo "127.0.0.1	resolver" | sudo tee -a /etc/hosts
    echo "127.0.0.2	user_proxy" | sudo tee -a /etc/hosts
    ((hosts_mod+=3))
    hosts=$(cat /etc/hosts)
elif [[ "$hosts" != *"127.0.0.2     user_proxy"* ]];then
    echo 'File /etc/hosts is not configured to the required state. Configuring (Initiall statre will be restored once test is finished)'
    echo "127.0.0.2	user_proxy" | sudo tee -a /etc/hosts
    ((hosts_mod+=1))
    hosts=$(cat /etc/hosts)
elif [[ "$hosts" != *"127.0.0.1     resolver"* ]];then
    echo 'File /etc/hosts is not configured to the required state. Configuring (Initiall statre will be restored once test is finished)'
    echo "127.0.0.1	resolver" | sudo tee -a /etc/hosts
    ((hosts_mod+=2))
    hosts=$(cat /etc/hosts)
fi
echo "$hosts_mod"
#
#
#
# SETTING UP APACHE2 SERVER TO RUN CURRENT TEST
#
#
#
items=$(sudo apache2ctl -S)

count=0
disableid=0
array_conf=()
arrcount=1

file="localhost_127.conf"
file2="user_proxy.conf"
curdir="/home/hce/trunk/api/python/ftests"
confdir="$curdir/properties/test_apache"
#confdir=$curdir
apachedirav="/etc/apache2/sites-available"

for item in $items
do
    ((count+=1))
    #echo $count $item
    if [[ "$count" != "$disableid" ]]; then
        if [[ "$item" == "127.0.0.1:*" || "$item" == "*:80" || "$item" == "*" || "$item" == *":80"* || "$item" == *":2222"* ]]; then
            ((disableid=count+2))
            #echo "Disable host filename on line: $disableid"
        fi
    else
#        echo "Disabling host on line $disableid"
        disable=$(echo "$item" | cut -d'/' -f 5)
        disable=$(echo "${disable:0:-3}")
#        echo "$disable"
        sudo a2dissite "$disable"
        sudo systemctl reload apache2
        array_conf[$arrcount]="$disable"
        ((arrcount+=1))
    fi
done
echo ''
echo ''
echo 'Disabling configurations that might interrupt with test'
echo ''
for itemm in ${array_conf[*]}
do
    echo "Disabling Apache2 config: $itemm"
    sudo a2dissite "$itemm"
done
echo ''
echo ''
echo 'Reloading Apache2 server'
sudo systemctl reload apache2
echo ''
echo ''
echo 'Enabling required configurations for current test'
echo ''
echo ''
#Enable properties_localhost_127.conf
sudo cp "$confdir/$file" "$apachedirav/properties_$file"
sudo a2ensite "properties_$file"
#Enable properties_user_proxy.conf
#sudo cp "$confdir/$file2" "$apachedirav/properties_$file2"
#sudo a2ensite "properties_$file2"
#--------------------------------------------------------
echo ''
echo ''
echo 'Reloading Apache2 server'
sudo systemctl reload apache2
echo ''
echo ''
echo 'Apache2 is configured to run current test. Launching test'
#
#
#exit 0
#
function ctrl_c()
{
echo 'Test interrupted by Ctrl+C. Restoring initial apache2 configuration'
#Disable properties_localhost_127.conf
sudo a2dissite "properties_$file"
sudo rm "$apachedirav/properties_$file"
#--------------------------------------------------------
echo ''
echo ''
echo 'Reloading Apache2 server'
sudo systemctl reload apache2
echo ''
echo ''
echo 'Enabling configurations that were disabled previously'
echo ''
for itemm in ${array_conf[*]}
do
    echo "Enabling Apache2 config: $itemm"
    sudo a2ensite "$itemm"
    sudo systemctl reload apache2
done
echo ''
echo ''
echo 'Reloading Apache2 server'
sudo systemctl reload apache2
echo ''
echo ''
echo 'Initial apache2 configuration has been restored'
echo ''
echo ''
if [[ "$hosts_mod" != "0" ]]; then
    echo "Restirong initial /etc/hosts configuration"
    echo "$hosts_original" | sudo tee /etc/hosts
else
    echo '/etc/hosts was not modified'
fi
echo ''
exit 0
}
trap ctrl_c INT
#
#
#
# Copying nessesary files to /var/www/html
#
#
#
cd /home/hce/trunk/api/python/data/ftests
movedDataFiles=0
if [[ ! -d "/var/www/html/properties" || ! -d "/var/www/html/python_cgi" || ! -d "/var/www/html/charsets" || ! -d "/var/www/html/check_date_formats" ]]; then
    ((movedDataFiles+=1));
    echo "Moved data files: $movedDataFiles"
    sudo cp -fr test_properties_data/* /var/www/html
    sudo mv /var/www/html/properties/SOCIAL_TWITTER /var/www/html/twitter_soc
    cd "$curdir"
fi
#
#
#
# !!! IMPORTANT !!!
# Exit codes for your tests: 1 - test fail, 0 - test success
errorss=0
#
#
#
#
# Property - PDATE_TIME
#
#
#
echo ''
echo -e '\e[1;33mStarting test for property: PDATE_TIME\e[0m' #-- put your propertie's names here

cd /home/hce/trunk/api/python/ftests/properties/PDATE_TIME #-- go to your test's directory
./test_PDATE_TIME.sh #-- run test
if [[ $? == 1 ]]; then #-- check exit code
    echo ''
    echo -e "\e[1;31mTest for PDATE_TIME property - FAIL\e[0m"
    ((errorss+=1))
    echo ''
elif [[ $? == 0 ]]; then
    echo ''
    echo -e "\e[1;32mTest for PDATE_TIME property - SUCCESS\e[0m"
    echo ''
fi
echo "$errorss"

#
#
#
# Property = PDATE_DAY_MONTH_ORDER
#
#
#
echo ''
echo -e '\e[1;33mStarting test for property: PDATE_DAY_MONTH_ORDER\e[0m' #-- put your propertie's names here

cd /home/hce/trunk/api/python/ftests/properties/PDATE_DAY_MONTH_ORDER #-- go to your test's directory
./test_PDATE_DAY_MONTH_ORDER.sh #-- run test
if [[ $? == 1 ]]; then
    echo ''
    echo -e "\e[1;31mTest for PDATE_DAY_MONTH_ORDER property - FAIL\e[0m"
    ((errorss+=1))
    echo ''
elif [[ $? == 0 ]]; then
    echo ''
    echo -e "\e[1;32mTest for PDATE_DAY_MONTH_ORDER property - SUCCESS\e[0m"
    echo ''
fi
echo "$errorss"

#
#
#
# Property = HTML_CANONICAL_REDIRECT
#
#
#
echo ''
echo -e '\e[1;33mStarting test for property: HTML_CANONICAL_REDIRECT\e[0m' #-- put your propertie's names here

cd /home/hce/trunk/api/python/ftests/properties/HTML_CANONICAL_REDIRECT #-- go to your test's directory
./test_HTML_CANONICAL_REDIRECT.sh #-- run test
if [[ $? == 1 ]]; then #-- check exit code
    echo ''
    echo -e "\e[1;31mTest for HTML_CANONICAL_REDIRECT property - FAIL\e[0m"
    ((errorss+=1))
    echo ''
elif [[ $? == 0 ]]; then
    echo ''
    echo -e "\e[1;32mTest for HTML_CANONICAL_REDIRECT property - SUCCESS\e[0m"
    echo ''
fi
echo "$errorss"

#
#
#
# Property = URL_LOGGING
#
#
#
echo ''
echo -e '\e[1;33mStarting test for property: URL_LOGGING\e[0m' #-- put your propertie's names here

cd /home/hce/trunk/api/python/ftests/properties/URL_LOGGING #-- go to your test's directory
./URL_LOGGING.sh #-- run test
if [[ $? == 1 ]]; then #-- check exit code
    echo ''
    echo -e "\e[1;31mTest for URL_LOGGING property - FAIL\e[0m"
    ((errorss+=1))
    echo ''
elif [[ $? == 0 ]]; then
    echo ''
    echo -e "\e[1;32mTest for URL_LOGGING property - SUCCESS\e[0m"
    echo ''
fi
echo "$errorss"

#
#
#
# Property - COLLECT_URLS_XPATH_LIST
#
#
#
echo ''
echo -e '\e[1;33mStarting test for property: COLLECT_URLS_XPATH_LIST\e[0m' #-- put your propertie's names here

cd /home/hce/trunk/api/python/ftests/properties/COLLECT_URLS_XPATH_LIST #-- go to your test's directory
./COLLECT_URLS_XPATH_LIST.sh #-- run test
if [[ $? = 0 ]]; then #-- check exit code
    echo ''
    echo -e "\e[1;32mTest for COLLECT_URLS_XPATH_LIST property - SUCCESS\e[0m"
    echo ''
else
    echo ''
    echo -e "\e[1;31mTest for COLLECT_URLS_XPATH_LIST property - FAIL\e[0m"
    echo ''
    ((errorss+=1))
fi
echo "$errorss"

#
#
#
# Property - HTTP_REDIRECT_RESOLVER
#
#
#
echo ''
echo -e '\e[1;33mStarting test for property: HTTP_REDIRECT_RESOLVER\e[0m' #-- put your propertie's names here

cd /home/hce/trunk/api/python/ftests/properties/HTTP_REDIRECT_RESOLVER #-- go to your test's directory
./HTTP_REDIRECT_RESOLVER.sh #-- run test
if [[ $? = 0 ]]; then #-- check exit code
    echo ''
    echo -e "\e[1;32mTest for HTTP_REDIRECT_RESOLVER property - SUCCESS\e[0m"
    echo ''
else
    echo ''
    echo -e "\e[1;31mTest for HTTP_REDIRECT_RESOLVER property - FAIL\e[0m"
    echo ''
    ((errorss+=1))
fi
echo "$errorss"

#
#
#
# Property - PROCESSED_CONTENTS_TAGS_LIMITS
#
#
#
echo ''
echo -e '\e[1;33mStarting test for property: PROCESSED_CONTENTS_TAGS_LIMITS\e[0m' #-- put your propertie's names here

cd /home/hce/trunk/api/python/ftests/properties/PROCESSED_CONTENTS_TAGS_LIMITS #-- go to your test's directory
./BATCH_PROCESSED_CONTENT_TAGS_LIMIT.sh #-- run test
if [[ $? = 0 ]]; then #-- check exit code
    echo ''
    echo -e "\e[1;32mTest for PROCESSED_CONTENTS_TAGS_LIMITS property - SUCCESS\e[0m"
    echo ''
else
    echo ''
    echo -e "\e[1;31mTest for PROCESSED_CONTENTS_TAGS_LIMITS property - FAIL\e[0m"
    echo ''
    ((errorss+=1))

fi
echo "$errorss"

#
#
#
# Properties - SQL_EXPRESSION_FIELDS_UPDATE_CRAWLER
#
#
#
echo ''
echo -e '\e[1;33mStarting test for properties: SQL_EXPRESSION_FIELDS_UPDATE_CRAWLER\e[0m' #-- put your propertie's names here

cd /home/hce/trunk/api/python/ftests/properties/SQL_EXPRESSION_FIELDS_UPDATE_CRAWLER #-- go to your test's directory
./test_SQL_EXPRESSION_FIELDS_UPDATE_CRAWLER.sh #-- run test
if [[ $? == 1 ]]; then #-- check exit code
     echo ''
     echo -e "\e[1;31mTest for SQL_EXPRESSION_FIELDS_UPDATE_CRAWLER properties - FAIL\e[0m"
     echo ''
elif [[ $? == 0 ]]; then
     echo ''
     echo -e "\e[1;32mTest for SQL_EXPRESSION_FIELDS_UPDATE_CRAWLER properties - SUCCESS\e[0m"
     echo ''
fi
echo "$errorss"

#
#
#
# Properties - SQL_EXPRESSION_FIELDS_UPDATE_PROCESSOR_AND_CRAWLER
#
#
#
echo ''
echo -e '\e[1;33mStarting test for properties: SQL_EXPRESSION_FIELDS_UPDATE_PROCESSOR_AND_CRAWLER\e[0m' #-- put your propertie's names here

cd /home/hce/trunk/api/python/ftests/properties/SQL_EXPRESSION_FIELDS_UPDATE_PROCESSOR_AND_CRAWLER #-- go to your test's directory
./test_SQL_EXPRESSION_FIELDS_UPDATE_PROCESSOR_AND_CRAWLER.sh #-- run test
if [[ $? == 1 ]]; then #-- check exit code
     echo ''
     echo -e "\e[1;31mTest for SQL_EXPRESSION_FIELDS_UPDATE_PROCESSOR_AND_CRAWLER properties - FAIL\e[0m"
     ((errorss+=1))
     echo ''
elif [[ $? == 0 ]]; then
     echo ''
     echo -e "\e[1;32mTest for SQL_EXPRESSION_FIELDS_UPDATE_PROCESSOR_AND_CRAWLER properties - SUCCESS\e[0m"
     echo ''
fi
echo "$errorss"

#
#
#
# Property - SCRAPER_TAGS_VALIDATION
#
#
#
echo ''
echo -e '\e[1;33mStarting test for property: SCRAPER_TAGS_VALIDATION\e[0m' #-- put your propertie's names here

cd /home/hce/trunk/api/python/ftests/properties/SCRAPER_TAGS_VALIDATION #-- go to your test's directory
./test_SCRAPER_TAGS_VALIDATION.sh #-- run test
if [[ $? == 1 ]]; then #-- check exit code
     echo ''
     echo -e "\e[1;31mTest for SCRAPER_TAGS_VALIDATION property - FAIL\e[0m"
     ((errorss+=1))
     echo ''
elif [[ $? == 0 ]]; then
     echo ''
     echo -e "\e[1;32mTest for SCRAPER_TAGS_VALIDATION property - SUCCESS\e[0m"
     echo ''
fi
echo "$errorss"

#
#
#
# Property - HTTP_FREQ_LIMITS
#
#
#
echo ''
echo -e '\e[1;33mStarting test for property: HTTP_FREQ_LIMITS\e[0m' #-- put your propertie's names here

cd /home/hce/trunk/api/python/ftests/properties/HTTP_FREQ_LIMITS #-- go to your test's directory
./test_HTTP_FREQ_LIMITS.sh #-- run test
if [[ $? == 1 ]]; then #-- check exit code
     echo ''
     echo -e "\e[1;31mTest for HTTP_FREQ_LIMITS property - FAIL\e[0m"
     ((errorss+=1))
     echo ''
elif [[ $? == 0 ]]; then
     echo ''
     echo -e "\e[1;32mTest for HTTP_FREQ_LIMITS property - SUCCESS\e[0m"
     echo ''
fi
echo "$errorss"

#
#
#
# Property - DETECT_MODIFIED
#
#
#
echo ''
echo -e '\e[1;33mStarting test for property: DETECT_MODIFIED\e[0m' #-- put your propertie's names here

cd /home/hce/trunk/api/python/ftests/properties/DETECT_MODIFIED #-- go to your test's directory
./test_DETECT_MODIFIED.sh #-- run test
if [[ $? == 1 ]]; then #-- check exit code
     echo ''
     echo -e "\e[1;31mTest for DETECT_MODIFIED property - FAIL\e[0m"
     ((errorss+=1))
     echo ''
elif [[ $? == 0 ]]; then
     echo ''
     echo -e "\e[1;32mTest for DETECT_MODIFIED property - SUCCESS\e[0m"
     echo ''
fi
echo "$errorss"

#
#
#
# Property - DETECT_MODIFIED check ETAG
#
#
#
echo ''
echo -e '\e[1;33mStarting test for property: DETECT_MODIFIED check ETAG\e[0m' #-- put your propertie's names here

cd /home/hce/trunk/api/python/ftests/properties/DETECT_MODIFIED #-- go to your test's directory
./cgi_etag.sh #-- run test
if [[ $? == 1 ]]; then #-- check exit code
     echo ''
     echo -e "\e[1;31mTest for DETECT_MODIFIED property - FAIL\e[0m"
     echo ''
elif [[ $? == 0 ]]; then
     echo ''
     echo -e "\e[1;32mTest for DETECT_MODIFIED property - SUCCESS\e[0m"
     echo ''
fi
echo "$errorss"

#
#
#
# Property - USER_PROXY
#
#
#
echo ''
echo -e '\e[1;33mStarting test for property: USER_PROXY\e[0m' #-- put your propertie's names here

cd /home/hce/trunk/api/python/ftests/properties/USER_PROXY #-- go to your test's directory
./test_USER_PROXY.sh #-- run test
if [[ $? == 1 ]]; then #-- check exit code
    echo ''
    echo -e "\e[1;31mTest for USER_PROXY property - FAIL\e[0m"
    ((errorss+=1))
    echo ''
elif [[ $? == 0 ]]; then
    echo ''
    echo -e "\e[1;32mTest for USER_PROXY property - SUCCESS\e[0m"
    echo ''
fi
echo "$errorss"

#
#
#
# Check pubdate "latimes.com"
#
#
#
echo ''
echo -e '\e[1;33mStarting test for check pubdate "latimes.com"\e[0m'

cd /home/hce/trunk/api/python/ftests/check_date_formats #-- go to your test's directory
./check_date_formats.sh #-- run test
if [[ $? == 1 ]]; then #-- check exit code
     echo ''
     echo -e "\e[1;31mTest for check pubdate 'latimes.com' - FAIL\e[0m"
     ((errorss+=1))
     echo ''
elif [[ $? == 0 ]]; then
     echo ''
     echo -e "\e[1;32mTest for check pubdate 'latimes.com' - SUCCESS\e[0m"
     echo ''
fi
echo "$errorss"

#
#
#
# Test for social data quality filters
#
#
#
echo ''
echo -e '\e[1;33mStarting test for social data filters quality\e[0m'

cd /home/hce/trunk/api/python/ftests/properties/SOCIAL_TWITTER #-- go to your test's directory
./social.sh #-- run test

if [[ $? == 1 ]]; then #-- check exit code
     echo ''
     echo -e "\e[1;31mTest for social data filters quality - FAIL\e[0m"
     ((errorss+=1))
     echo ''
elif [[ $? == 0 ]]; then
     echo ''
     echo -e "\e[1;32mTest for social filters quality - SUCCESS\e[0m"
     echo ''
fi
echo "$errorss"
#
#
#
# RESTORING INITIAL APACHE2 SERVER CONFIGURATION
#
#
#
echo 'Test completed. Restoring initial apache2 configuration'
#Disable properties_localhost_127.conf
sudo a2dissite "properties_$file"
sudo rm "$apachedirav/properties_$file"
#--------------------------------------------------------
echo ''
echo ''
echo 'Reloading Apache2 server'
sudo systemctl reload apache2
echo ''
echo ''
echo 'Enabling configurations that were disabled previously'
echo ''
for itemm in ${array_conf[*]}
do
    echo "Enabling Apache2 config: $itemm"
    sudo a2ensite "$itemm"
done
echo ''
echo ''
echo 'Reloading Apache2 server'
sudo systemctl reload apache2
echo ''
echo ''
echo 'Initial apache2 configuration has been restored'
echo ''
#
#
#
# Restirong initial /etc/hosts configuration
#
#
#
echo ''
echo ''
if [[ "$hosts_mod" != "0" ]]; then
    echo "Restirong initial /etc/hosts configuration"
    echo "$hosts_original" | sudo tee /etc/hosts
else
    echo '/etc/hosts was not modified'
fi
echo ''
echo ''
#
#
#
if [[ $movedDataFiles != 0 ]]; then
    echo "Removing files copied to /var/www/html"
    #sudo rm -fr /var/www/html/python_cgi
    #sudo rm -fr /var/www/html/charsets
    #sudo rm -fr /var/www/html/check_date_formats
    #sudo rm -fr /var/www/html/properties
    #sudo rm -fr /var/www/html/twitter_soc
    #sudo rm /var/www/html/social.js

fi
#
#
#
echo ''
echo ''
echo ''
echo ''
if [[ $errorss != 0 ]]; then
    echo -e "\e[1;31mErrors in test: $errorss\e[0m"
    exit 1
else
    echo -e "\e[1;32mTest compleded successfully\e[0m"
    exit 0
fi

#
#
#
# END
#
#
#
