
#!/bin/bash

# Executor - Anton Lukashov
# Subject of testing - property COLLECT_URLS_XPATH_LIST

set +e
# The 'basename $0' returns the filename.
base=$(basename $0)
TMP_RESULT_FILE=$(mktemp /tmp/result.$base.XXXXX)
RESULT_FILE_CONTENT=$(mktemp /tmp/content_result.$base.XXXXX)
TMP_ERROR_MESSAGE_FILE=$(mktemp /tmp/message.$base.XXXXX)
echo 'RESULT FILE: '$TMP_RESULT_FILE
function checkErrors()
## Return 1 - if check is fail, or 0 - otherwise
{
        ERROR_CODE=$(jq -r '.errorCode' $TMP_RESULT_FILE)

        ERROR_MESSAGE=$(jq -r '.errorMessage' $TMP_RESULT_FILE)
#echo "--${ERROR_MESSAGE}-- **${ERROR_CODE}**"

        if [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "" ]
        then
                ERROR_CODE=$(jq -r '.itemsList[0].errorCode' $TMP_RESULT_FILE)

                ERROR_MESSAGE=$(jq -r '.itemsList[0].errorMessage' $TMP_RESULT_FILE)

                if [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "" ] || [ "$ERROR_MESSAGE" = "OK" ] || [ "$ERROR_MESSAGE" = "0" ]
                then
		            ITEMOBJECT=$(jq -r '.itemsList[0].itemObject | length' $TMP_RESULT_FILE)


#echo "item_obj: " $ITEMOBJECT


                if [ $ITEMOBJECT -gt 0 ]
                then

                    ERROR_CODE=$(jq -r '.itemsList[0].itemObject.errorCode' $TMP_RESULT_FILE)
                    ERROR_MESSAGE=$(jq -r '.itemsList[0].itemObject.errorMessage' $TMP_RESULT_FILE)

    		            if [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "" ] || [ "$ERROR_MESSAGE" = "OK" ] || [ "$ERROR_CODE" = "null" ] || [ "$ERROR_MESSAGE" = "null" ]
    		            then

    			            return 0
    		            else

    			            echo $ERROR_MESSAGE > $TMP_ERROR_MESSAGE_FILE
    			            return 1
    		            fi


                else

                  echo $ERROR_MESSAGE > $TMP_ERROR_MESSAGE_FILE
    			        return 1
                fi


                return 0
                fi

        else
		      echo $ERROR_MESSAGE > $TMP_ERROR_MESSAGE_FILE
		      return 1
        fi
}

function breakOnError()
# exit for error
{
if [ $1 -eq 0 ]; then
    echo -e "\e[36m$2\e[0m - \e[1;32mSuccess\e[0m"
else
    echo -e "\e[1;36m$2\e[0m - \e[1;31mFail\e[0m"
    if [ "$3" != "" ]; then
    cat $3
    fi
    exit 1
fi
}
#TMP_RESULT_FILE='/tmp/result.time_zone_DC_implementation.sh.RCVxc'
#checkErrors
#breakOnError $? "SITE_STATUS"
#exit

echo "Test start"

#Check if project exists
cd /home/hce/hce-node-bundle/api/python/bin
./dc-client.py --config=../ini/dc-client.ini --command=SITE_UPDATE --file=/home/hce/trunk/api/python/data/ftests/properties_json/COLLECT_URLS_XPATH_LIST/update.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "SITE_UPDATE"

exists=$(jq -r '.itemsList[0].itemObject' $TMP_RESULT_FILE)
echo ''
if [[ "${exists}" != "null"  ]]; then
  #Delete project
  echo 'Project already exists. Deleting project'
  #Delete project and all related data and structures from DC service.
  cd /home/hce/hce-node-bundle/api/python/bin
  ./dc-client.py --config=../ini/dc-client.ini --command=SITE_DELETE --file=/home/hce/trunk/api/python/data/ftests/properties_json/COLLECT_URLS_XPATH_LIST/site_delete.json > $TMP_RESULT_FILE
  checkErrors
  breakOnError $? "SITE_DELETE"
  sleep 15
fi



cd /home/hce/hce-node-bundle/api/python/bin
echo "Create new site" >> ../log/${base}.log 2>&1
# Create a new project in the DC service, sets root URLs, initialize templates, patterns and another related structures.
# In case of conditions are succeed new site included in to the crawling right after creation.
./dc-client.py --config=../ini/dc-client.ini --command=SITE_NEW --file=/home/hce/trunk/api/python/data/ftests/properties_json/COLLECT_URLS_XPATH_LIST/batch_file_DC_time_zone.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "SITE_NEW" $TMP_ERROR_MESSAGE_FILE
#echo “STATUS:”$?
#exit
echo 'Site create...'
echo ''
echo 'Start project crawling'
echo '...'
sleep 180
echo 'Crawled'
echo 'Start project processing'
echo '...'
sleep 60
echo 'Processed'
echo ''



# Returns the project state inside DC service.
# Can be used to check presence of project (id), find out the state of the project (STATE_ACTIVE = 1, STATE_DISABLED = 2, STATE_SUSPENDED = 3, STATE_DELETED = 4, STATE_DELETE_TASK = 5, STATE_RESTART = 6, STATE_CLEANED = 7, STATE_CLEANUP_TASK = 8, STATE_NOT_FOUND = 9).
./dc-client.py --config=../ini/dc-client.ini --command=SITE_STATUS --file=/home/hce/trunk/api/python/data/ftests/properties_json/COLLECT_URLS_XPATH_LIST/status.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "SITE_STATUS"


# Updates fields of existing project in the DC service.
./dc-client.py --config=../ini/dc-client.ini --command=SITE_UPDATE --file=/home/hce/trunk/api/python/data/ftests/properties_json/COLLECT_URLS_XPATH_LIST/update.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "SITE_UPDATE"

sleep 180



# Returns the array of url objects satisfies with criterions and selection conditions.
 # Can be used to check state of resources, also, used internally by DC service to make crawling batches. Can also change state and other fields of selected URL objects

./dc-client.py --config=../ini/dc-client.ini --command=URL_FETCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/COLLECT_URLS_XPATH_LIST/url_fetch.json > $TMP_RESULT_FILE
#checkErrors
#breakOnError $? "URL_FETCH"

echo -e "\e[36mURL_FETCH\e[0m - \e[1;32mSuccess\e[0m"


FETCH_COUNT=$(jq '.itemsList[0].itemObject | length' $TMP_RESULT_FILE)
# Check the number of crawled resources
# echo -e "\e[36mFETCH_COUNT - 5 links \e[0m"

echo $FETCH_COUNT " links crawled"



if [ "$FETCH_COUNT" = "5" ]; then
    echo -e "\e[36mFETCH_COUNT\e[0m - \e[1;32mSuccess\e[0m"
    echo 'The check of number of crawled resources passed successfully'
    #Delete project and all related data and structures from DC service.
    cd /home/hce/hce-node-bundle/api/python/bin
    ./dc-client.py --config=../ini/dc-client.ini --command=SITE_DELETE --file=/home/hce/trunk/api/python/data/ftests/properties_json/COLLECT_URLS_XPATH_LIST/site_delete.json > $TMP_RESULT_FILE
    checkErrors
    breakOnError $? "SITE_DELETE"
    echo ''
    echo 'Project was deleted'
    exit 0
else
    echo -e "\e[36mFETCH_COUNT\e[0m - \e[1;31mError\e[0m"
    exit 1
fi


