#!/bin/bash

# Executor - Anton Dmytrenko
# Subject of testing - property HTML_CANONICAL_REDIRECT

set +e
# The 'basename $0' returns the filename.
base=$(basename $0)
TMP_RESULT_FILE=$(mktemp /tmp/result.$base.XXXXX)
TMP_ERROR_MESSAGE_FILE=$(mktemp /tmp/message.$base.XXXXX)
echo 'RESULT FILE: '$TMP_RESULT_FILE
errors=0
testnum=0
function checkErrors()
## Return 1 - if check is fail, or 0 - otherwise
{
        ERROR_CODE=$(jq -r '.errorCode' $TMP_RESULT_FILE)

        ERROR_MESSAGE=$(jq -r '.errorMessage' $TMP_RESULT_FILE)
#echo "--${ERROR_MESSAGE}-- **${ERROR_CODE}**"

        if [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "" ]
        then
                ERROR_CODE=$(jq -r '.itemsList[0].errorCode' $TMP_RESULT_FILE)

                ERROR_MESSAGE=$(jq -r '.itemsList[0].errorMessage' $TMP_RESULT_FILE)

                link=$(jq -r '.itemsList[0].itemObject[0].url' $TMP_RESULT_FILE)

                if [[ $testnum == 1 && "$link" != "http://example.com/wordpress/seo-plugin/" ]]; then
                    echo -e "\e[1;31m HTML_CANONICAL_REDIRECT 1 - ERROR: LINK INCORRECT\e[0m"
                    ((errors+=1))
                    return 1
                elif [[ $testnum == 2 && "$link" != "http://127.0.0.1/properties/HTML_CANONICAL_REDIRECT/1.html" ]]; then
                    echo -e "\e[1;31m HTML_CANONICAL_REDIRECT 2 - ERROR: LINK INCORRECT\e[0m"
                    ((errors+=1))
                    return 1
                fi
                if [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "" ]
                then
	    return 0
                elif [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "OK" ]
                then
	    return 0
                else
                        echo $ERROR_MESSAGE > $TMP_ERROR_MESSAGE_FILE
	    return 1
                fi
        else
	echo $ERROR_MESSAGE > $TMP_ERROR_MESSAGE_FILE
	return 1
        fi
}

function breakOnError()
# exit for error
{
if [ $1 -eq 0 ]; then
    echo -e "\e[36m$2\e[0m - \e[1;32mSuccess\e[0m"
else
    echo -e "\e[1;36m$2\e[0m - \e[1;31mFail\e[0m"
    if [ "$3" != "" ]; then
    cat $3
    fi
fi
}

echo "Test start for HTML_CANONICAL_REDIRECT property"
echo ''
cd /home/hce/hce-node-bundle/api/python/bin
# Execute the command BATCH - JSON request sent by demo-form through dc-client

echo ''
echo -e '\e[35m----- Case 1 -----'
echo ''
echo "Running script INCLUDING the property HTML_CANONICAL_REDIRECT"
((testnum+=1))
./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/HTML_CANONICAL_REDIRECT/test_includeCANONICAL.batch.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "BATCH - HTML_CANONICAL_REDIRECT" $TMP_ERROR_MESSAGE_FILE


echo ''
echo -e '\e[35m----- Case 2 -----'
echo ''
echo "Runnung script EXCLUDING the property HTML_CANONICAL_REDIRECT"
((testnum+=1))
./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/HTML_CANONICAL_REDIRECT/test_excludeCANONICAL.batch.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "BATCH - HTML_CANONICAL_REDIRECT" $TMP_ERROR_MESSAGE_FILE

echo ''
#echo "$errors"
if [[ $errors != 0 ]]; then
    echo -e "\e[1;31mTest did not complete successfully. Errors: ${errors}. Returning Test Failed\e[0m"
    exit 1
elif [[ $errors == 0 ]]; then
    echo -e '\e[1;32mTest completed successfully with no errors\e[0m'
    exit 0
fi

