#!/bin/bash

# Executor - Anton Lukashov
# Subject of testing - property HTTP_REDIRECT_RESOLVER
#
#
#
#
#

set +e
# The 'basename $0' returns the filename.
base=$(basename $0)
TMP_RESULT_FILE=$(mktemp /tmp/result.$base.XXXXX)
RESULT_FILE_CONTENT=$(mktemp /tmp/content_result.$base.XXXXX)
TMP_ERROR_MESSAGE_FILE=$(mktemp /tmp/message.$base.XXXXX)
echo 'RESULT FILE: '$TMP_RESULT_FILE
errors=0
proxy=0
function checkErrors()
## Return 1 - if check is fail, or 0 - otherwise
{
        ERROR_CODE=$(jq -r '.errorCode' $TMP_RESULT_FILE)

        ERROR_MESSAGE=$(jq -r '.errorMessage' $TMP_RESULT_FILE)
#echo "--${ERROR_MESSAGE}-- **${ERROR_CODE}**"

        if [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "" ]
        then
                ERROR_CODE=$(jq -r '.itemsList[0].errorCode' $TMP_RESULT_FILE)

                ERROR_MESSAGE=$(jq -r '.itemsList[0].errorMessage' $TMP_RESULT_FILE)

                if [[ "${proxy}" != "0"  ]]; then

                    decoded3=$(jq -r '.itemsList[0].itemObject[0].dbFields.HTTPCode' $TMP_RESULT_FILE)

                    #echo "$decoded3"
                    if [[ $decoded3 == 302 ]]; then
                      echo "Status code " $decoded3
                    else
                      echo  "\e[1;32mWrong status code\e[0m"
                      echo $decoded3
                      ((errors+=1))
                    fi
                fi
                if [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "" ]
                then
	    return 0
                elif [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "OK" ]
                then
	    return 0
                else
                        echo $ERROR_MESSAGE > $TMP_ERROR_MESSAGE_FILE
	    return 1
                fi
        else
	echo $ERROR_MESSAGE > $TMP_ERROR_MESSAGE_FILE
	return 1
        fi
}

function breakOnError()
# exit for error
{
if [ $1 -eq 0 ]; then
    echo -e "\e[36m$2\e[0m - \e[1;32mSuccess\e[0m"
else
    echo -e "\e[1;36m$2\e[0m - \e[1;31mFail\e[0m"
    if [ "$3" != "" ]; then
    cat $3
    fi
fi
}

echo "Starting test of HTTP_REDIRECT_RESOLVER "


#Check if project exists
cd /home/hce/hce-node-bundle/api/python/bin
./dc-client.py --config=../ini/dc-client.ini --command=SITE_STATUS --file=/var/www/html/python_cgi/HTTP_REDIRECT_RESOLVER/status.json > $TMP_RESULT_FILE

exists=$(jq -r '.itemsList[0].itemObject' $TMP_RESULT_FILE)
echo ''
if [[ "${exists}" != "null"  ]]; then
    #Delete project
    echo 'Project already exists. Deleting project'
    cd /home/hce/hce-node-bundle/api/python/bin
    ./dc-client.py --config=../ini/dc-client.ini --command=SITE_DELETE --file=/var/www/html/python_cgi/HTTP_REDIRECT_RESOLVER/site_delete.json > $TMP_RESULT_FILE
    checkErrors
    breakOnError $? "SITE_DELETE" $TMP_ERROR_MESSAGE_FILE
    sleep 15
fi

echo ''
echo ''

cd /home/hce/hce-node-bundle/api/python/bin
echo 'Create new site' >> ../log/${base}.log 2>&1
# Create a new project in the DC service, sets root URLs, initialize templates, patterns and another related structures.
# In case of conditions are succeed new site included in to the crawling right after creation.
./dc-client.py --config=../ini/dc-client.ini --command=SITE_NEW --file=/var/www/html/python_cgi/HTTP_REDIRECT_RESOLVER/site_new_2.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "SITE_NEW - HTTP_REDIRECT_RESOLVER" $TMP_ERROR_MESSAGE_FILE



echo ''
echo 'Start project crawling'
echo '...'
echo 'waiting 180 sec...'
sleep 180
echo 'Crawled'
echo 'Start project processing'
echo '...'
echo 'waiting 180 sec...'
sleep 180
echo 'Processed'
echo ''

#Execute URL_CONTENT to validate whether the custom proxy was engaged
echo ''
echo ''
cd /home/hce/hce-node-bundle/api/python/bin
#echo 'Send URL_CONTENT command for HTTP_REDIRECT_RESOLVER DC test' >> ../log/${base}.log 2>&1
# Run URL_CONTENT command to check http headers
./dc-client.py --config=../ini/dc-client.ini --command=URL_CONTENT --file=/var/www/html/python_cgi/HTTP_REDIRECT_RESOLVER/url_content.json > $TMP_RESULT_FILE
((proxy+=1))
checkErrors
breakOnError $? "URL_CONTENT - HTTP_REDIRECT_RESOLVER"

echo ''

if [[ $errors != 0 ]]; then
    echo -e "\e[1;31mTest did not complete successfully. Errors: ${errors}. Returning Test Failed\e[0m"
    echo ''
    echo ''
    echo ''
    echo -e '\e[1;32m--- CORRECT --- Curl http://127.0.0.1/python_cgi/HTTP_REDIRECT_RESOLVER.py?1:\e[0m'
    curl -vv "http://127.0.0.1/python_cgi/HTTP_REDIRECT_RESOLVER.py?1"
    exit 1
elif [[ $errors == 0 ]]; then
    echo -e '\e[1;32mTest completed successfully with no errors. Deleting project\e[0m'
    #Delete project
    cd /home/hce/hce-node-bundle/api/python/bin
    ./dc-client.py --config=../ini/dc-client.ini --command=SITE_DELETE --file=/var/www/html/python_cgi/HTTP_REDIRECT_RESOLVER/site_delete.json >> $TMP_RESULT_FILE
    exit 0
fi
#
#
#
#
#
#
#
#
