# !/bin/bash
# Executor - Anton Dmytrenko
# Subject of testing - property PDATE_DAY_MONTH_ORDER

set +e
# The 'basename $0' returns the filename.
base=$(basename $0)
TMP_RESULT_FILE=$(mktemp /tmp/result.$base.XXXXX)
TMP_ERROR_MESSAGE_FILE=$(mktemp /tmp/message.$base.XXXXX)
echo 'RESULT FILE: '$TMP_RESULT_FILE
errors=0
testnum=0
function checkErrors()
## Return 1 - if check is fail, or 0 - otherwise
{
        ERROR_CODE=$(jq -r '.errorCode' $TMP_RESULT_FILE)

        ERROR_MESSAGE=$(jq -r '.errorMessage' $TMP_RESULT_FILE)
#echo "--${ERROR_MESSAGE}-- **${ERROR_CODE}**"

        if [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "" ]
        then
                ERROR_CODE=$(jq -r '.itemsList[0].errorCode' $TMP_RESULT_FILE)

                ERROR_MESSAGE=$(jq -r '.itemsList[0].errorMessage' $TMP_RESULT_FILE)

                date=$(jq -r '.itemsList[0].itemObject[0].dbFields.PDate' $TMP_RESULT_FILE)

                if [[ $testnum == 1 && $date != *"2019-07-15"* ]]; then
                    echo -e "\e[1;31mDate is INCORRECT. Date: ${date}. Correct Date: 2019-07-15\e[0m"
                    ((errors+=1))
                    return 1
                elif [[ $testnum == 2 && $date != *"2012-12-24"* ]]; then
                    echo -e "\e[1;31mDate is INCORRECT. Date: ${date}. Correct Date: 2012-12-24\e[0m"
                    ((errors+=1))
                    return 1
                elif [[ $testnum == 3 && $date != *"2014-07-15"* ]]; then
                    echo -e "\e[1;31mDate is INCORRECT. Date: ${date}. Correct Date: 2014-07-15\e[0m"
                    ((errors+=1))
                    return 1
                elif [[ $testnum == 4 && $date != *"2019-07-15"* ]]; then
                    echo -e "\e[1;31mDate is INCORRECT. Date: ${date}. Correct Date: 2019-07-15\e[0m"
                    ((errors+=1))
                    return 1
                elif [[ $testnum == 5 && $date != *"2019-07-15"* ]]; then
                    echo -e "\e[1;31mDate is INCORRECT. Date: ${date}. Correct Date: 2019-07-15\e[0m"
                    ((errors+=1))
                    return 1
                elif [[ $testnum == 6 && $date != *"2025-02-12"* ]]; then
                    echo -e "\e[1;31mDate is INCORRECT. Date: ${date}. Correct Date: 2025-02-12\e[0m"
                    ((errors+=1))
                    return 1
                elif [[ $testnum == 7 && $date != *"2001-07-28"* ]]; then
                    echo -e "\e[1;31mDate is INCORRECT. Date: ${date}. Correct Date: 2001-07-28\e[0m"
                    ((errors+=1))
                    return 1

                else
                    echo -e "\e[1;32mDate ${date} is correct\e[0m"
                fi

                if [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "" ]
                then
            return 0
                elif [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "OK" ]
                then
            return 0
                else
                        echo $ERROR_MESSAGE > $TMP_ERROR_MESSAGE_FILE
            return 1
                fi
        else
        echo $ERROR_MESSAGE > $TMP_ERROR_MESSAGE_FILE
        return 1
        fi
}

function breakOnError()
# exit for error
{
if [ $1 -eq 0 ]; then
    echo -e "\e[36m$2\e[0m - \e[1;32mSuccess\e[0m"
else
    echo -e "\e[1;36m$2\e[0m - \e[1;31mFail\e[0m"
    if [ "$3" != "" ]; then
    cat $3
    fi
fi
}

echo ''
echo "Test start for PDATE_DAY_MONTH_ORDER property"
echo ''
cd /home/hce/hce-node-bundle/api/python/bin
# Execute the command BATCH - JSON request sent by demo-form through dc-client
echo ''
echo -e '\e[35m----- Case 1 -----'
echo ''
echo "Running script for PDATE_DAY_MONTH_ORDER html file 1"
./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/PDATE_DAY_MONTH_ORDER/test_PDATE_DAY_MONTH_ORDER_1.batch.json > $TMP_RESULT_FILE
((testnum+=1))
checkErrors
breakOnError $? "BATCH - PDATE_DAY_MONTH_ORDER" $TMP_ERROR_MESSAGE_FILE

echo ''
echo -e '\e[35m----- Case 2 -----'
echo ''
echo "Running script for PDATE_DAY_MONTH_ORDER html file 2"
./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/PDATE_DAY_MONTH_ORDER/test_PDATE_DAY_MONTH_ORDER_2.batch.json > $TMP_RESULT_FILE
((testnum+=1))
checkErrors
breakOnError $? "BATCH - PDATE_DAY_MONTH_ORDER" $TMP_ERROR_MESSAGE_FILE

echo ''
echo -e '\e[35m----- Case 3 -----'
echo ''
echo "Running script for PDATE_DAY_MONTH_ORDER html file 3"
./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/PDATE_DAY_MONTH_ORDER/test_PDATE_DAY_MONTH_ORDER_3.batch.json > $TMP_RESULT_FILE
((testnum+=1))
checkErrors
breakOnError $? "BATCH - PDATE_DAY_MONTH_ORDER" $TMP_ERROR_MESSAGE_FILE

echo ''
echo -e '\e[35m----- Case 4 -----'
echo ''
echo "Running script for PDATE_DAY_MONTH_ORDER html file 4"
./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/PDATE_DAY_MONTH_ORDER/test_PDATE_DAY_MONTH_ORDER_4.batch.json > $TMP_RESULT_FILE
((testnum+=1))
checkErrors
breakOnError $? "BATCH - PDATE_DAY_MONTH_ORDER" $TMP_ERROR_MESSAGE_FILE

echo ''
echo -e '\e[35m----- Case 5 -----'
echo ''
echo "Running script for PDATE_DAY_MONTH_ORDER html file 5"
./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/PDATE_DAY_MONTH_ORDER/test_PDATE_DAY_MONTH_ORDER_5.batch.json > $TMP_RESULT_FILE
((testnum+=1))
checkErrors
breakOnError $? "BATCH - PDATE_DAY_MONTH_ORDER" $TMP_ERROR_MESSAGE_FILE

echo ''
echo -e '\e[35m----- Case 6 -----'
echo ''
echo "Running script for PDATE_DAY_MONTH_ORDER html file 6"
./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/PDATE_DAY_MONTH_ORDER/test_PDATE_DAY_MONTH_ORDER_6.batch.json > $TMP_RESULT_FILE
((testnum+=1))
checkErrors
breakOnError $? "BATCH - PDATE_DAY_MONTH_ORDER" $TMP_ERROR_MESSAGE_FILE

echo ''
echo -e '\e[35m----- Case 7 -----'
echo ''
echo "Running script for PDATE_DAY_MONTH_ORDER html file 7"
./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/PDATE_DAY_MONTH_ORDER/test_PDATE_DAY_MONTH_ORDER_7.batch.json > $TMP_RESULT_FILE
((testnum+=1))
checkErrors
breakOnError $? "BATCH - PDATE_DAY_MONTH_ORDER" $TMP_ERROR_MESSAGE_FILE
echo ''
#echo "$errors"
if [[ $errors != 0 ]]; then
    echo -e "\e[1;31mTest did not complete successfully. Errors: ${errors}. Returning Test Failed\e[0m"
    exit 0
elif [[ $errors == 0 ]]; then
    echo -e '\e[1;32mTest completed successfully with no errors\e[0m'
    exit 1
fi

