#!/bin/bash

# Executor - Anton Dmytrenko
# Subject of testing - property PDATE_TIME

set +e
# The 'basename $0' returns the filename.
base=$(basename $0)
TMP_RESULT_FILE=$(mktemp /tmp/result.$base.XXXXX)
TMP_ERROR_MESSAGE_FILE=$(mktemp /tmp/message.$base.XXXXX)
echo 'RESULT FILE: '$TMP_RESULT_FILE
errors=0
function checkErrors()
## Return 1 - if check is fail, or 0 - otherwise
{
        ERROR_CODE=$(jq -r '.errorCode' $TMP_RESULT_FILE)

        ERROR_MESSAGE=$(jq -r '.errorMessage' $TMP_RESULT_FILE)
#echo "--${ERROR_MESSAGE}-- **${ERROR_CODE}**"

        if [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "" ]
        then
                ERROR_CODE=$(jq -r '.itemsList[0].errorCode' $TMP_RESULT_FILE)

                ERROR_MESSAGE=$(jq -r '.itemsList[0].errorMessage' $TMP_RESULT_FILE)

		timeiszero=$(jq -r '.itemsList[0].itemObject[0].dbFields.PDate' $TMP_RESULT_FILE)
		if [[ $timeiszero == *"00:00:00"* ]];
                then
                    echo -e "\e[1;31m PDATE_TIME - ERROR: TIME IS SET TO ZEROS\e[0m"
                    ((errors+=1))
                    return 1
		fi
                if [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "" ]
                then
	    return 0
                elif [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "OK" ]
                then
	    return 0
                else
                        echo $ERROR_MESSAGE > $TMP_ERROR_MESSAGE_FILE
	    return 1
		fi
        else
	echo $ERROR_MESSAGE > $TMP_ERROR_MESSAGE_FILE
	return 1
        fi
}

function breakOnError()
# exit for error
{
if [ $1 -eq 0 ]; then
    echo -e "\e[36m$2\e[0m - \e[1;32mSuccess\e[0m"
else
    echo -e "\e[1;36m$2\e[0m - \e[1;31mFail\e[0m"
    if [ "$3" != "" ]; then
    cat $3
    fi
fi
}
echo "Test start for PDATE_TIME property"
echo ''
echo ''
cd /home/hce/hce-node-bundle/api/python/bin
# Execute the command BATCH - JSON request sent by demo-form through dc-client
echo -e '\e[35m----- Case 1 -----'
echo ''
echo "Running script for EXCLUDED property PDATE_TIME html file 1"
./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/PDATE_TIME/test_PDATE_TIME_0.batch.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "BATCH" $TMP_ERROR_MESSAGE_FILE
echo ''

echo -e '\e[35m----- Case 2 -----'
echo ''
echo "Running script for PDATE_TIME html file 1"
./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/PDATE_TIME/test_PDATE_TIME_1.batch.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "BATCH" $TMP_ERROR_MESSAGE_FILE
echo ''

echo -e '\e[35m----- Case 3 -----'
echo ''
echo "Running script for PDATE_TIME html file 2"
./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/PDATE_TIME/test_PDATE_TIME_2.batch.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "BATCH" $TMP_ERROR_MESSAGE_FILE
echo ''

echo -e '\e[35m----- Case 4 -----'
echo ''
echo "Running script for PDATE_TIME html file 3"
./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/PDATE_TIME/test_PDATE_TIME_3.batch.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "BATCH" $TMP_ERROR_MESSAGE_FILE
echo ''

echo -e '\e[35m----- Case 5 -----'
echo ''
echo "Running script for PDATE_TIME html file 4"
./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/PDATE_TIME/test_PDATE_TIME_4.batch.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "BATCH" $TMP_ERROR_MESSAGE_FILE
echo ''

echo -e '\e[35m----- Case 6 -----'
echo ''
echo "Running script for PDATE_TIME html file 5"
./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/PDATE_TIME/test_PDATE_TIME_5.batch.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "BATCH" $TMP_ERROR_MESSAGE_FILE
echo ''

echo -e '\e[35m----- Case 7 -----'
echo ''
echo "Running script for PDATE_TIME html file 6"
./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/PDATE_TIME/test_PDATE_TIME_6.batch.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "BATCH" $TMP_ERROR_MESSAGE_FILE
echo ''

echo -e '\e[35m----- Case 8 -----'
echo ''
echo "Running script for PDATE_TIME html file 7"
./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/PDATE_TIME/test_PDATE_TIME_7.batch.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "BATCH" $TMP_ERROR_MESSAGE_FILE
echo ''

echo -e '\e[35m----- Case 9 -----'
echo ''
echo "Running script for PDATE_TIME html file 8 (date format as current in crawler)"
./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/PDATE_TIME/test_PDATE_TIME_8.batch.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "BATCH" $TMP_ERROR_MESSAGE_FILE

echo -e '\e[35m----- Case IST -----'
echo ''
echo "Running script for PDATE_TIME html file(IST future pubdate time)"
./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/PDATE_TIME/test_PDATE_TIME_IST.batch.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "BATCH" $TMP_ERROR_MESSAGE_FILE
function ist_tz()
{
CONTENT_GET=$(jq -r '.itemsList[0].itemObject[0].processedContents[0].buffer' $TMP_RESULT_FILE | base64 -di)
CONTENT_ENCODED=$(echo ${CONTENT_GET} | jq --raw-output '.[].content_encoded')
time_zone=$(echo $CONTENT_GET | jq --raw-output '.[].pubdate_tz')
pub_date=$(echo $CONTENT_GET | jq --raw-output '.[].pubdate')
#echo $pub_date
if [ "$time_zone" == "+0000" ]; then
	echo -e "\e[1;32mTimeZone is modifed to +0000\e[0m"
else
        echo -e "\e[1;31mSomethings happend with TimeZone\e[0m"
        ((errors+=1))
	return 1
        fi

if [ "$pub_date" == "2025-06-09 18:17:24" ]; then
        echo -e "\e[1;32mFuture pubdate is OK\e[0m"
	return 0
else
        ((errors+=1))	
        echo -e "\e[1;31mSomethings happens with pubdate\e[0m"		
	return 1
fi
}
ist_tz

if [[ $errors != 0 ]]; then
    echo -e "\e[1;31mTest did not complete successfully. Errors: ${errors}. Returning Test Failed\e[0m"
    exit 1
elif [[ $errors == 0 ]]; then
    echo -e '\e[1;32mTest completed successfully with no errors\e[0m'
    exit 0
fi
