#!/bin/bash

# Executor - Anton Lukashov
# Subject of testing - PROCESSED_CONTENTS_TAGS_LIMITS for task DC-3155


set +e
# The 'basename $0' returns the filename.
base=$(basename $0)
TMP_RESULT_FILE=$(mktemp /tmp/result.$base.XXXXX)
TMP_ERROR_MESSAGE_FILE=$(mktemp /tmp/message.$base.XXXXX)
echo 'RESULT FILE: '$TMP_RESULT_FILE
errors=0
function checkErrors()
## Return 1 - if check is fail, or 0 - otherwise
{
        ERROR_CODE=$(jq -r '.errorCode' $TMP_RESULT_FILE)

        ERROR_MESSAGE=$(jq -r '.errorMessage' $TMP_RESULT_FILE)
#echo "--${ERROR_MESSAGE}-- **${ERROR_CODE}**"

        if [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "" ]
        then
                ERROR_CODE=$(jq -r '.itemsList[0].errorCode' $TMP_RESULT_FILE)

                ERROR_MESSAGE=$(jq -r '.itemsList[0].errorMessage' $TMP_RESULT_FILE)

                if [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "" ]
                then
                    return 0
                elif [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "OK" ]
                then
                    return 0
                else
                        echo $ERROR_MESSAGE > $TMP_ERROR_MESSAGE_FILE
                        return 1
                fi
        else
                echo $ERROR_MESSAGE > $TMP_ERROR_MESSAGE_FILE
                return 1
        fi
}

function breakOnError()
# exit for error
{
if [ $1 -eq 0 ]; then
    echo -e "\e[36m$2\e[0m - \e[1;32mSuccess\e[0m"
else
    echo -e "\e[1;36m$2\e[0m - \e[1;31mFail\e[0m"
    if [ "$3" != "" ]; then
    cat $3
    fi
    exit 1
fi
}

cd /home/hce/hce-node-bundle/api/python/bin
echo ''
echo "========================================================================"
echo ''
echo "The test is checking title with parameters: min_bytes:32, max_bytes:1000"
# Execute the command BATCH - JSON request sent by demo-form through dc-client
./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/PROCESSED_CONTENTS_TAGS_LIMITS/batch_processed_content_tags_limit.json > $TMP_RESULT_FILE
checkErrors
if [[ $? -eq 0 ]]; then
    PROCESSED_CONTENT=$(jq -r '.itemsList[0].itemObject[0].processedContents[0].buffer' $TMP_RESULT_FILE | base64 -di)
    TITLE=$(echo ${PROCESSED_CONTENT} | jq --raw-output '.[].title')
    EXPECTED_TITLE="Tearful Obama tightens gun control and tells inactive Congress"
    if [[ "$TITLE" == $EXPECTED_TITLE ]]; then
        echo -e "\e[36mTitle with parameters: min_bytes:32, max_bytes:1000\e[0m - \e[1;32mOK\e[0m";
        echo ''
    else
        echo -e "\e[36mTitle with parameters: min_bytes:32, max_bytes:1000\e[0m - \e[1;31mWRONG\e[0m";
        echo -e "Actual:\n"$TITLE
        echo -e "Expected:\n"$EXPECTED_TITLE
        ((errors+=1))
    fi
else
  echo "BATCH wrong answer, check $TMP_RESULT_FILE"
  ((errors+=1))
fi
echo "========================================================================"
echo ''

echo "The test is checking title with parameters: min_bytes:1, max_bytes:20"
# Execute the command BATCH - JSON request sent by demo-form through dc-client
./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/PROCESSED_CONTENTS_TAGS_LIMITS/batch_processed_content_tags_limits_form_1_to_20.json > $TMP_RESULT_FILE
checkErrors
if [[ $? -eq 0 ]]; then
    PROCESSED_CONTENT=$(jq -r '.itemsList[0].itemObject[0].processedContents[0].buffer' $TMP_RESULT_FILE | base64 -di)
    TITLE=$(echo ${PROCESSED_CONTENT} | jq --raw-output '.[].title')
    EXPECTED_TITLE="%title%"
    if [[ "$TITLE" == $EXPECTED_TITLE ]]; then
        echo -e "\e[36mTitle with parameters: min_bytes:1, max_bytes:20\e[0m - \e[1;32mOK\e[0m";
        echo ''
    else
        echo -e "\e[36mTitle with parameters: min_bytes:1, max_bytes:20\e[0m - \e[1;31mWRONG\e[0m";
        echo -e "Actual:\n"$TITLE
        echo -e "Expected:\n"$EXPECTED_TITLE
        ((errors+=1))
    fi
else
  echo "BATCH wrong answer, check $TMP_RESULT_FILE"
  ((errors+=1))
fi
echo "========================================================================"
echo ''

if [[ $errors -eq 0 ]]; then
  exit 0
else
  exit 1
fi
