#!/bin/bash

# Executor - Maksym Masalov
# Subject of testing - property SCRAPER_TAGS_VALIDATION

set +e
# The 'basename $0' returns the filename.
base=$(basename $0)
TMP_RESULT_FILE=$(mktemp /tmp/result.${base}.XXXXX)
RESULT_FILE_CONTENT=$(mktemp /tmp/content_result.${base}.XXXXX)
TMP_ERROR_MESSAGE_FILE=$(mktemp /tmp/message.${base}.XXXXX)
echo 'RESULT FILE: '${TMP_RESULT_FILE}
function checkErrors()
## Return 1 - if check is fail, or 0 - otherwise
{
        ERROR_CODE=$(jq -r '.errorCode' ${TMP_RESULT_FILE})
        res=0
        ERROR_MESSAGE=$(jq -r '.errorMessage' ${TMP_RESULT_FILE})
#echo "--${ERROR_MESSAGE}-- **${ERROR_CODE}**"

        if [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "" ]
        then
                ERROR_CODE=$(jq -r '.itemsList[0].errorCode' ${TMP_RESULT_FILE})

                ERROR_MESSAGE=$(jq -r '.itemsList[0].errorMessage' ${TMP_RESULT_FILE})

                if [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "" ]
                then
	    return 0
                elif [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "OK" ]
                then
	    return 0
                else
                        echo ${ERROR_MESSAGE} > ${TMP_ERROR_MESSAGE_FILE}
                        res=${res}+1
	    return 1
                fi
        else
	 echo ${ERROR_MESSAGE} > ${TMP_ERROR_MESSAGE_FILE}
	 return 0
        fi
}

function breakOnError()
# exit for error
{
if [ $1 -eq 0 ]; then
    echo -e "\e[36m$2\e[0m - \e[1;32mSuccess\e[0m"
else
    echo -e "\e[1;36m$2\e[0m - \e[1;31mFail\e[0m"
    if [ "$3" != "" ]; then
    cat $3
    fi
    exit 1
fi
}

echo "Test start"
echo ''
echo -e '\e[35m----- Check SCRAPER TAGS VALIDATION (png) ----- \e[0m'
cd /home/hce/hce-node-bundle/api/python/bin
echo 'Create new site' >> ../log/${base}.log 2>&1

res=0
res_media=0

./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/SCRAPER_TAGS_VALIDATION/test_SCRAPER_TAGS_VALIDATION.batch1.json > ${TMP_RESULT_FILE}
checkErrors
breakOnError $? "BATCH" ${TMP_ERROR_MESSAGE_FILE}


decoded=$(jq -r '.itemsList[0].itemObject[0].processedContents[0].buffer' $TMP_RESULT_FILE | base64 -di)
media=$(echo ${decoded} | jq --raw-output '.[].media')
echo "Media: " ${media}

if [[ "$media" = "http://pngimg.com/uploads/minions/minions_PNG17.png" ]]; then
    echo -e "\e[36mMEDIA\e[0m - \e[1;32mSuccess\e[0m"
else
    echo -e "\e[36mMEDIA\e[0m - \e[1;31mError\e[0m"
    res_media=${res_media}+1
fi

echo ''
echo -e '\e[35m----- Check SCRAPER TAGS VALIDATION (gif) ----- \e[0m'

./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/SCRAPER_TAGS_VALIDATION/test_SCRAPER_TAGS_VALIDATION.batch2.json > ${TMP_RESULT_FILE}
checkErrors
breakOnError $? "BATCH" ${TMP_ERROR_MESSAGE_FILE}


decoded=$(jq -r '.itemsList[0].itemObject[0].processedContents[0].buffer' $TMP_RESULT_FILE | base64 -di)
media=$(echo ${decoded} | jq --raw-output '.[].media')
echo "Media: " ${media}

if [[ "$media" = "http://127.0.0.1/python_cgi/scraper_tags_validation.py?gif" ]]; then
    echo -e "\e[36mMEDIA\e[0m - \e[1;32mSuccess\e[0m"
else
    echo -e "\e[36mMEDIA\e[0m - \e[1;31mError\e[0m"
    res_media=${res_media}+1
fi

if [[ "$res_media" = "0" ]]; then
  echo -e '\e[1;32mEverything is OK\e[0m'
  exit 0
else
  echo -e '\e[1;31mSomething was wrong\e[0m'
  exit 1
fi