#!/bin/bash
#
# Executor - Anton Dmytrenko
#
# Subject of testing - social fields social_tw_posts and social_tw_raw_posts of DC-clients BATCH response

set +e
# The 'basename $0' returns the filename.
base=$(basename $0)
TMP_RESULT_FILE=$(mktemp /tmp/result.$base.XXXXX)
TMP_ERROR_MESSAGE_FILE=$(mktemp /tmp/message.$base.XXXXX)
echo 'RESULT FILE: '$TMP_RESULT_FILE
errors=0
function checkErrors()
## Return 1 - if check is fail, or 0 - otherwise
{
        ERROR_CODE=$(jq -r '.errorCode' $TMP_RESULT_FILE)

        ERROR_MESSAGE=$(jq -r '.errorMessage' $TMP_RESULT_FILE)
#echo "--${ERROR_MESSAGE}-- **${ERROR_CODE}**"

        if [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "" ]
        then
                ERROR_CODE=$(jq -r '.itemsList[0].errorCode' $TMP_RESULT_FILE)

                ERROR_MESSAGE=$(jq -r '.itemsList[0].errorMessage' $TMP_RESULT_FILE)

                if [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "" ]
                then
            return 0
                elif [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "OK" ]
                then
            return 0
                else
                        echo $ERROR_MESSAGE > $TMP_ERROR_MESSAGE_FILE
            return 1
                fi
        else
        echo $ERROR_MESSAGE > $TMP_ERROR_MESSAGE_FILE
        return 1
        fi
}

function breakOnError()
# exit for error
{
if [ $1 -eq 0 ]; then
    echo -e "\e[36m$2\e[0m - \e[1;32mSuccess\e[0m"
else
    echo -e "\e[1;36m$2\e[0m - \e[1;31mFail\e[0m"
    if [ "$3" != "" ]; then
    cat $3
    fi
fi
}
echo "Test start for SOCIAL FIELDS quality"
echo ''
echo ''
echo "Executing python script (selenium data gathering). This will take a couple of minutes.."
echo ''
ans=$(python3 /home/hce/trunk/api/python/ftests/properties/SOCIAL_TWITTER/title_exact_match.py 1)
echo "Ans: $ans"
raw_twits=$(echo "$ans" | cut -d'|' -f 1)
filtered_twits=$(echo "$ans" | cut -d'|' -f 2)
echo "Raw twits: $raw_twits"
echo "Filtered twits: $filtered_twits"

ans2=$(python3 /home/hce/trunk/api/python/ftests/properties/SOCIAL_TWITTER/title_exact_match.py 2)
echo "Ans2: $ans2"
raw_twits2=$(echo "$ans2" | cut -d'|' -f 1)
filtered_twits2=$(echo "$ans2" | cut -d'|' -f 2)
echo "Raw twits: $raw_twits2"
echo "Filtered twits: $filtered_twits2"

ans3=$(python3 /home/hce/trunk/api/python/ftests/properties/SOCIAL_TWITTER/title_exact_match.py 3)
echo "Ans3: $ans3"
raw_twits3=$(echo "$ans3" | cut -d'|' -f 1)
filtered_twits3=$(echo "$ans3" | cut -d'|' -f 2)
echo "Raw twits: $raw_twits3"
echo "Filtered twits: $filtered_twits3"

ans4=$(python3 /home/hce/trunk/api/python/ftests/properties/SOCIAL_TWITTER/title_exact_match.py 4)
echo "Ans4: $ans4"
raw_twits4=$(echo "$ans4" | cut -d'|' -f 1)
filtered_twits4=$(echo "$ans4" | cut -d'|' -f 2)
echo "Raw twits: $raw_twits4"
echo "Filtered twits: $filtered_twits4"

ans5=$(python3 /home/hce/trunk/api/python/ftests/properties/SOCIAL_TWITTER/title_exact_match.py 5)
echo "Ans5: $ans5"
raw_twits5=$(echo "$ans5" | cut -d'|' -f 1)
filtered_twits5=$(echo "$ans5" | cut -d'|' -f 2)
echo "Raw twits: $raw_twits5"
echo "Filtered twits: $filtered_twits5"

ans6=$(python3 /home/hce/trunk/api/python/ftests/properties/SOCIAL_TWITTER/title_exact_match.py 6)
echo "Ans6: $ans6"
raw_twits6=$(echo "$ans6" | cut -d'|' -f 1)
filtered_twits6=$(echo "$ans6" | cut -d'|' -f 2)
echo "Raw twits: $raw_twits6"
echo "Filtered twits: $filtered_twits6"

ans7=$(python3 /home/hce/trunk/api/python/ftests/properties/SOCIAL_TWITTER/title_exact_match.py 7)
echo "Ans7: $ans7"
raw_twits7=$(echo "$ans7" | cut -d'|' -f 1)
filtered_twits7=$(echo "$ans7" | cut -d'|' -f 2)
echo "Raw twits: $raw_twits7"
echo "Filtered twits: $filtered_twits7"

ans8=$(python3 /home/hce/trunk/api/python/ftests/properties/SOCIAL_TWITTER/title_exact_match.py 8)
echo "Ans8: $ans8"
raw_twits8=$(echo "$ans8" | cut -d'|' -f 1)
filtered_twits8=$(echo "$ans8" | cut -d'|' -f 2)
echo "Raw twits: $raw_twits8"
echo "Filtered twits: $filtered_twits8"

#ans9=$(python3 /home/hce/trunk/api/python/ftests/properties/SOCIAL_TWITTER/title_exact_match.py 9)
#echo "Ans9: $ans9"
#raw_twits9=$(echo "$ans9" | cut -d'|' -f 1)
#filtered_twits9=$(echo "$ans9" | cut -d'|' -f 2)
#echo "Raw twits: $raw_twits9"
#echo "Filtered twits: $filtered_twits9"
echo "Python script completed"
echo ''
#
#
#
# Configuring /etc/hosts
#
#
#
hosts=$(cat /etc/hosts)
hosts_original=$(cat /etc/hosts)
hosts_mod=0
echo -e "\e[00;36m$hosts"
if [[ "$hosts" == *"127.0.0.4       twitter.com"* ]]; then
    echo 'File /etc/hosts is already configured to the required state'
    hosts=$(cat /etc/hosts)
elif [[ "$hosts" != *"127.0.0.4       twitter.com"* ]];then
    echo 'File /etc/hosts is not configured to the required state. Configuring (Initiall statre will be restored once test is finished)'
    echo "127.0.0.4       twitter.com" | sudo tee -a /etc/hosts
    ((hosts_mod+=1))
fi
echo "$hosts_mod"
#
#
#
# SETTING UP APACHE2 SERVER TO RUN CURRENT TEST
#
#
#
items=$(sudo apache2ctl -S)

count=0
disableid=0
array_conf=()
arrcount=1

file="twitter_loc_exact.conf"
file2="twitter_loc_title.conf"
file3="twitter_loc_url.conf"
curdir="/home/hce/trunk/api/python/ftests/properties/SOCIAL_TWITTER"
#curdir="/home/hce/test/tony/SOCIAL_TWITTER"
#confdir="$curdir/properties/test_apache"
#confdir="$curdir/properties/test_apache"
confdir="$curdir"
apachedirav="/etc/apache2/sites-available"

for item in $items
do
    ((count+=1))
    #echo $count $item
    if [[ "$count" != "$disableid" ]]; then
        if [[ "$item" == "127.0.0.1:*" || "$item" == "*:80" || "$item" == "*" || "$item" == *":80"* || "$item" == *":2222"* ]]; then
            ((disableid=count+2))
            #echo "Disable host filename on line: $disableid"
        fi
    else
        echo "Disabling host on line $disableid"
        disable=$(echo "$item" | cut -d'/' -f 5)
        disable=$(echo "${disable:0:-3}")
        echo "$disable"
	sudo a2dissite "$disable"
        sudo systemctl reload apache2
        array_conf[$arrcount]="$disable"
        ((arrcount+=1))
    fi
done
echo ''
echo ''
echo 'Reloading Apache2 server'
sudo systemctl reload apache2
echo ''
echo ''
echo 'Enabling required configurations for current test'
echo ''
echo ''
# Enable properties_localhost_127.conf
sudo cp "$confdir/$file" "$apachedirav/$file"
sudo cp "$confdir/$file2" "$apachedirav/$file2"
sudo cp "$confdir/$file3" "$apachedirav/$file3"

#--------------------------------------------------------
echo ''
echo 'Apache2 is configured to run current test. Launching test'

# ------------------------------------------------------------------------------------------------------------------------------------------------------------------

function ctrl_c()
{
echo -e "\e[00;36mTest interrupted by Ctrl+C. Restoring initial apache2 configuration"
#Disable properties_localhost_127.conf
sudo a2dissite "$file"
sudo systemctl reload apache2
sudo a2dissite "$file2"
sudo systemctl reload apache2
sudo a2dissite "$file3"
sudo systemctl reload apache2
sudo rm "$apachedirav/$file"
sudo rm "$apachedirav/$file2"
sudo rm "$apachedirav/$file3"

#--------------------------------------------------------
echo ''
echo ''
echo 'Reloading Apache2 server'
sudo systemctl reload apache2
echo ''
echo ''
echo 'Enabling configurations that were disabled previously'
echo ''
for itemm in ${array_conf[*]}
do
    echo "Enabling Apache2 config: $itemm"
    sudo a2ensite "$itemm"
    sudo systemctl reload apache2
done
echo ''
echo ''
echo 'Reloading Apache2 server'
sudo systemctl reload apache2
echo ''
echo ''
echo 'Initial apache2 configuration has been restored'
echo ''
echo ''
if [[ "$hosts_mod" != "0" ]]; then
    echo "Restirong initial /etc/hosts configuration"
    echo "$hosts_original" | sudo tee /etc/hosts
else
    echo '/etc/hosts was not modified'
fi
echo ''
echo "Restoring initial python/ini folder configuration"
cd /home/hce/hce-node-bundle/api/python/ini

if [[ "$ini_rt_existed" == "1" ]]; then
    mv social_task-rt_backup.ini social_task-rt.ini
elif [[ "$ini_rt_existed" == "0" ]]; then
    rm social_task-rt.ini
fi

echo ''
exit 0
}

trap ctrl_c INT

# ------------------------------------------------------------------------------------------------------------------------------------------------------------
echo ''
echo "Configuring ini files supplemental to this test"
# Case 1: Search with: Title Exact Match; Filter: No
cd /home/hce/hce-node-bundle/api/python/ini
twitter_ini_existed=0
if [[ -f "social_task_twitter.ini" ]]; then
    echo "File 'social_task_twitter.ini' exists"
else
    echo "File 'social_task_twitter.ini' does not exist. Copied."
    cp "$curdir/social_task_twitter.ini" /home/hce/hce-node-bundle/api/python/ini/
    ((twitter_ini_existed+=1))
fi
ini_rt_existed=0
if [[ -f "social_task-rt.ini" ]]; then
    echo "File 'social_task-rt.ini' exists."
    mv social_task-rt.ini social_task-rt_backup.ini
    mv social_task_twitter.ini social_task-rt.ini
    ((ini_rt_existed+=1))
else
    echo "File 'social_task-rt.ini' does not exist. Renaming social_task_twitter.ini file"
    mv social_task_twitter.ini social_task-rt.ini
fi
echo -e "Done\e[00m"
# Enabling conf file for title_exact_match
sudo a2ensite "$file"
sudo systemctl reload apache2
echo ''
echo ''
echo "Launching BATCH tests for all 8 cases covered in python script earlier"
cd /home/hce/hce-node-bundle/api/python/bin

./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/SOCIAL_TWITTER/social_titleExactFilterNo.batch.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "BATCH - Twitter social CASE 1" $TMP_ERROR_MESSAGE_FILE
echo ''
batchRawTwitsBuffer1=$(jq -r '.itemsList[0].itemObject[0].processedContents[0].buffer' $TMP_RESULT_FILE | base64 -di)
batchRawTwits1=$(echo $batchRawTwitsBuffer1 | jq --raw-output '.[].social_tw_raw_posts')
batchTwits1=$(echo $batchRawTwitsBuffer1 | jq --raw-output '.[].social_tw_posts')
#echo "$batchRawTwitsBuffer1"
echo "$batchRawTwits1"
echo "$batchTwits1"

sudo a2dissite "$file"
sudo systemctl reload apache2

# Case 2: Search with: Title; Filter: Title Exact Match

sudo a2ensite "$file2"
sudo systemctl reload apache2

./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/SOCIAL_TWITTER/social_titleFilterTitleExact.batch.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "BATCH - Twitter social CASE 2" $TMP_ERROR_MESSAGE_FILE
echo ''

batchRawTwitsBuffer2=$(jq -r '.itemsList[0].itemObject[0].processedContents[0].buffer' $TMP_RESULT_FILE | base64 -di)
batchRawTwits2=$(echo $batchRawTwitsBuffer2 | jq --raw-output '.[].social_tw_raw_posts')
batchTwits2=$(echo $batchRawTwitsBuffer2 | jq --raw-output '.[].social_tw_posts')
#echo "$batchRawTwitsBuffer2"
echo "$batchRawTwits2"
echo "$batchTwits2"

sudo a2dissite "$file2"
sudo systemctl reload apache2

# Case 3: Search with: Title; Filter: No Title Exact Match

sudo a2ensite "$file2"
sudo systemctl reload apache2

./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/SOCIAL_TWITTER/social_titleFilterNoTitleExact.batch.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "BATCH - Twitter social CASE 3" $TMP_ERROR_MESSAGE_FILE
echo ''

batchRawTwitsBuffer3=$(jq -r '.itemsList[0].itemObject[0].processedContents[0].buffer' $TMP_RESULT_FILE | base64 -di)
batchRawTwits3=$(echo $batchRawTwitsBuffer3 | jq --raw-output '.[].social_tw_raw_posts')
batchTwits3=$(echo $batchRawTwitsBuffer3 | jq --raw-output '.[].social_tw_posts')
#echo "$batchRawTwitsBuffer3"
echo "$batchRawTwits3"
echo "$batchTwits3"

sudo a2dissite "$file2"
sudo systemctl reload apache2

# Case 4: Search with: Title; Filter: No

sudo a2ensite "$file2"
sudo systemctl reload apache2

./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/SOCIAL_TWITTER/social_titleFilterNo.batch.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "BATCH - Twitter social CASE 4" $TMP_ERROR_MESSAGE_FILE
echo ''

batchRawTwitsBuffer4=$(jq -r '.itemsList[0].itemObject[0].processedContents[0].buffer' $TMP_RESULT_FILE | base64 -di)
batchRawTwits4=$(echo $batchRawTwitsBuffer4 | jq --raw-output '.[].social_tw_raw_posts')
batchTwits4=$(echo $batchRawTwitsBuffer4 | jq --raw-output '.[].social_tw_posts')
#echo "$batchRawTwitsBuffer4"
echo "$batchRawTwits4"
echo "$batchTwits4"

sudo a2dissite "$file2"
sudo systemctl reload apache2

# Case 5: Search with: Title Exact Match; Filter: Url

sudo a2ensite "$file"
sudo systemctl reload apache2

./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/SOCIAL_TWITTER/social_titleExactFilterUrl.batch.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "BATCH - Twitter social CASE 5" $TMP_ERROR_MESSAGE_FILE
echo ''

batchRawTwitsBuffer5=$(jq -r '.itemsList[0].itemObject[0].processedContents[0].buffer' $TMP_RESULT_FILE | base64 -di)
batchRawTwits5=$(echo $batchRawTwitsBuffer5 | jq --raw-output '.[].social_tw_raw_posts')
batchTwits5=$(echo $batchRawTwitsBuffer5 | jq --raw-output '.[].social_tw_posts')
#echo "$batchRawTwitsBuffer5"
echo "$batchRawTwits5"
echo "$batchTwits5"

sudo a2dissite "$file"
sudo systemctl reload apache2

# Case 6: Search with: Title; Filter: Url

sudo a2ensite "$file2"
sudo systemctl reload apache2

./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/SOCIAL_TWITTER/social_titleFilterUrl.batch.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "BATCH - Twitter social CASE 6" $TMP_ERROR_MESSAGE_FILE
echo ''

batchRawTwitsBuffer6=$(jq -r '.itemsList[0].itemObject[0].processedContents[0].buffer' $TMP_RESULT_FILE | base64 -di)
batchRawTwits6=$(echo $batchRawTwitsBuffer6 | jq --raw-output '.[].social_tw_raw_posts')
batchTwits6=$(echo $batchRawTwitsBuffer6 | jq --raw-output '.[].social_tw_posts')
#echo "$batchRawTwitsBuffer6"
echo "$batchRawTwits6"
echo "$batchTwits6"

sudo a2dissite "$file2"
sudo systemctl reload apache2

# Case 7: Search with: Title Exact Match; Filter: Domain

sudo a2ensite "$file"
sudo systemctl reload apache2

./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/SOCIAL_TWITTER/social_titleExactFilterDomain.batch.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "BATCH - Twitter social CASE 7" $TMP_ERROR_MESSAGE_FILE
echo ''

batchRawTwitsBuffer7=$(jq -r '.itemsList[0].itemObject[0].processedContents[0].buffer' $TMP_RESULT_FILE | base64 -di)
batchRawTwits7=$(echo $batchRawTwitsBuffer7 | jq --raw-output '.[].social_tw_raw_posts')
batchTwits7=$(echo $batchRawTwitsBuffer7 | jq --raw-output '.[].social_tw_posts')
#echo "$batchRawTwitsBuffer7"
echo "$batchRawTwits7"
echo "$batchTwits7"

sudo a2dissite "$file"
sudo systemctl reload apache2

# Case 8: Search with: Title; Filter: Domain

sudo a2ensite "$file2"
sudo systemctl reload apache2

./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/SOCIAL_TWITTER/social_titleFilterDomain.batch.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "BATCH - Twitter social CASE 8" $TMP_ERROR_MESSAGE_FILE
echo ''

batchRawTwitsBuffer8=$(jq -r '.itemsList[0].itemObject[0].processedContents[0].buffer' $TMP_RESULT_FILE | base64 -di)
batchRawTwits8=$(echo $batchRawTwitsBuffer8 | jq --raw-output '.[].social_tw_raw_posts')
batchTwits8=$(echo $batchRawTwitsBuffer8 | jq --raw-output '.[].social_tw_posts')
#echo "$batchRawTwitsBuffer8"
echo "$batchRawTwits8"
echo "$batchTwits8"

sudo a2dissite "$file2"
sudo systemctl reload apache2

# Case 9: Search with: Url; Filter: No
#
#sudo a2ensite "$file3"
#sudo systemctl reload apache2
#
#./dc-client.py --config=../ini/dc-client.ini --command=BATCH --file=/home/hce/trunk/api/python/data/ftests/properties_json/SOCIAL_TWITTER/social_Url.batch.json > $TMP_RESULT_FILE
#checkErrors
#breakOnError $? "BATCH - Twitter social CASE 9" $TMP_ERROR_MESSAGE_FILE
#echo ''

#batchRawTwitsBuffer9=$(jq -r '.itemsList[0].itemObject[0].processedContents[0].buffer' $TMP_RESULT_FILE | base64 -di)
#batchRawTwits9=$(echo $batchRawTwitsBuffer9 | jq --raw-output '.[].social_tw_raw_posts')
#batchTwits9=$(echo $batchRawTwitsBuffer9 | jq --raw-output '.[].social_tw_posts')
#echo "$batchRawTwitsBuffer9"
#echo "$batchRawTwits9"
#echo "$batchTwits9"
#echo ''
#echo ''
#echo 'BATCH tests complete'
#echo ''
#echo ''
#echo "Comparing values from python script and BATCh test results"
#echo ''
#echo ''

# CASE 1

if [[ "$raw_twits" == "$batchRawTwits1"  ]]; then
    echo -e "\e[00;32mCase 1: raw_twits are CORRECT\e[00m"
else
    echo -e "\e[00;31mCase 1: raw_twits are INCORRECT\e[00m"
    ((errors+=1))
fi

if [[ "$filtered_twits" == "$batchTwits1"  ]]; then
    echo -e "\e[00;32mCase 1: filtered_twits are CORRECT\e[00m"
else
    echo -e "\e[00;31mCase 1: filtered_twits are INCORRECT\e[00m"
    ((errors+=1))
fi

# CASE 2

if [[ "$raw_twits2" == "$batchRawTwits2"  ]]; then
    echo -e "\e[00;32mCase 2: raw_twits are CORRECT\e[00m"
else
    echo -e "\e[00;31mCase 2: raw_twits are INCORRECT\e[00m"
    ((errors+=1))
fi

if [[ "$filtered_twits2" == "$batchTwits2"  ]]; then
    echo -e "\e[00;32mCase 2: filtered_twits are CORRECT\e[00m"
else
    echo -e "\e[00;31mCase 2: filtered_twits are INCORRECT\e[00m"
    ((errors+=1))
fi

# CASE 3

if [[ "$raw_twits3" == "$batchRawTwits3"  ]]; then
    echo -e "\e[00;32mCase 3: raw_twits are CORRECT\e[00m"
else
    echo -e "\e[00;31mCase 3: raw_twits are INCORRECT\e[00m"
    ((errors+=1))
fi

if [[ "$filtered_twits3" == "$batchTwits3"  ]]; then
    echo -e "\e[00;32mCase 3: filtered_twits are CORRECT\e[00m"
else
    echo -e "\e[00;31mCase 3: filtered_twits are INCORRECT\e[00m"
    ((errors+=1))
fi

# CASE 4

if [[ "$raw_twits4" == "$batchRawTwits4"  ]]; then
    echo -e "\e[00;32mCase 4: raw_twits are CORRECT\e[00m"
else
    echo -e "\e[00;31mCase 4: raw_twits are INCORRECT\e[00m"
    ((errors+=1))
fi
#echo "sel4-f: $filtered_twits4| batch4-f: $batchTwits4"

if [[ "$filtered_twits4" == "$batchTwits4"  ]]; then
    echo -e "\e[00;32mCase 4: filtered_twits are CORRECT\e[00m"
else
    echo -e "\e[00;31mCase 4: filtered_twits are INCORRECT\e[00m"
    ((errors+=1))
fi

# CASE 5

if [[ "$raw_twits5" == "$batchRawTwits5"  ]]; then
    echo -e "\e[00;32mCase 5: raw_twits are CORRECT\e[00m"
else
    echo -e "\e[00;31mCase 5: raw_twits are INCORRECT\e[00m"
    ((errors+=1))
fi
#echo "sel4-f: $filtered_twits5| batch4-f: $batchTwits5"

if [[ "$filtered_twits5" == "$batchTwits5"  ]]; then
    echo -e "\e[00;32mCase 5: filtered_twits are CORRECT\e[00m"
else
    echo -e "\e[00;31mCase 5: filtered_twits are INCORRECT\e[00m"
    ((errors+=1))
fi


# CASE 6

if [[ "$raw_twits6" == "$batchRawTwits6"  ]]; then
    echo -e "\e[00;32mCase 6: raw_twits are CORRECT\e[00m"
else
    echo -e "\e[00;31mCase 6: raw_twits are INCORRECT\e[00m"
    ((errors+=1))
fi

if [[ "$filtered_twits6" == "$batchTwits6"  ]]; then
    echo -e "\e[00;32mCase 6: filtered_twits are CORRECT\e[00m"
else
    echo -e "\e[00;31mCase 6: filtered_twits are INCORRECT\e[00m"
    ((errors+=1))
fi

# CASE 7
#echo "raw7: $raw_twits7 | $batchRawTwits7"
if [[ "$raw_twits7" == "$batchRawTwits7"  ]]; then
    echo -e "\e[00;32mCase 7: raw_twits are CORRECT\e[00m"
else
    echo -e "\e[00;31mCase 7: raw_twits are INCORRECT\e[00m"
    ((errors+=1))
fi
#echo "filter7: $filtered_twits7 | $batchTwits7"

if [[ "$filtered_twits7" == "$batchTwits7"  ]]; then
    echo -e "\e[00;32mCase 7: filtered_twits are CORRECT\e[00m"
else
    echo -e "\e[00;31mCase 7: filtered_twits are INCORRECT\e[00m"
    ((errors+=1))
fi

# CASE 8

if [[ "$raw_twits8" == "$batchRawTwits8"  ]]; then
    echo -e "\e[00;32mCase 8: raw_twits are CORRECT\e[00m"
else
    echo -e "\e[00;31mCase 8: raw_twits are INCORRECT\e[00m"
    ((errors+=1))
fi

if [[ "$filtered_twits8" == "$batchTwits8"  ]]; then
    echo -e "\e[00;32mCase 8: filtered_twits are CORRECT\e[00m"
else
    echo -e "\e[00;31mCase 8: filtered_twits are INCORRECT\e[00m"
    ((errors+=1))
fi

# CASE 9

#if [[ "$raw_twits9" == "$batchRawTwits9"  ]]; then
#    echo -e "\e[00;32mCase 9: raw_twits are CORRECT\e[00m"
#else
#    echo -e "\e[00;31mCase 9: raw_twits are INCORRECT\e[00m"
#    ((errors+=1))
#fi

#if [[ "$filtered_twits9" == "$batchTwits9"  ]]; then
#    echo -e "\e[00;32mCase 9: filtered_twits are CORRECT\e[00m"
#else
#    echo -e "\e[00;31mCase 9: filtered_twits are INCORRECT\e[00m"
#    ((errors+=1))
#fi
#
#sudo a2dissite "$file3"
#sudo systemctl reload apache2

#-------------------------------------------------------------------
#
#
#
# Restoring ini folder
#
#
#
echo ''
echo -e "\e[00;36mRestoring initial python/ini folder configuration"
cd /home/hce/hce-node-bundle/api/python/ini

if [[ "$ini_rt_existed" == "1" ]]; then
    mv social_task-rt_backup.ini social_task-rt.ini
elif [[ "$ini_rt_existed" == "0" ]]; then
    rm social_task-rt.ini
fi
echo ''
#-------------------------------------------------------------------
#
#
#
# RESTORING INITIAL APACHE2 SERVER CONFIGURATION
#
#
#
echo 'Test completed. Restoring initial apache2 configuration'
sudo a2dissite "$file"
sudo a2dissite "$file2"
sudo a2dissite "$file3"
sudo rm "$apachedirav/$file"
sudo rm "$apachedirav/$file2"
sudo rm "$apachedirav/$file3"

#--------------------------------------------------------
echo ''
echo ''
echo 'Reloading Apache2 server'
sudo systemctl reload apache2
echo ''
echo ''
echo 'Enabling configurations that were disabled previously'
echo ''
for itemm in ${array_conf[*]}
do
    echo "Enabling Apache2 config: $itemm"
    sudo a2ensite "$itemm"
    sudo systemctl reload apache2
done
echo ''
echo ''
echo 'Reloading Apache2 server'
sudo systemctl reload apache2
echo ''
echo ''
echo 'Initial apache2 configuration has been restored'
echo ''
#
#
#
# Restirong initial /etc/hosts configuration
#
#
#
echo ''
echo ''
if [[ "$hosts_mod" != "0" ]]; then
    echo "Restirong initial /etc/hosts configuration"
    echo "$hosts_original" | sudo tee /etc/hosts
else
    echo '/etc/hosts was not modified'
fi
echo ''
echo ''



if [[ $errors != 0 ]]; then
    echo -e "\e[1;31mErrors in test: $errors\e[0m"
    exit 1
else
    echo -e "\e[1;32mTest compleded successfully\e[0m"
    exit 0
fi
