#!/usr/bin/env python3
import sys
from selenium import webdriver
from selenium.webdriver.common.by import By
from selenium.webdriver.support.ui import WebDriverWait
from selenium.webdriver.support import expected_conditions as EC
from selenium.webdriver.common.action_chains import ActionChains
from selenium.common.exceptions import NoSuchElementException, TimeoutException
from selenium.webdriver.common.keys import Keys
from re import search, findall, IGNORECASE
from collections import Counter
import requests


def timeout():
    raise Exception("Some elements on page took too long to load. Internet connection may have also been disrupted.")


# sys.tracebacklimit = 0
if len(sys.argv) == 1:
    raise Exception("No argument supplied. Try again with a numerical argument.")
elif len(sys.argv) > 2:
    raise Exception("Too much arguments supplied. Only one argument is allowed")
try:
    int(sys.argv[1])
except Exception:
    raise Exception("Argument is not int. Try again using integer value for the argument")
else:
    p = int(sys.argv[1])
if p <= 0:
    raise Exception("Value error. Input a positive value!")

try:
    chrmdrv = "/usr/bin/chromedriver"
    drv = webdriver.Chrome(chrmdrv)
    arg = int(sys.argv[1])
    if arg == 1:
        #
        # Case 1: Search with: Title Exact Match; Filter: No
        #
        # print("\n# Case 1: Search with: Title Exact Match; Filter: No")
        drv.get("http://127.0.0.1/twitter_soc/searchTitleExactMatch.html")
        WebDriverWait(drv, 50).until(EC.presence_of_element_located((By.CLASS_NAME, "js-tweet-text-container")))
        twits = [x.text for x in drv.find_elements_by_class_name("js-tweet-text-container")]
        # print("Twits found: ", len(twits))
        posts = len(twits)
        TitleExactFilterNo = 0
        key = "Male violence and US mass shootings"
        for i in range(0, len(twits)):
            if search('Male violence and US mass shootings', twits[i]):
                TitleExactFilterNo += 1
        # print("Exact title match in all twits: ", TitleExactFilterNo)
        ext_code = str(posts) + "|" + str(TitleExactFilterNo)
        # print(ext_code)
        print(ext_code)
    elif arg == 2:
        #
        # Case 2: Search with: Title; Filter: Title Exact Match
        #
        # print("\n# Case 2: Search with: Title; Filter: Title Exact Match")
        drv.get("http://127.0.0.1/twitter_soc/searchTitle.html")
        WebDriverWait(drv, 50).until(EC.presence_of_element_located((By.CLASS_NAME, "js-tweet-text-container")))
        twits2 = [x.text for x in drv.find_elements_by_class_name("js-tweet-text-container")]
        # print("Twits found: ", len(twits2))
        posts = len(twits2)
        TitleFilterTitleExact = 0
        key = "Male violence and US mass shootings"
        for i in range(0, len(twits2)):
            if search('Male violence and US mass shootings', twits2[i]):
                TitleFilterTitleExact += 1
        # print("Exact title match in all twits: ", TitleFilterTitleExact)
        ext_code = str(posts) + "|" + str(TitleFilterTitleExact)
        # print(ext_code)
        print(ext_code)
    elif arg == 3:
        #
        # Case 3: Search with: Title; Filter: No Title Exact Match
        #
        # print("\n# Case 3: Search with: Title; Filter: No Title Exact Match")
        drv.get("http://127.0.0.1/twitter_soc/searchTitle.html")
        WebDriverWait(drv, 50).until(EC.presence_of_element_located((By.CLASS_NAME, "js-tweet-text-container")))
        twits3 = [x.text for x in drv.find_elements_by_class_name("js-tweet-text-container")]
        # print("Twits found: ", len(twits3))
        posts = len(twits3)
        TitleFilterNoTitleExact = 0
        key = "Male violence and US mass shootings"
        for i in range(0, len(twits3)):
            if not search('Male violence and US mass shootings', twits3[i]):
                TitleFilterNoTitleExact += 1
        # print("Exact title match in all twits: ", TitleFilterNoTitleExact)
        ext_code = str(posts) + "|" + str(TitleFilterNoTitleExact)
        # print(ext_code)
        print(ext_code)
    elif arg == 4:
        #
        # Case 4: Search with: Title; Filter: No
        #
        # print("\n# Case 4: Search with: Title; Filter: No")
        drv.get("http://127.0.0.1/twitter_soc/searchTitle.html")
        WebDriverWait(drv, 10).until(EC.presence_of_element_located((By.CLASS_NAME, "js-tweet-text-container")))
        twits4 = [x.text for x in drv.find_elements_by_class_name("js-tweet-text-container")]
        # print("Twits found: ", len(twits4))
        posts = len(twits4)
        TitleFilterNoTitleExact = posts
        # print("Exact title match in all twits: ", TitleFilterNoTitleExact)
        ext_code = str(posts) + "|" + str(TitleFilterNoTitleExact)
        # print(ext_code)
        print(ext_code)
    elif arg == 5:
        #
        # Case 5: Search with: Title Exact Match; Filter: Url
        #
        # print("\n# Case 5: Search with: Title Exact Match; Filter: Url")
        drv.get("http://127.0.0.1/twitter_soc/searchTitleExactMatch.html")
        WebDriverWait(drv, 50).until(EC.presence_of_element_located((By.CLASS_NAME, "js-tweet-text-container")))
        twits5 = [x.text for x in drv.find_elements_by_class_name("js-tweet-text-container")]
        # print("Twits found: ", len(twits5))
        posts = len(twits5)
        TitleExactFilterUrl = 0
        for i in range(0, len(twits5)):
            urls = findall('http[s]?://(?:[a-zA-Z]|[0-9]|[$-_@.&+]|[!*\(\),]|(?:%[0-9a-fA-F][0-9a-fA-F]))+', twits5[i])
            # print(urls)
            for k in urls:
                if search('https://www.theguardian.com/us-news/2019/aug/06/male-violence-and-us-mass-shootings', k):
                    TitleExactFilterUrl += 1
                elif k != '':
                    r = requests.get(k, allow_redirects=True)
                    if search('https://www.theguardian.com/us-news/2019/aug/06/male-violence-and-us-mass-shootings', r.url):
                        TitleExactFilterUrl += 1
        # print("Exact title match in all twits: ", TitleExactFilterUrl)
        ext_code = str(posts) + "|" + str(TitleExactFilterUrl)
        # print(ext_code)
        print(ext_code)
    elif arg == 6:
        #
        # Case 6: Search with: Title; Filter: Url
        #
        # print("\n# Case 6: Search with: Title; Filter: Url")
        drv.get("http://127.0.0.1/twitter_soc/searchTitle.html")
        WebDriverWait(drv, 50).until(EC.presence_of_element_located((By.CLASS_NAME, "js-tweet-text-container")))
        twits6 = [x.text for x in drv.find_elements_by_class_name("js-tweet-text-container")]
        # print("Twits found: ", len(twits6))
        posts = len(twits6)
        TitleFilterUrl = 0
        for i in range(0, len(twits6)):
            urls = findall('http[s]?://(?:[a-zA-Z]|[0-9]|[$-_@.&+]|[!*\(\),]|(?:%[0-9a-fA-F][0-9a-fA-F]))+', twits6[i])
            # print(urls)
            for k in urls:
                if search('https://www.theguardian.com/us-news/2019/aug/06/male-violence-and-us-mass-shootings', k):
                    TitleFilterUrl += 1
                elif k != '':
                    if search('https://twitter.com', k):
                        TitleFilterUrl += 0
                        continue
                    else:
                        r = requests.get(k, allow_redirects=True)
                        if search('https://www.theguardian.com/us-news/2019/aug/06/male-violence-and-us-mass-shootings', r.url):
                            TitleFilterUrl += 1
        # print("Exact title match in all twits: ", TitleFilterUrl)
        ext_code = str(posts) + "|" + str(TitleFilterUrl)
        # print(ext_code)
        print(ext_code)
    elif arg == 7:
        #
        # Case 7: Search with: Title Exact Match; Filter: Domain
        #
        # print("\n# Case 7: Search with: Title Exact Match; Filter: Domain")
        drv.get("http://127.0.0.1/twitter_soc/searchTitleExactMatch.html")
        WebDriverWait(drv, 50).until(EC.presence_of_element_located((By.CLASS_NAME, "js-tweet-text-container")))
        twits7 = [x.text for x in drv.find_elements_by_class_name("js-tweet-text-container")]
        # print("Twits found: ", len(twits7))
        posts = len(twits7)
        TitleExactFilterDomain = 0
        for i in range(0, len(twits7)):
            urls = findall('http[s]?://(?:[a-zA-Z]|[0-9]|[$-_@.&+]|[!*\(\),]|(?:%[0-9a-fA-F][0-9a-fA-F]))+', twits7[i])
            # print(urls)
            for k in urls:
                if search('theguardian.com', k):
                    TitleExactFilterDomain += 1
                elif k != '':
                    if search('https://twitter.com', k):
                        TitleExactFilterDomain += 0
                        continue
                    else:
                        r = requests.get(k, allow_redirects=True)
                        if search('theguardian.com', r.url):
                            TitleExactFilterDomain += 1
        # print("Exact title match in all twits: ", TitleExactFilterDomain)
        ext_code = str(posts) + "|" + str(TitleExactFilterDomain)
        # print(ext_code)
        print(ext_code)
    elif arg == 8:
        #
        # Case 8: Search with: Title; Filter: Domain
        #
        # print("\n# Case 8: Search with: Title; Filter: Domain")
        drv.get("http://127.0.0.1/twitter_soc/searchTitle.html")
        WebDriverWait(drv, 50).until(EC.presence_of_element_located((By.CLASS_NAME, "js-tweet-text-container")))
        twits8 = [x.text for x in drv.find_elements_by_class_name("js-tweet-text-container")]
        # print("Twits found: ", len(twits8))
        posts = len(twits8)
        TitleFilterDomain = 0
        for i in range(0, len(twits8)):
            urls = findall('http[s]?://(?:[a-zA-Z]|[0-9]|[$-_@.&+]|[!*\(\),]|(?:%[0-9a-fA-F][0-9a-fA-F]))+', twits8[i])
            # print(urls)
            for k in urls:
                if search('theguardian.com', k):
                    TitleFilterDomain += 1
                elif k != '':
                    if search('https://twitter.com', k):
                        TitleFilterDomain += 0
                        continue
                    else:
                        r = requests.get(k, allow_redirects=True)
                        if search('theguardian.com', r.url):
                            TitleFilterDomain += 1
        # print("Exact title match in all twits: ", TitleFilterDomain)
        ext_code = str(posts) + "|" + str(TitleFilterDomain)
        # print(ext_code)
        print(ext_code)
    elif arg == 9:
        #
        # Case 9: Search with: Url; Filter: No
        #
        # print("\n # Case 9: Search with: Url; Filter: No")
        drv.get("http://127.0.0.1/twitter_soc/searchURL.html")
        WebDriverWait(drv, 50).until(EC.presence_of_element_located((By.CLASS_NAME, "js-tweet-text-container")))
        twits9 = [x.text for x in drv.find_elements_by_class_name("js-tweet-text-container")]
        # print("Twits found: ", len(twits9))
        posts = len(twits9)
        ext_code = str(posts) + "|" + str(posts)
        # print(ext_code)
        print(ext_code)
    else:
        print("Argument is not within the correct range. Try again and input values 1 - 9 ...")
except TimeoutException:
    timeout()
finally:
    drv.quit()
