#!/bin/bash

# Executor - Tim
# Subject of testing - property URLS_LOGGING

set +e
# The 'basename $0' returns the filename.
base=$(basename $0)
TMP_RESULT_FILE=$(mktemp /tmp/result.$base.XXXXX)
RESULT_FILE_CONTENT=$(mktemp /tmp/content_result.$base.XXXXX)
TMP_ERROR_MESSAGE_FILE=$(mktemp /tmp/message.$base.XXXXX)
echo 'RESULT FILE: '$TMP_RESULT_FILE
function checkErrors()
## Return 1 - if check is fail, or 0 - otherwise
{
        ERROR_CODE=$(jq -r '.errorCode' $TMP_RESULT_FILE)

        ERROR_MESSAGE=$(jq -r '.errorMessage' $TMP_RESULT_FILE)
#echo "--${ERROR_MESSAGE}-- **${ERROR_CODE}**"

        if [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "" ]
        then
                ERROR_CODE=$(jq -r '.itemsList[0].errorCode' $TMP_RESULT_FILE)

                ERROR_MESSAGE=$(jq -r '.itemsList[0].errorMessage' $TMP_RESULT_FILE)

                if [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "" ] || [ "$ERROR_MESSAGE" = "OK" ] || [ "$ERROR_MESSAGE" = "0" ]
                then
		            ITEMOBJECT=$(jq -r '.itemsList[0].itemObject | length' $TMP_RESULT_FILE)


#echo "item_obj: " $ITEMOBJECT


                if [ $ITEMOBJECT -gt 0 ]
                then

                    ERROR_CODE=$(jq -r '.itemsList[0].itemObject.errorCode' $TMP_RESULT_FILE)
                    ERROR_MESSAGE=$(jq -r '.itemsList[0].itemObject.errorMessage' $TMP_RESULT_FILE)

    		            if [ "$ERROR_CODE" = "0" ] && [ "$ERROR_MESSAGE" = "" ] || [ "$ERROR_MESSAGE" = "OK" ] || [ "$ERROR_CODE" = "null" ] || [ "$ERROR_MESSAGE" = "null" ]
    		            then

    			            return 0
    		            else

    			            echo $ERROR_MESSAGE > $TMP_ERROR_MESSAGE_FILE
    			            return 1
    		            fi


                else

                  echo $ERROR_MESSAGE > $TMP_ERROR_MESSAGE_FILE
    			        return 1
                fi


                return 0
                fi

        else
		      echo $ERROR_MESSAGE > $TMP_ERROR_MESSAGE_FILE
		      return 1
        fi
}

function breakOnError()
# exit for error
{
if [ $1 -eq 0 ]; then
    echo -e "\e[36m$2\e[0m - \e[1;32mSuccess\e[0m"
else
    echo -e "\e[1;36m$2\e[0m - \e[1;31mFail\e[0m"
    if [ "$3" != "" ]; then
    cat $3
    fi
    exit 1
fi
}
#TMP_RESULT_FILE='/tmp/result.url_logging.RCVxc'
#checkErrors
#breakOnError $? "SITE_STATUS"
#exit

echo "Test start"
echo "Remove logs"
cd /tmp
if [[ $(ls -l | grep urls_ | wc -l) -gt "1" ]]; then
#if [[ -f urls_199fcf4591fc23e79b839d8819904294_feed.txt ]]; then
	rm urls_*.txt
	echo "Logs have been removed"
else
	echo "Logs are empty"
fi
#Check if project exists
cd /home/hce/hce-node-bundle/api/python/bin
./dc-client.py --config=../ini/dc-client.ini --command=SITE_UPDATE --file=/home/hce/trunk/api/python/data/ftests/properties_json/URL_LOGGING/test_URL_LOGGING_ALL.site_status.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "SITE_UPDATE"
exists=$(jq -r '.itemsList[0].itemObject.errorMessage' $TMP_RESULT_FILE)
#echo $exists
echo ''
if [[ "${exists}" = "null"  ]]; then
  #Delete project
  echo 'Project already exists. Deleting project'
  #Delete project and all related data and structures from DC service.
  cd /home/hce/hce-node-bundle/api/python/bin
  ./dc-client.py --config=../ini/dc-client.ini --command=SITE_DELETE --file=/home/hce/trunk/api/python/data/ftests/properties_json/URL_LOGGING/test_URL_LOGGING_ALL.site_delete.json > $TMP_RESULT_FILE
  checkErrors
  breakOnError $? "SITE_DELETE"
  sleep 15
fi



cd /home/hce/hce-node-bundle/api/python/bin
echo "Create new site" >> ../log/${base}.log 2>&1
# Create a new project in the DC service, sets root URLs, initialize templates, patterns and another related structures.
# In case of conditions are succeed new site included in to the crawling right after creation.
#./dc-client.py --config=../ini/dc-client.ini --command=SITE_NEW --file=/home/hce/trunk/api/python/data/ftests/properties_json/URL_LOGGING/test_URL_LOGGING_ALL.site_new.json > $TMP_RESULT_FILE
./dc-client.py --config=../ini/dc-client.ini --command=SITE_NEW --file=/home/hce/trunk/api/python/data/ftests/properties_json/URL_LOGGING/urllogging.json > $TMP_RESULT_FILE
#urllogging.json
checkErrors
breakOnError $? "SITE_NEW" $TMP_ERROR_MESSAGE_FILE
#echo “STATUS:”$?
#exit
echo 'Site create...'
echo ''
echo 'Start project crawling'
echo '...'
sleep 180
echo 'Crawled'
echo 'Start project processing'
echo '...'
sleep 60
echo 'Processed'
echo ''


#echo -e "Delete an url"
cd /home/hce/hce-node-bundle/api/python/bin
./dc-client.py --config=../ini/dc-client.ini --command=URL_DELETE --file=/home/hce/trunk/api/python/data/ftests/properties_json/URL_LOGGING/test_URL_LOGGING_ALL.url_delete.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "URL_DELETE"


# Returns the project state inside DC service.
# Can be used to check presence of project (id), find out the state of the project (STATE_ACTIVE = 1, STATE_DISABLED = 2, STATE_SUSPENDED = 3, STATE_DELETED = 4, STATE_DELETE_TASK = 5, STATE_RESTART = 6, STATE_CLEANED = 7, STATE_CLEANUP_TASK = 8, STATE_NOT_FOUND = 9).
./dc-client.py --config=../ini/dc-client.ini --command=SITE_STATUS --file=/home/hce/trunk/api/python/data/ftests/properties_json/URL_LOGGING/test_URL_LOGGING_ALL.site_status.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "SITE_STATUS"

#echo $TMP_RESULT_FILE


# Updates fields of existing project in the DC service.
./dc-client.py --config=../ini/dc-client.ini --command=SITE_UPDATE --file=/home/hce/trunk/api/python/data/ftests/properties_json/URL_LOGGING/test_URL_LOGGING_ALL.site_update.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "SITE_UPDATE"

sleep 180


#echo $TMP_RESULT_FILE


# Returns the array of url objects satisfies with criterions and selection conditions.
 # Can be used to check state of resources, also, used internally by DC service to make crawling batches. Can also change state and other fields of selected URL objects

#echo $TMP_RESULT_FILE


echo -e "\e[36mURL_FETCH\e[0m - \e[1;32mSuccess\e[0m"


FETCH_COUNT=$(jq '.itemsList[0].itemObject | length' $TMP_RESULT_FILE)
# Check the number of crawled resources
# echo -e "\e[36mFETCH_COUNT - 5 links \e[0m"


echo $FETCH_COUNT " links crawled"
# URL_DELETE #
#echo -e "Delete an url"
#cd /home/hce/hce-node-bundle/api/python/bin
#./dc-client.py --config=../ini/dc-client.ini --command=URL_DELETE --file=/home/hce/trunk/api/python/data/ftests/properties_json/URL_LOGGING/test_URL_LOGGING_ALL.url_delete.json > $TMP_RESULT_FILE
#checkErrors
#breakOnError $? "URL_DELETE"

#sleep 60 
#./dc-client.py --config=../ini/dc-client.ini --command=SITE_STATUS --file=/home/hce/trunk/api/python/data/ftests/properties_json/URL_LOGGING/test_URL_LOGGING_ALL.site_status.json > $TMP_RESULT_FILE
#checkErrors
#breakOnError $? "SITE_STATUS"

#echo $TMP_RESULT_FILE
./dc-client.py -config=../ini/dc-client.ini --command=URL_CONTENT --file=/home/hce/trunk/api/python/data/ftests/properties_json/URL_LOGGING/test_URL_LOGGING_ALL.url_content_header.json > $TMP_RESULT_FILE
checkErrors
breakOnError $? "GET_HEADERS"
CONTENT_GET=$(jq -r '.itemsList[0].itemObject[0].dbFields[0].ContentType' $TMP_RESULT_FILE )
echo $CONTENT_GET
if [[ $CONTENT_GET == "text/html" ]]; then
        echo -e "\e[36mReplace of http headers\e[0m - \e[1;32mSuccess\e[0m"
else
        echo -e "\e[36mReplace\e[0m - \e[1;31mError\e[0m"
fi



cd /tmp
if [[ $(cat urls_*feed.txt | grep http | wc -l) -ge "3" ]]; then 
        echo -e "\e[36mFeed logs is\e[0m - \e[1;32mSuccess\e[0m"
else
        echo -e "\e[36mFeed logs\e[0m - \e[1;31mError\e[0m"
fi

if [[ $(cat urls_*skipped.txt | grep cgi_else.py,None,None | wc -l) -gt "2" ]]; then 
        echo -e "\e[36mOne url skipped\e[0m - \e[1;32mSuccess\e[0m"
else
        echo -e "\e[36mSkipped logs\e[0m - \e[1;31mError\e[0m"
fi

if [[ $(cat urls_*collect.txt | grep http | wc -l) -ge "3" ]]; then 
        echo -e "\e[36mCollect logs is\e[0m - \e[1;32mSuccess\e[0m"
else
        echo -e "\e[36mCollect logs\e[0m - \e[1;31mError\e[0m"
fi

if [[ $(cat urls_*insert.txt | grep http | wc -l) -ge "2" ]]; then 
        echo -e "\e[36mInsert logs is\e[0m - \e[1;32mSuccess\e[0m"
else
        echo -e "\e[36mInsert logs\e[0m - \e[1;31mError\e[0m"
fi



 #Delete project and all related data and structures from DC service.
#cd /home/hce/hce-node-bundle/api/python/bin
#./dc-client.py --config=../ini/dc-client.ini --command=SITE_DELETE --file=/home/hce/trunk/api/python/data/ftests/properties_json/URL_LOGGING/test_URL_LOGGING_ALL.site_delete.json > $TMP_RESULT_FILE
#checkErrors
#breakOnError $? "SITE_DELETE"
#echo ""
#echo 'Project was deleted'


