#!/bin/bash

#Executor - Anton Dmytrenko
#Script description - THe script checks if current configuration of apache2 server is aplicable for combiProperties.sh test script and configures it if not
#After test finishes the following script restores previous apache2 configuration

curdir=$(pwd)
#confdir="$curdir/properties/test_apache"
confdir=$curdir
apachediren="/etc/apache2/sites-enabled"
apachedirav="/etc/apache2/sites-available"
backup=0
enable_only=0
origin_enabled=0
#echo $curdir
#echo $confdir
cd $apachediren
file="localhost_127.conf"
file2="user_proxy.conf"
if [[ -f "${file}" ]]; then
    echo "File ${file} exists in 'sites-enabled' folder. Checking its contents in sites-available folder"
    cd $apachedirav
    ((origin_enabled+=1))
    if [[ -s "${file}"  ]]; then
        echo "File is not empty"
        file_contents=$(cat $file)
        #echo $file_contents
        if [[ $file_contents == *'+ExecCGI'* && $file_contents == *'AddHandler cgi-script .py'* && $file_contents == *'<Directory /var/www/html/python_cgi>'*  ]]; then
            echo "'$file' file is correct for running current test"
            echo 'Launching test'
        else
            echo "File $file is not correct for this test. Overwriting file (Original will be saved and restored after test finished)"
            cd $apachedirav
            sudo a2dissite "$file"
            sudo systemctl reload apache2
            sudo mv "${file}" "backup_$file"
            ((backup+=1))
            sudo cp "$confdir/$file" "$apachedirav/properties_$file"
            sudo a2ensite "properties_$file"
            sudo systemctl reload apache2
            echo "Done"
            echo "Launching test"
        fi
    else
        echo "File is empty"
        echo "File $file is not correct for this test. Overwriting file (Original will be saved and restored after test finished)"
        cd $apachedirav
        sudo a2dissite "$file"
        sudo systemctl reload apache2
        sudo mv "${file}" "backup_$file"
        ((backup+=1))
        sudo cp "$confdir/$file" "$apachedirav/properties_$file"
        sudo a2ensite "properties_$file"
        sudo systemctl reload apache2
        echo "Done"
        echo "Launching test"
    fi
else
    echo "File $file doesn't exist in sites-enabled folder. Checking in sites-available folder"
    cd $apachedirav
    if [[ -f "${file}" ]]; then
        echo "File ${file} exists in 'sites-available' folder."
        cd $apachedirav
        if [[ -s "${file}"  ]]; then
            echo "File is not empty"
            file_contents=$(cat $file)
            #echo $file_contents
            if [[ $file_contents == *'+ExecCGI'* && $file_contents == *'AddHandler cgi-script .py'* && $file_contents == *'<Directory /var/www/html/python_cgi>'*  ]]; then
                echo "'$file' file is correct for running current test. Enabling it in apache (after test complete current state will be restored)"
                sudo a2ensite "$file"
                ((enable_only+=1))
                sudo systemctl reload apache2
                echo "Done"
                echo "Launching test"
            else
                echo 'File $file is not correct for this test. Overwriting file (Original will be saved and restored after test finished)'
                cd $apachedirav
                sudo mv "${file}" "backup_$file"
                ((backup+=1))
                sudo cp "$confdir/$file" "$apachedirav/properties_$file"
                sudo a2ensite "properties_$file"
                sudo systemctl reload apache2
                echo "Done"
                echo "Launching test"
            fi
        else
            echo "File is empty"
            echo "File $file is not correct for this test. Overwriting file (Original will be saved and restored after test finished)"
            cd $apachedirav
            sudo mv "${file}" "backup_$file"
            ((backup+=1))
            sudo cp "$confdir/$file" "$apachedirav/properties_$file"
            sudo a2ensite "properties_$file"
            sudo systemctl reload apache2
            echo "Done"
            echo "Launching test"
        fi
    fi
fi


sleep 40


if [[ $enable_only == 0 && $backup != 0 ]]; then
    echo "Test finished. Restoring initial apache configuration"
    cd $apachedirav
    sudo a2dissite "properties_$file"
    sudo systemctl reload apache2
    sudo rm "properties_$file"
    sudo mv "backup_$file" "$file"
    if [[ $origin_enabled != 0  ]]; then
        sudo a2ensite "$file"
        sudo systemctl reload apache2
    fi
    echo "Done"
    echo "Initial apache configuration has been restored"
    exit 0
elif [[ $enable_only != 0 ]]; then
    echo "Test finished. Restoring initial apache configuration"
    cd $apachedirav
    sudo a2dissite "$file"
    sudo systemctl reload apache2
    echo "Done"
    echo "Initial apache configuration has been restored"
    exit 0
else
    echo "Test finished"
fi
