#!/usr/bin/python
# coding: utf-8

import logging
import logging.config
import ConfigParser
import requests
from app.Utils import varDump
import app.Consts as APP_CONSTS
from app.ContentEvaluator import ContentEvaluator
import dc_crawler.DBTasksWrapper as DBTasksWrapper
from dc_crawler.Fetcher import Response


def getLogger():
  # create logger
  log = logging.getLogger()
  log.setLevel(logging.DEBUG)

  # create console handler and set level to debug
  ch = logging.StreamHandler()
  ch.setLevel(logging.DEBUG)

  # create formatter
  formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')

  # add formatter to ch
  ch.setFormatter(formatter)

  # add ch to logger
  log.addHandler(ch)

  return log


def getDBWrapper():
  CONFIG_NAME = "../../ini_default/db-task.ini"
  cfgParser = ConfigParser.ConfigParser()
  cfgParser.read(CONFIG_NAME)
  return DBTasksWrapper.DBTasksWrapper(cfgParser)



logger = getLogger()
dbWrapper = getDBWrapper()

response = Response()
response.rendered_unicode_content = '****************<!--TEST-->*****************'

# properties = "[{\"WHERE\":\"RAW\", \"WHAT\":\"<!--(.*)-->\", \"WITH\":\" \", \"CONDITION\":\"ContentType='text/html'\"}]"

sqlExpression = "ContentType='text/html'"
siteId = '0'
url = 'https://tracking.feedpress.it/link/20202/10985042'  # (redirect to domain: bloomberg.com)
url = 'https://www.bloomberg.com/news/articles/2019-01-14/hedge-fund-known-for-milking-newspapers-takes-aim-at-gannett'

res = requests.head(url, allow_redirects=True)
logger.info("res.status_code = %s", str(res.status_code))
response.headers = res.headers

# logger.debug("Input response.headers: %s", varDump(response.headers, stringifyType=0))
logger.debug("Input response.headers: %s", str(response.headers))

properties = {}
properties[".*"] = [{"WHERE":"RAW", "WHAT":"<!--(.|\n)*?-->", "WITH":" ", "CONDITION":"ContentType='text/html'"}]
properties["bloomberg.com"] = [{"WHERE":"HEADERS", "WHAT":"content-type=text/html, text/html", "WITH":"content-type=text/html", "CONDITION":"",
                                 "NAME":{"prefix":"Old_", "suffix":"_old"}}]
# properties["bloomberg.com"] = [{"WHERE":"HEADERS", "WHAT":"content-type=text/html, text/html", "WITH":"content-type=text/html", "CONDITION":""}]

siteProperties = {APP_CONSTS.REPLACE_PROP_NAME:properties}
logger.info("siteProperties:\n%s", varDump(siteProperties, stringifyType=0))

# # res = ContentEvaluator.executeSqlExpression(dbWrapper, siteId, sqlExpression)
# # logger.debug('res:' + str(res))
# # logger.debug("\n\n")
#
# logger.debug("contentData: %s", varDump(contentData))
# contentData = ContentEvaluator.executeReplace(dbWrapper, siteId, json, contentData)
# logger.debug("")
# logger.debug("contentData: %s", varDump(contentData))

logger.debug("Input response.rendered_unicode_content: %s", str(response.rendered_unicode_content))
response = ContentEvaluator.execute(siteProperties, dbWrapper, siteId, url, response)
logger.debug("Output response.rendered_unicode_content: %s", str(response.rendered_unicode_content))
# logger.debug("Output response.headers: %s", varDump(response.headers, stringifyType=0))
logger.debug("Output response.headers: %s", str(response.headers))

