#!/usr/bin/python
# coding: utf-8

import os
import glob
import base64
import logging
import ConfigParser
import datetime

from dc_crawler.CrawlerDataStorage import CrawlerDataStorage
from dc_crawler.HTTPHeaders import HTTPHeaders
from dc_crawler.DBTasksWrapper import DBTasksWrapper
import app.Consts as APP_CONSTS
from app.Utils import PathMaker
import dc.EventObjects as dc_event
import dc.Constants as DC_CONSTANTS


def getLogger():
  # create logger
  log = logging.getLogger()
  log.setLevel(logging.DEBUG)

  # create console handler and set level to debug
  ch = logging.StreamHandler()
  ch.setLevel(logging.DEBUG)

  # create formatter
  formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')

  # add formatter to ch
  ch.setFormatter(formatter)

  # add ch to logger
  log.addHandler(ch)

  return log


def getDBWrapper(configFileName, log=None):
  # variable for result
  ret = None
  try:
    configParser = ConfigParser.ConfigParser()
    configParser.read(configFileName)
    ret = DBTasksWrapper(configParser)
  except Exception, err:
    if log is not None:
      log.error(str(err))

  return ret


if __name__ == '__main__':
  retval = os.getcwd()
  os.chdir('..')
  logger = getLogger()

  # iniDirName = 'ini'
  iniDirName = 'ini_default'
  configName = '../' + iniDirName + '/db-task.ini'

  # # Test
  dbWrapper = getDBWrapper(configName, logger)

  responseHeader = ''
  siteId = "12345"
  urlMd5 = "54321"

  baseUrl = 'http://test.html'
  pubdate = datetime.datetime.now().strftime('%Y-%m-%d %H:%M:%S')

  # HTTPHeaders.addBaseUrlToHeader('', baseUrl)
  responseHeader = HTTPHeaders.addPubdateRssFeedToHeader(responseHeader, pubdate)
  responseHeader = HTTPHeaders.addPubdateRssRawToHeader(responseHeader, pubdate)

  urlPut_list = []
  putDict = {"data": base64.b64encode(responseHeader)}
  contentType = dc_event.Content.CONTENT_HEADERS_CONTENT
  urlPut_list.append(dc_event.URLPut(siteId, urlMd5, contentType, putDict))
  dbWrapper.putURLContent(urlPut_list)

  logger.debug("="*20)

  rawDataDir = '../data/dc_rdata'

  logger.debug("isdir: %s", str(os.path.isdir(rawDataDir)))

  headerContent = CrawlerDataStorage.getHeaderContent(rawDataDir, siteId, urlMd5, logger)
  logger.debug("headerContent:\n%s", str(headerContent))
#   headerFileDir = ''
#
#   crawlerDataStorage = CrawlerDataStorage(dbWrapper, logger)
#   headerContent = crawlerDataStorage.getHeaderContent(siteId, urlMd5)
#   logger.debug("headerContent:\n%s", str(headerContent))

