#!/usr/bin/python
# coding: utf-8

import logging

import app.Consts as APP_CONSTS
from dc_crawler.DetectModified import DetectModified
from dc_crawler.Fetcher import Response
from dc_crawler.Exceptions import NotModifiedException
import dc.EventObjects as dc_events


def getLogger():
  # create logger
  log = logging.getLogger('hce')
  log.setLevel(logging.DEBUG)

  # create console handler and set level to debug
  ch = logging.StreamHandler()
  ch.setLevel(logging.DEBUG)

  # create formatter
  formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(funcName)s - %(message)s')

  # add formatter to ch
  ch.setFormatter(formatter)

  # add ch to logger
  log.addHandler(ch)

  return log


if __name__ == '__main__':
  logger = getLogger()

  siteId = '0'
  url = 'https://test.html'
  dbWrapper = None

#   properties = {"mode":1, "algorithm":1, "behavior":1}
#   properties = {"url_mask":["https.*", "http.*"], "mode":0, "algorithm":1, "behavior":0}
  properties = [{"url_mask":["https.*", "http.*"], "mode":0, "algorithm":1, "behavior":0},
                {"url_mask":["http://test(.*)"], "mode":1, "algorithm":1, "behavior":3}]

  siteProperties = {APP_CONSTS.DETECT_MODIFIED:properties}
#   siteProperties = {}

  logger.info("Start...")

  detectModified = DetectModified(siteProperties, url)
  logger.debug("Created instance.")

  initialized = detectModified.isInitialized()
  logger.debug("initialized = %s", str(initialized))

  headers = {}
  urlObj = dc_events.URL(siteId='0', url=url)
  urlObj.lastModified = '1212'
  urlObj.eTag = 'qwqeerty'

  headers = detectModified.prepareRequest(urlObj, headers)

  method = detectModified.getHTTPMethod()
  logger.debug("method = %s", str(method))

  # # fetch URL
  response = Response()
  response.headers = {'etag':urlObj.eTag}
  try:
    DetectModified.checkModified(detectModified, response)  # throw exception

    needRepeat = detectModified.isNeedRepeatRequest()
    logger.debug("needRepeat = %s", str(needRepeat))
  except NotModifiedException, err:
    logger.debug("Caught exception: %s", str(err))

    httpCode, status, updateUDate = DetectModified.extractResult(siteId, url, dbWrapper, err.detectModified, err.response)
