#!/usr/bin/python
# coding: utf-8

import logging

from app.FiltersLogging import FiltersLogging
import app.Consts as APP_CONSTS


def getLogger():
  # create logger
  log = logging.getLogger(APP_CONSTS.LOGGER_NAME)
  log.setLevel(logging.DEBUG)

  # create console handler and set level to debug
  ch = logging.StreamHandler()
  ch.setLevel(logging.DEBUG)

  # create formatter
  formatter = logging.Formatter('%(asctime)s - %(levelname)s - %(message)s')

  # add formatter to ch
  ch.setFormatter(formatter)

  # add ch to logger
  log.addHandler(ch)

  return log


if __name__ == '__main__':

  logger = getLogger()

  properties = {"stages": [1, 2, 3], "file":"/tmp/filters_%SITE_MD5%.log"}
  properties = {"stages": [{"stage":1, "action":1, "urlMask":"http://.*"}, 2, 3], "file":"/tmp/filters_%SITE_MD5%_%STAGE%.log"}
#   [{"type":1, "urlMask":"http://.*"}, ...]

  logger.info("properties: %s", str(properties))
  siteProperties = {APP_CONSTS.FILTERS_LOG:properties}
  logger.info("siteProperties: %s", str(siteProperties))

  url = 'http://test/index.html'
  siteId = '00000TestSiteID00000'

  logger.info("Test started...")
  FiltersLogging.addLog(siteProperties, url, siteId, stage=1, action=1, pattern='re_pattern_value', log=logger)
  logger.info("Test finished...")
