#!/usr/bin/python
# coding: utf-8

import os
import sys
import json
import logging
import requests

from dc_crawler.HTMLCanonicalRedirect import HTMLCanonicalRedirect
from app.Utils import varDump
from app.Utils import parseHost
import app.Consts as APP_CONSTS


def getLogger():
  # create logger
  logger = logging.getLogger(APP_CONSTS.LOGGER_NAME)
  logger.setLevel(logging.DEBUG)

  # create console handler and set level to debug
  ch = logging.StreamHandler()
  ch.setLevel(logging.DEBUG)

  # create formatter
  formatter = logging.Formatter('%(asctime)s - %(name)s - %(funcName)s - %(levelname)s - %(message)s')

  # add formatter to ch
  ch.setFormatter(formatter)

  # add ch to logger
  logger.addHandler(ch)

  return logger


def getRawContent(url, log):
  #variable for result
  ret = None
  try:
    ret = requests.get(url).content
    log.debug("rawContent len =  %s", str(len(ret)))

  except Exception, err:
    log.error(str(err))

  return ret
  

def testExecution(rawContent, property, url, log):
  log.debug("Input property: %s", str(property))

  canonicalRedirectUrl = HTMLCanonicalRedirect.extract(rawContent, property, url, log)
  log.debug("Extracted url: %s", str(canonicalRedirectUrl))


if __name__ == '__main__':

  rawContentBuffer = '<meta name="lastupdate" content="2018-02-05 13:53:28">'\
                      '<meta name="mainichi:art-type" content="all">'\
                      '<meta name="mixi-check-robots" content="noimage">'\
                      '<meta name="robots" content="noarchive"><link rel="canonical" href="http://mainichi.jp/senkyo/articles/20180205/k00/00e/010/137000c">'

  logger = getLogger()

  url = 'https://mainichi.jp/senkyo/articles/20180205/k00/00e/010/137000c'

  properties = []

  properties.append({"domain":".*bad_domain/.*", "state":0})
  properties.append({"domain":".*mainichi.jp.*", "state":0})
  properties.append({"domain":".*mainichi.jp.*", "state":1})

  properties.append([{"domain":".*bad_domain/.*", "state":0}])
  properties.append([{"domain":".*mainichi.jp.*", "state":0}])
  properties.append([{"domain":".*mainichi.jp.*", "state":1}])

  # rawContent = getRawContent(url, logger)
  rawContent = rawContentBuffer

  for property in properties:
    testExecution(rawContent, property, url, logger)
