#!/usr/bin/python
# coding: utf-8

import logging
import lxml.etree

from dc_crawler.HTMLRecover import HTMLRecover
from dc_crawler.ResourceProcess import ResourceProcess
import app.Consts as APP_CONSTS

def getLogger():
  # create logger
  log = logging.getLogger()
  log.setLevel(logging.DEBUG)

  # create console handler and set level to debug
  ch = logging.StreamHandler()
  ch.setLevel(logging.DEBUG)

  # create formatter
  formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')

  # add formatter to ch
  ch.setFormatter(formatter)

  # add ch to logger
  log.addHandler(ch)

  return log


if __name__ == '__main__':

  logger = getLogger()

#   siteProperties = {APP_CONSTS.HTML_RECOVER:0}
#   siteProperties = {APP_CONSTS.HTML_RECOVER:1}
  siteProperties = {APP_CONSTS.HTML_RECOVER:2}
  htmlContent = "<html><body></body></html>"
  charset = 'utf-8'

  parser = lxml.etree.HTMLParser(encoding=ResourceProcess.DEFAULT_CHARSET)  # pylint: disable=E1101
  res = HTMLRecover.execute(siteProperties=siteProperties, htmlContent=htmlContent, charset=charset, log=logger, parser=parser, parserFailed=True)
  logger.debug("res: %s", str(res))
