#!/usr/bin/python
# coding: utf-8

import logging
import requests

import app.Consts as APP_CONSTS
import app.Utils as Utils
from dc_crawler.HTMLRedirectResolver import HTMLRedirectResolver


def getLogger():
  # create logger
  log = logging.getLogger(APP_CONSTS.LOGGER_NAME)
  log.setLevel(logging.DEBUG)

  # create console handler and set level to debug
  ch = logging.StreamHandler()
  ch.setLevel(logging.DEBUG)

  # create formatter
  formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')

  # add formatter to ch
  ch.setFormatter(formatter)

  # add ch to logger
  log.addHandler(ch)

  return log


if __name__ == '__main__':

  logger = getLogger()

  siteProperties = {APP_CONSTS.HTML_REDIRECTS_MAX:5}

  url = 'http://127.0.0.1/html_redirect/index1.html'
  try:
    res = requests.get(url)
    logger.debug("status_code = %s", str(res.status_code))

    resUrl = HTMLRedirectResolver.extractURL(res.url, res.content, logger)
    logger.debug("Result URL: %s", str(resUrl))

  except Exception, err:
    logger.error("Error: %s", str(err))

  maxAllowedRedirects = HTMLRedirectResolver.getMaxAllowedRedirects(siteProperties, logger)
  logger.info("maxAllowedRedirects = %s", str(maxAllowedRedirects))

