#!/usr/bin/python
# coding: utf-8

import logging

from dc_crawler.HTTPCookieResolver import HTTPCookieResolver
import app.Consts as APP_CONSTS


def getLogger():
  # create logger
  log = logging.getLogger(APP_CONSTS.LOGGER_NAME)
  log.setLevel(logging.DEBUG)

  # create console handler and set level to debug
  ch = logging.StreamHandler()
  ch.setLevel(logging.DEBUG)

  # create formatter
  formatter = logging.Formatter('%(asctime)s - %(name)s - %(funcName)s - %(levelname)s - %(message)s')

  # add formatter to handler
  ch.setFormatter(formatter)

  # add ch to logger
  log.addHandler(ch)

  return log


if __name__ == '__main__':

  logger = getLogger()

  testUrl = 'http://www.nytimes.com/pages/realestate/index.html'

  properties = {"nytimes.com":{"stage":4, "storage":"/tmp/cookies"}}
  # properties = {"nytimes.com":{"stage":4, "storage":"/tmp/cookies", "static_file":"/tmp/cookies/crawler-task_cookies.txt"}}
  # properties = {".nytimes.com":{"stage":15, "debug":1, "accumulate":1, "storage":"/tmp/cookies", "cookie":"init_ck=hack42; LTMD=1; sc_mp=1; "}}
  properties = {".nytimes.com":{"stage":15, "debug":1, "accumulate":1, "storage":"/tmp/cookies"}}
  properties = {"nytimes.com":{"stage":15, "cookie":{"127.0.1.1":"RMID=007f010026e957ee843f0147"}}}

#   siteId = '0'
  siteId = '01234567890123456789'

  cookieResolver = HTTPCookieResolver(properties, siteId)
#   logger.info('is debug: ' + str(cookieResolver.isDebug(testUrl)))
#   logger.info('is accumulate: ' + str(cookieResolver.isAccumulate(testUrl)))
#
#   cookieResolver.addCookie(siteId, 'http://www.nytimes.com/pages/realestate', 'ng=12345')
#   cookieResolver.addCookie(siteId, 'http://www.nytimes.com/pages', 'st=54321')
  cookie = cookieResolver.getCookie(siteId, testUrl, stage=4)
  logger.debug('cookie: ' + str(cookie))
#   logger.info('*' * 20)
#   cookieResolver.loadStorage(siteId, testUrl)
#   cookieResolver.addCookie(siteId, 'http://www.nytimes.com/', 'xqf=67')
#   cookieResolver.saveStorage(siteId, testUrl)
#   logger.info('*' * 20)
#   cookieResolver = HTTPCookieResolver(properties, siteId)
#   cookieResolver.loadStorage(siteId, testUrl)
#   cookie = cookieResolver.getCookie(siteId, testUrl, stage=4)
#   logger.debug('cookie: ' + str(cookie))

