#!/usr/bin/python

import logging

from dc_crawler.MimeTypeExtractor import MimeTypeExtractor
from dc_crawler.CrawledResource import CrawledResource
import dc.EventObjects as dc_event

from app.Utils import varDump


def getLogger():
  # create logger
  log = logging.getLogger()
  log.setLevel(logging.DEBUG)

  # create console handler and set level to debug
  ch = logging.StreamHandler()
  ch.setLevel(logging.DEBUG)

  # create formatter
  formatter = logging.Formatter('%(asctime)s - %(levelname)s - %(message)s')

  # add formatter to ch
  ch.setFormatter(formatter)

  # add ch to logger
  log.addHandler(ch)

  return log


logger = getLogger()

# url = 'http://javascript:void(0);/'
url = 'http://feeds.afpbb.com/rss/afpbb/afpbbnews'
url = 'http://mainichi.jp/rss/etc/opinion.rss'
urlObj = dc_event.URL(siteId='0', url=url)
urlObj.parentMd5 = ''
urlObj.type = dc_event.URL.TYPE_SINGLE

crawledResource = CrawledResource()
crawledResource.binary_content = '<!DOCTYPE html><html><body></body></html>'
crawledResource.content_type = 'text/html'

propertyDict = {}
propertyDict['url_expression'] = '(.*)feeds.afpbb.com/rss/afpbb/afpbbnews(.*)'
propertyDict['mode'] = 2
propertyDict['url_types'] = [1]
propertyDict['url_parent'] = [0]
propertyDict['content_types'] = ["text/xml", "text/xml", "application/rss+xml"]

siteProperties = {'MIME_TYPE_AUTO_DETECT':[propertyDict, {'url_parent':[0]}]}

# #[{"url_expression":"(.*)feeds.afpbb.com/rss/afpbb/afpbbnews(.*)", "mode":2, "url_types":[1], "url_parent":[0], "content_types":["text/xml", "text/xml", "application/rss+xml"]}]

logger.debug("Start...")
logger.debug("siteProperties: %s", varDump(siteProperties))  # , stringifyType=0))

# res = MimeTypeExtractor.detect(crawledResource, contentTypeMap=None, log=logger)
res = MimeTypeExtractor.extract(crawledResource, siteProperties, urlObj, logger)
logger.debug("res: %s", str(res))

# contentType = MimeTypeExtractor.extractUrlMime(url, siteProperties, log=logger, default=None)
# logger.debug("contentType = '%s'", str(contentType))
