#!/usr/bin/python
# coding: utf-8

import os
import sys
import json
import logging
from app.PDateSourceExpression import PDateSourceExpression
import app.Consts as APP_CONSTS


def getLogger():
  # create logger
  logger = logging.getLogger(APP_CONSTS.LOGGER_NAME)
  logger.setLevel(logging.DEBUG)

  # create console handler and set level to debug
  ch = logging.StreamHandler()
  ch.setLevel(logging.DEBUG)

  # create formatter
  formatter = logging.Formatter('%(asctime)s - %(name)s - %(funcName)s - %(levelname)s - %(message)s')

  # add formatter to ch
  ch.setFormatter(formatter)

  # add ch to logger
  logger.addHandler(ch)

  return logger


def testExecution(property, siteId, urlMd5, url, log):
  log.debug("Input property: %s", str(property))

  sqlExpression = PDateSourceExpression.loadProperty(property, url, log)
  log.debug("sql: %s", str(sqlExpression))
  query = PDateSourceExpression.makeSqlQuery(sql=sqlExpression, log=log, url=url, siteId=siteId, urlMd5=urlMd5)
  log.debug("query: %s", str(query))
  log.debug("="*50)


if __name__ == '__main__':

  logger = getLogger()

  url = 'http://bbc.com/dir1/index.html'

  siteId = '0d0c6535ac4aa83efbbbe90fccf00a16'
  urlMd5 = 'ac425fc1d05ff21abdb93b9ddcddf2b9'

  properties = []

  properties.append("NOW()")
  properties.append({"pattern": ".*bbc.com/dir1/.*", "sql": "NOW()"})
  properties.append({"pattern": ".*bbc.com/dir1/.*", "sql": "`CDate`"})
  properties.append("{\"pattern\": \".*bbc.com\/dir1\/.*\", \"sql\": \"`CDate`\"}")
  properties.append([{"pattern": ".*bbc.com/dir1/.*", "sql": "`CDate`"}])
  properties.append([{"pattern": ".*bbc.com/dir1/.*", "sql": "SELECT `CDate` FROM urls_%PROJECT_MD5% WHERE `URLMd5` = '%CURRENT_URLMD5%'"}])

  for property in properties:
    testExecution(property, siteId, urlMd5, url, logger)

