#!/usr/bin/python

import os
import sys
import json
import logging
import ConfigParser

from dc_crawler.DBTasksWrapper import DBTasksWrapper
from dc_crawler.RefererHeaderResolver import RefererHeaderResolver
from app.Utils import varDump
import app.Consts as APP_CONSTS


def getLogger():
  # create logger
  log = logging.getLogger('hce')
  log.setLevel(logging.DEBUG)

  # create console handler and set level to debug
  ch = logging.StreamHandler()
  ch.setLevel(logging.DEBUG)

  # create formatter
  formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')

  # add formatter to ch
  ch.setFormatter(formatter)

  # add ch to logger
  log.addHandler(ch)

  return log


def getDBWrapper(configFileName):
  # variable for result
  ret = None
  try:
    configParser = ConfigParser.ConfigParser()
    configParser.read(configFileName)
    ret = DBTasksWrapper(configParser)
  except Exception, err:
    sys.stderr.write(str(err) + '\n')

  return ret


if __name__ == '__main__':
  logger = getLogger()

  configFile = '../../ini_default/db-task.ini'
  dbWrapper = getDBWrapper(configFile)
  logger.info("dbWrapper: %s", varDump(dbWrapper))

  propertyValue = [[["ft.com", "www.ft.com"], "1"], ["nbc.com", 3], ["*", 0]]
  siteProperties = {APP_CONSTS.REFERER_SELF_URL: json.dumps(propertyValue)}
  logger.info("Test started...")
  headers = {}

  url = 'http://127.0.0.1/template_scraping/index1.html/'
  url = 'https://nbc.com/template_scraping/index1.html/'
  siteId = '0'

#   propertyValue = [[["ft.com", "www.ft.com"], "1"], ["nbc.com", 1], ["*", 0]]
#   modeNumber = RefererHeaderResolver.getModeNumber(propertyValue, url, logger)
#   logger.info("modeNumber: %s", varDump(modeNumber))

  RefererHeaderResolver.updateHeaders(siteProperties, headers, url, siteId, dbWrapper, logger)
  logger.info("headers: %s", varDump(headers))
