#!/usr/bin/python
# coding: utf-8

import os
import sys
import logging
import requests.exceptions

from dc_crawler.ResourceProcess import ResourceProcess
from dc_crawler.CrawledResource import CrawledResource
from dc_crawler.CollectURLsXPath import CollectURLsXPath

from app.Utils import varDump
import app.Consts as APP_CONSTS


def getLogger():
  # create logger
  logger = logging.getLogger(APP_CONSTS.LOGGER_NAME)
  logger.setLevel(logging.DEBUG)

  # create console handler and set level to debug
  ch = logging.StreamHandler()
  ch.setLevel(logging.DEBUG)

  # create formatter
  formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')

  # add formatter to ch
  ch.setFormatter(formatter)

  # add ch to logger
  logger.addHandler(ch)

  return logger


if __name__ == '__main__':

  logger = getLogger()

  siteProperties = {}
  # siteProperties[APP_CONSTS.COLLECT_URLS_XPATH_LIST] = {"sets": {".*": ["//li[@class='line']/a[contains(., '29')]"]}, "date_format":""}
  # siteProperties[APP_CONSTS.COLLECT_URLS_XPATH_LIST] = {"sets": {".*": ["//li[@class='line']/a[contains(., '29')]"]}, "date_format": "%Y-%m-%d %H:%M:%S"}
  siteProperties[APP_CONSTS.COLLECT_URLS_XPATH_LIST] = {"sets": {".*": ["//li[@class='line']/a[contains(., '%@DATE(+0)%')]"]}, "date_format": "%-d"}
  # siteProperties[APP_CONSTS.COLLECT_URLS_XPATH_LIST] = {"sets": {".*": ["//li[@class='line']/a[contains(., '%@DATE(+0)%')]"]}, "date_format": "%-d"}
  # siteProperties[APP_CONSTS.COLLECT_URLS_XPATH_LIST] = {"sets": {".*": ["//li[@class='line']/a[contains(., '%@DAY(+0)%')]"]}, "date_format": ""}
  urlSet = []
  url = 'https://www.tokyo-np.co.jp'

  filePath = './data/test1.html'

  rawContent = None
  with open(filePath, 'r') as f:
    rawContent = f.read()

    logger.debug("Read data from %s", str(filePath))
    logger.debug("%s", str(rawContent))

    crawledResource = CrawledResource()
    crawledResource.html_content = rawContent

    dom = ResourceProcess.getDom(siteProperties=siteProperties, crawledResource=crawledResource, log=logger)
    logger.debug("Dom: %s", str(dom))

    urlSet = CollectURLsXPath.execute(siteProperties=siteProperties, urlSet=urlSet, dom=dom, urlsXpathListFromConfig=None, url=url, log=logger)
    logger.debug("urlSet: %s", str(urlSet))

