#!/usr/bin/python
# coding: utf-8

import os
import logging
import ConfigParser
from dc_processor.SocialTask import SocialTask  # pylint: disable=F0401,E0611
import app.Consts as APP_CONSTS
from app.Utils import varDump
import app.Utils as Utils


def getLogger():
  # create logger
  log = logging.getLogger(APP_CONSTS.LOGGER_NAME)
  log.setLevel(logging.DEBUG)

  # create console handler and set level to debug
  ch = logging.StreamHandler()
  ch.setLevel(logging.DEBUG)

  # create formatter
  formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')

  # add formatter to ch
  ch.setFormatter(formatter)

  # add ch to logger
  log.addHandler(ch)

  return log


if __name__ == '__main__':
  retval = os.getcwd()
  os.chdir('..')

  logger = getLogger()

  configName = '../ini/social_task-rt.ini'
  
  res = SocialTask.MacroResult(urlMd5='12345', udate=SocialTask().getCurrentDatetime('UTC'))
  logger.debug("res: %s", varDump(res))

  logger.debug("res: %s", varDump(res.toDict(socialName='tw', allowedFields=None, replacementNames=None, log=logger), stringifyType=0))

#   self.macroResultData = SocialTask.MacroResult.MacroResultData()
#   self.macroResultDataRaw = SocialTask.MacroResult.MacroResultData()
#   self.urlMd5 = urlMd5
#   self.sentiment = sentiment
#   self.profile = profile
#   self.rawContent = rawContent
#   self.pw = pw

  os.chdir(retval)
    
