#!/usr/bin/python
# coding: utf-8
"""
HCE project, Python bindings, Crawler application.
Test for UrlNormalize class.

@package: ftests
@file ftest_UrlNormalize.py
@author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
@link: http://hierarchical-cluster-engine.com/
@copyright: Copyright &copy; 2017 IOIX Ukraine
@license: http://hierarchical-cluster-engine.com/license/
@since: 0.1
"""

import logging

import app.Consts as APP_CONSTS
from app.UrlNormalize import UrlNormalize


def getLogger():
  # create logger
  log = logging.getLogger()
  log.setLevel(logging.DEBUG)

  # create console handler and set level to debug
  ch = logging.StreamHandler()
  ch.setLevel(logging.DEBUG)

  # create formatter
  formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')

  # add formatter to ch
  ch.setFormatter(formatter)

  # add ch to logger
  log.addHandler(ch)

  return log


logger = getLogger()
logger.debug("Start...")

properties = {}
siteProperties = {APP_CONSTS.URL_NORMALIZE:properties}

baseUrl = "https://twitter.com/"
url = "https://twitter.com/intent/tweet?text=The Week in Pictures: A tsunami's power and a painful anniversary&via=nbcnews&url=https://www.nbcnews.com/slideshow/week-pictures-sept-27-oct-4-n917046&original_referer=https://www.nbcnews.com/slideshow/week-pictures-sept-27-oct-4-n917046"

# URL normalization
resUrl = UrlNormalize.execute(siteProperties=siteProperties, base=baseUrl, url=url, supportProtocols=None, log=logger)
logger.debug("resUrl: %s", str(resUrl))

