#!/usr/bin/python
# coding: utf-8
"""
HCE project, Python bindings, Crawler application.
FetcherType module tests.

@package: dc
@file FetcherType.py
@author Alexander Vybornyh <alexander.hce.cluster@gmail.com>
@link: http://hierarchical-cluster-engine.com/
@link: http://hierarchical-cluster-engine.com/
@copyright: Copyright &copy; 2013-2018 IOIX Ukraine
@license: http://hierarchical-cluster-engine.com/license/
@since: 0.1
"""

import logging
import os
import sys
import json

import app.Consts as APP_CONSTS
from dc_crawler.FetcherType import FetcherType


def getLogger():
  # create logger
  log = logging.getLogger(APP_CONSTS.LOGGER_NAME)
  log.setLevel(logging.DEBUG)

  # create console handler and set level to debug
  ch = logging.StreamHandler()
  ch.setLevel(logging.DEBUG)

  # create formatter
  formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(message)s')

  # add formatter to ch
  ch.setFormatter(formatter)

  # add ch to logger
  log.addHandler(ch)

  return log



if __name__ == "__main__":
  # create logger
  logger = getLogger()

  # test data
  url = "http://test.html"
  properties = json.dumps({".*test.*":2})

#   fetchResType = FetcherType.getFromProperty(properties, url, logger)
#   logger.debug("fetchResType: %s", str(fetchResType))

  properties = json.dumps({".*test.*":{"fetcher_type":2}})
  properties = json.dumps({".*test.*":{"fetcher_type":2, "fetcher_options":{"type":1, "remove_before_create":1}}})

  fetcherType = FetcherType(properties, logger)
  options = fetcherType.getFetcherTypeOptions(url)
  if options is not None:
    logger.debug("type: %s", str(options.type))
    logger.debug("options: %s", str(options.options))

