#!/usr/bin/python3
# coding: utf-8

"""
HCE project, Python bindings, Distributed Tasks Manager application.
Verify of social data checker main functional.

@package: tools
@file compare.py
@author Maksym Masalov <maximmasalov888@gmail.com>
@link: http://hierarchical-cluster-engine.com/
@copyright: Copyright &copy; 2013-2017 IOIX Ukraine
@license: http://hierarchical-cluster-engine.com/license/
@since: 0.1
"""

import argparse
import json


def create_parser():
    """Command line arguments"""

    parser = argparse.ArgumentParser()

    parser.add_argument('-f', metavar='--file', type=str, help='Name of the file')

    return parser.parse_args()


def change_settings(file_name):
    """Merge and filter scraper template settings in the file from argument"""

    with open(file_name, 'r') as f:
        json_data = json.load(f)

    for d in json_data:
        for i in json_data[d]:

            if i == 'content_encoded':
                if type(json_data[d][i]) == dict:
                    json_data[d][i] = json_data[d][i]['xpath']

            if i == 'pubdate':
                if type(json_data[d][i]) == dict:
                    json_data[d][i] = json_data[d][i]['xpath']

            if i == 'description':
                if type(json_data[d][i]) == dict:
                    json_data[d][i] = json_data[d][i]['xpath']

    file = json.dumps(json_data, ensure_ascii=False, indent=2).encode('utf8').decode('utf-8')

    return file


def main():
    parser = create_parser()

    if parser != '--help':
        if parser.f:
            result = change_settings(parser.f)
            print(result)

    # print(change_settings('scraper_template.txt'))


if __name__ == '__main__':
    main()
